CADNA software

Sorbonne Université
LIP6 Laboratory
PEQUAN Team

----------------------------------------------------------
Generated libraries:

This package generates libraries that enable one to use CADNA in a numerical code.
The following libraries can be created.
libcadnaC.a: optimized version of CADNA for C/C++ codes
libcadnaCdebug.a: version of CADNA for debugging in C/C++ codes
libcadnaOpenmpC.a: optimized version of CADNA for C/C++ codes that use OpenMP
libcadnaOpenmpCdebug.a: version of CADNA for debugging in C/C++ codes that use OpenMP
libcadnaMPIC.a: MPI extension for CADNA C/C++ codes
libcadnaMPICdebug.a: MPI extension for debugging in CADNA C/C++ codes
libcadnaMPICforOpenMP.a: MPI extension for CADNA C/C++ codes that use OpenMP
libcadnaMPICdebugforOpenMP.a: MPI extension for debugging in CADNA C/C++ codes that use OpenMP
libcadnaFortran.a: library to enable the use of CADNA in Fortran codes
libcadnaMPIFortran.a: MPI extension for CADNA Fortran codes


Examples are provided for each case in the following directories.
examplesC
examplesC_mpi
examplesC_mpiomp
examplesC_omp
examplesFortran
examplesFortran_mpi
----------------------------------------------------------
Installation:

The configure script automatically detects if CADNA versions compatible with OpenMP and MPI can be generated.
The m4 macro processor, that is used to this purpose, should be installed. 
To generate the Fortran version of CADNA, the  --enable-fortran option must be used when executing the configure script.
Examples of calls to the configure script are given below.

./configure CXX=YourC++Compiler 
./configure --prefix=TheInstallationDirectory
./configure CXX=YourC++Compiler  --prefix=TheInstallationDirectory 
./configure --prefix=`pwd` --enable-fortran

Macos 
Brew gcc/7.3.0_1 (gcc, g++, gfortran)
./configure --prefix=`pwd` CC=gcc-7 CXX=g++-7 --enable-fortran
./configure --prefix=`pwd` CC=clang CXX=clang++ OPENMP_CFLAGS="-I/usr/local/Cellar/libomp/5.0.1/include -Xclang -fopenmp" OPENMP_CXXFLAGS="-I/usr/local/Cellar/libomp/5.0.1/include -Xclang -fopenmp" OPENMP_LDFLAGS="-L/usr/local/Cellar/libomp/5.0.1/lib -lomp"
./configure --prefix=`pwd` CC=clang CXX=clang++ OPENMP_CFLAGS="-I/usr/local/Cellar/libomp/7.0.0/include -Xclang -fopenmp" OPENMP_CXXFLAGS="-I/usr/local/Cellar/libomp/7.0.0/include -Xclang -fopenmp" OPENMP_LDFLAGS="-L/usr/local/Cellar/libomp/7.0.0/lib -lomp"
On OSX gcc may be a wrapper for clang. In that case you can use:
./configure --prefix=`pwd` CC=clang CXX=clang++

With IBM compilers, both  -libmc++ and  -lstdc++ must be mentioned when you use CADNA in a Fortran code.
You can specify it with a configure command such as:  
./configure CC=xlc  CXX=xlc++ FC=xlf FCFLAGS="-L/The_Path_To_libmc++  -libmc++  -lstdc++ " --enable-fortran

To support the half precision with the half.hpp package use "enable-half-emulation".
Example:
./configure CXX=YourC++Compiler  --prefix=TheInstallationDirectory --enable-half-emulation

To support the half precision by the armv8.2 architecture which supports half-precision natively use "enable-half-native"
Example:
./configure CXX=YourC++Compiler  --prefix=TheInstallationDirectory --enable-half-native

To enable the use of FMA use "enable-fma"
Example:
./configure CXX=YourC++Compiler  --prefix=TheInstallationDirectory  --enable-fma

It might be interesting to use 2 shell variables to specify the compiler to be used with MPI:
export OMPI_CC=gcc-7
export OMPI_CXX=g++-7

Compilers are supposed to be 64-bit compilers, otherwise specify --enable-32bit   

After the execution of the configuration script, type:
make install

Then, to compile and execute some test examples, go to any example directory, and just do:
make clean 
make

----------------------------------------------------------
Restrictions:

- The configuration script supports clang, GNU compilers (g++, gfortran),
INTEL compilers (icpc, ifort), IBM compilers (xlc, xlf), and PGI compilers.

- This CADNA package cannot be used in Fortran codes OpenMP.

- With clang, the libcadnaOpenmpCdebug.a must be used for OpenMP C/C++ codes,
although the libcadnaOpenmpC.a library is also generated. 

- You should not compile CADNA in parallel because of the dependencies between CADNA source files.
To compile CADNA, do not use a command such as:
make -j NumberOfParallelProcesses

# FlexFloat

FlexFloat is a C library for the emulation of reduced-precision floating point types.

## Building FlexFloat

Required packages:
* CMake 3.1 or higher
* GCC 7.1 or higher

To build the library:
* Create a directory (denoted as "&lt;build_dir&gt;" in this document) where you want to put the generated Makefiles, project files as well the object files and output binaries and enter this location.
  For example: `cd flexfloat & mkdir build`

* Run `cmake  [<optional configuration parameters>] <path to the FlexFloat source directory>` (from "&lt;build_dir&gt;")
  For example: `cd build && cmake ..`
  [optional] Configuration parameters are:
  * -DCMAKE_BUILD_TYPE=Release\Debug (default: Release) - The release mode compiles sources with "-O3 -DNDEBUG" flags, while the debug mode uses "-O0 -g3" flags.
  * -DBUILD_TESTS=ON/OFF (default: ON) - Enable unit testing of FlexFloat
  * -DBUILD_EXAMPLES=ON/OFF (default: ON) - Build usage examples
  * -DDISABLE_ROUNDING=ON/OFF (default: OFF) - Disable the library support to IEEE rounding modes (truncation is always applied)
  * -DSINGLE_BACKEND=ON/OFF (default: OFF) - Use single-precision type (float) as a backend type instead of double precision
  * -DQUAD_BACKEND=ON/OFF (default: OFF) - Use quad-precision type (_Float128) as a backend type instead of float or double precision
  * -DENABLE_FLAGS=ON/OFF (default: OFF) - Enable support for floating-point exception flags
  * -DENABLE_STATS=ON/OFF (default: OFF) - Enable collection of statistics
  * -DENABLE_TRACKING=ON/OFF (default: OFF) - Enable track of error accumulation on program variables

* In the "&lt;build_dir&gt;"  directory execute `make`

* [optional] To executes the library tests, execute `make test` (note that this feature requires to enable the unit testing feature of the library)

## Base usage

To replace a floating-point type with a reduced-precision one, the native types used in the program must be replaced with `flexfloat_t`.
Before its first use each FlexFloat variable must be given an initial value for exponent and mantissa bit-widths (two unsigned integers) by invoking `ff_init` (e.g., 5 bits for the exponent and 10 bits for the mantissa characterize the IEEE 754 half-precision format.
Users can also (optionally) specify an initialization value expressed as a native C type using `ff_init_float` or `ff_init_double`.
Since an initialization value might not be exactly representable in a target type with a lower number of bits, it is typically rounded to its nearest representable value using the current rounding mode.
The FlexFloat API includes a set of functions to perform arithmetic operations involving operands of the same floating-point type, such as `ff_add` and `ff_mul`.
Arithmetic perations in the original source code must be replaced by function calls that implement equivalent functionality on top of the
emulated types.
See "flexfloat.h" for further details on the API.

The C++ wrapper provides a generic floating-point type by defining a template class (flexfloat&lt;e,m&gt;, e and m are exponent and mantissa bit-widths) and a set of auxiliary functions (useful for debugging and collecting statistics). This only requires users to replace original variable declarations with instantiations of this template class. No other part of the program needs modification since class methods include operator overloading.
See "flexfloat.hpp" for further details on the class methods.

Examples for the C API and for the C++ wrapper are provided in the "examples" folder (after building the executables are available in "&lt;build_dir&gt;/examples").

## Advanced features

Flexfloat includes basic support for floating-point exception flags. If enabled, operations on FlexFloat variables will raise floating-point exception flags within the floating-point environment. One notable limitation of this feature is that the overflow exception (`FE_OVERFLOW`) is no longer raised on infinity results after a divide-by-zero condition is detected (`FE_DIVBYZERO`). Flags can be cleared using `feclearexcept(FE_ALL_EXCEPT)` to restore correct overflow detection until the next singularity division.

FlexFloat allows a complete set of execution statistics related to FP types to be collected. The library API includes functions to start, stop and reset the collection of statistics, namely `ff_start_stats`, `ff_stop_stats` and `ff_clear_stats`. A report is generated by calling `ff_print_stats`, and it includes the number of arithmetic operations (grouped by operator name) and the number of casts (grouped by source+destination type pairs). This feature allows the evaluation of the overhead due to the casts that have been introduced in a transprecision scenario, where the type of computations can be assigned at a very fine grain level. An example of this feature can be found at “examples/example_stats.c”.

FlexFloat also provides an advanced feature to keep track of error accumulation. Activating this feature, library adopters (programmers or automatic tools) can retrieve the exact value of a computation stored in a variable (calling `ff_track_get_exact`) or its current error w.r.t. the exact value (calling `ff_track_get_error`) at any point of the program. In addition users can add a callback to a program variable (calling `ff_track_callback`), that is a function invoked at any update of the variable. This feature can be useful for different purposes, for instance it can be used to track which internal expression has more impact on the result quality or to study the evolution of the error over time. An example of variable tracking can be found at “examples/example_tracking.c”.

exampleMPI1.c and exampleMPI2.cc do the same computation.
exampleMPI1 is a C version
exampleMPI2 is a C++ version

make clean
make
mpirun -np 4 ./exampleMPI1
mpirun -np 4 ./exampleMPI1_cad
mpirun -np 4 ./exampleMPI2
mpirun -np 4 ./exampleMPI2_cad

exampleMPI1SendRecv.f90 is the Fortran conversion of ../examplesC_mpi/exampleMPI1.c
exampleMPI1SendRecv_cad.f90 is the Fortran conversion of ../examplesC_mpi/exampleMPI1_cad.cc
exampleMPI1Reduce_cad.f90 performs the same computation using MPI_Reduce

make clean
make
mpirun -np 4 ./exampleMPI1SendRecv
mpirun -np 4 ./exampleMPI1SendRecv_cad
mpirun -np 4 ./exampleMPI1Reduce_cad

You will find in this directory seven small numerical codes. For each
code, a classical version (using the classical floating-point
arithmetic) and a CADNA version (using Discrete Stochastic Arithmetic)
are presented.

To generate the binary codes of the examples, use the "make"
instruction or "make clean" to clean them.

============================
Brief description of the examples
============================

All examples are described in the documentation
(in the doc directory).

Example 1: A polynomial function of two variables 

Example 2: A second degree equation where the exact discriminant is
the null value.

Example 3: Computation of the discriminant of Hilbert's matrix of
dimension 11. All the pivots are also printed.

Example 4: Computation of a second order recurrent sequence.
From the instability report, "UNSTABLE DIVISION(S)" are generated by
divisions where the denominator is numerical noise.  Such operations
make the computed trajectory turn off the exact trajectory and then,
the estimation of accuracy is not possible any more.

Example 5: An algebraic equation solved by Newton's method. In
the ex5_cad.cc file, one can change the stopping criterion by moving
<= into < and try to explain the difference ... that leads to the
ex5_cad_opt.cc file.

Example 6: A linear system is solved using Gaussian elimination
with partial pivoting.

Example 7: Example created on purpose to make CADNA fail.
The same result r is computed for a number of iterations
chosen by the user. The exact result is 1.4E-10.
But in 1 case out of 4, CADNA estimates an incorrect accuracy.

!Copyright 2017 R. CARPENTIER, P. CORDE, F. JEZEQUEL, J.-L. LAMOTTE
!
!This file is part of CADNA.
!
!    CADNA is free software: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as
!    published by the Free Software Foundation, either version 3 of the
!    License, or (at your option) any later version.
!
!    CADNA is distributed in the hope that it will be useful, but WITHOUT
!    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
!    or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General
!    Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public
!    License along with CADNA. If not, see
!    <http://www.gnu.org/licenses/>.
!


! Module de surcharge des fonctions de précision




module cadna_prec
  use cadna_types
  implicit none




  interface precision
   module procedure precision_single_st
  end interface precision

  interface precision
   module procedure precision_double_st
  end interface precision

  interface range
   module procedure range_single_st
  end interface range

  interface range
   module procedure range_double_st
  end interface range

  interface epsilon
   module procedure epsilon_single_st
  end interface epsilon

  interface epsilon
   module procedure epsilon_double_st
  end interface epsilon

  interface spacing
   module procedure spacing_single_st
  end interface spacing

  interface spacing
   module procedure spacing_double_st
  end interface spacing

  interface nearest
   module procedure nearest_single_st
  end interface nearest

  interface nearest
   module procedure nearest_double_st
  end interface nearest




  interface precision
   module procedure precision_single_st_1D
  end interface precision

  interface precision
   module procedure precision_double_st_1D
  end interface precision

  interface precision
   module procedure precision_single_st_2D
  end interface precision

  interface precision
   module procedure precision_double_st_2D
  end interface precision

  interface precision
   module procedure precision_single_st_3D
  end interface precision

  interface precision
   module procedure precision_double_st_3D
  end interface precision

  interface precision
   module procedure precision_single_st_4D
  end interface precision

  interface precision
   module procedure precision_double_st_4D
  end interface precision

  interface precision
   module procedure precision_single_st_5D
  end interface precision

  interface precision
   module procedure precision_double_st_5D
  end interface precision

  interface precision
   module procedure precision_single_st_6D
  end interface precision

  interface precision
   module procedure precision_double_st_6D
  end interface precision

  interface precision
   module procedure precision_single_st_7D
  end interface precision

  interface precision
   module procedure precision_double_st_7D
  end interface precision

  interface range
   module procedure range_single_st_1D
  end interface range

  interface range
   module procedure range_double_st_1D
  end interface range

  interface range
   module procedure range_single_st_2D
  end interface range

  interface range
   module procedure range_double_st_2D
  end interface range

  interface range
   module procedure range_single_st_3D
  end interface range

  interface range
   module procedure range_double_st_3D
  end interface range

  interface range
   module procedure range_single_st_4D
  end interface range

  interface range
   module procedure range_double_st_4D
  end interface range

  interface range
   module procedure range_single_st_5D
  end interface range

  interface range
   module procedure range_double_st_5D
  end interface range

  interface range
   module procedure range_single_st_6D
  end interface range

  interface range
   module procedure range_double_st_6D
  end interface range

  interface range
   module procedure range_single_st_7D
  end interface range

  interface range
   module procedure range_double_st_7D
  end interface range


contains



  function precision_single_st(x )
     
    type(single_st), intent(in) :: x
     
    integer precision_single_st

    precision_single_st = precision((x%x+x%y+x%z)/3.)
  end function precision_single_st

  function precision_double_st(x )
     
    type(double_st), intent(in) :: x
     
    integer precision_double_st

    precision_double_st = precision((x%x+x%y+x%z)/3.)
  end function precision_double_st

  function range_single_st(x )
     
    type(single_st), intent(in) :: x
     
    integer range_single_st

    range_single_st = range((x%x+x%y+x%z)/3.)
  end function range_single_st

  function range_double_st(x )
     
    type(double_st), intent(in) :: x
     
    integer range_double_st

    range_double_st = range((x%x+x%y+x%z)/3.)
  end function range_double_st

  elemental function epsilon_single_st(x )
    use ISO_FORTRAN_ENV, only : REAL32
    type(single_st), intent(in) :: x
     
    real(kind=REAL32) epsilon_single_st

    epsilon_single_st = epsilon((x%x+x%y+x%z)/3.)
  end function epsilon_single_st

  elemental function epsilon_double_st(x )
    use ISO_FORTRAN_ENV, only : REAL64
    type(double_st), intent(in) :: x
     
    real(kind=REAL64) epsilon_double_st

    epsilon_double_st = epsilon((x%x+x%y+x%z)/3.)
  end function epsilon_double_st

  elemental function spacing_single_st(x )
    use ISO_FORTRAN_ENV, only : REAL32
    type(single_st), intent(in) :: x
     
    real(kind=REAL32) spacing_single_st

    spacing_single_st = spacing((x%x+x%y+x%z)/3.)
  end function spacing_single_st

  elemental function spacing_double_st(x )
    use ISO_FORTRAN_ENV, only : REAL64
    type(double_st), intent(in) :: x
     
    real(kind=REAL64) spacing_double_st

    spacing_double_st = spacing((x%x+x%y+x%z)/3.)
  end function spacing_double_st

  elemental function nearest_single_st(x ,s)
    use ISO_FORTRAN_ENV, only : REAL32
    type(single_st), intent(in) :: x
    real,            intent(in) :: s
    real(kind=REAL32) nearest_single_st

    nearest_single_st = nearest((x%x+x%y+x%z)/3.,s)
  end function nearest_single_st

  elemental function nearest_double_st(x ,s)
    use ISO_FORTRAN_ENV, only : REAL64
    type(double_st), intent(in) :: x
    real,            intent(in) :: s
    real(kind=REAL64) nearest_double_st

    nearest_double_st = nearest((x%x+x%y+x%z)/3.,s)
  end function nearest_double_st




  function precision_single_st_1D(x)
    type(single_st), dimension (:), intent(in), target, contiguous :: x
    type(single_st), dimension(:), pointer :: p_array
    integer precision_single_st_1D

    p_array(1:size(x)) => x
    precision_single_st_1D = precision((p_array(1)%x))
  end function precision_single_st_1D

  function precision_double_st_1D(x)
    type(double_st), dimension (:), intent(in), target, contiguous :: x
    type(double_st), dimension(:), pointer :: p_array
    integer precision_double_st_1D

    p_array(1:size(x)) => x
    precision_double_st_1D = precision((p_array(1)%x))
  end function precision_double_st_1D

  function precision_single_st_2D(x)
    type(single_st), dimension (:,:), intent(in), target, contiguous :: x
    type(single_st), dimension(:), pointer :: p_array
    integer precision_single_st_2D

    p_array(1:size(x)) => x
    precision_single_st_2D = precision((p_array(1)%x))
  end function precision_single_st_2D

  function precision_double_st_2D(x)
    type(double_st), dimension (:,:), intent(in), target, contiguous :: x
    type(double_st), dimension(:), pointer :: p_array
    integer precision_double_st_2D

    p_array(1:size(x)) => x
    precision_double_st_2D = precision((p_array(1)%x))
  end function precision_double_st_2D

  function precision_single_st_3D(x)
    type(single_st), dimension (:,:,:), intent(in), target, contiguous :: x
    type(single_st), dimension(:), pointer :: p_array
    integer precision_single_st_3D

    p_array(1:size(x)) => x
    precision_single_st_3D = precision((p_array(1)%x))
  end function precision_single_st_3D

  function precision_double_st_3D(x)
    type(double_st), dimension (:,:,:), intent(in), target, contiguous :: x
    type(double_st), dimension(:), pointer :: p_array
    integer precision_double_st_3D

    p_array(1:size(x)) => x
    precision_double_st_3D = precision((p_array(1)%x))
  end function precision_double_st_3D

  function precision_single_st_4D(x)
    type(single_st), dimension (:,:,:,:), intent(in), target, contiguous :: x
    type(single_st), dimension(:), pointer :: p_array
    integer precision_single_st_4D

    p_array(1:size(x)) => x
    precision_single_st_4D = precision((p_array(1)%x))
  end function precision_single_st_4D

  function precision_double_st_4D(x)
    type(double_st), dimension (:,:,:,:), intent(in), target, contiguous :: x
    type(double_st), dimension(:), pointer :: p_array
    integer precision_double_st_4D

    p_array(1:size(x)) => x
    precision_double_st_4D = precision((p_array(1)%x))
  end function precision_double_st_4D

  function precision_single_st_5D(x)
    type(single_st), dimension (:,:,:,:,:), intent(in), target, contiguous :: x
    type(single_st), dimension(:), pointer :: p_array
    integer precision_single_st_5D

    p_array(1:size(x)) => x
    precision_single_st_5D = precision((p_array(1)%x))
  end function precision_single_st_5D

  function precision_double_st_5D(x)
    type(double_st), dimension (:,:,:,:,:), intent(in), target, contiguous :: x
    type(double_st), dimension(:), pointer :: p_array
    integer precision_double_st_5D

    p_array(1:size(x)) => x
    precision_double_st_5D = precision((p_array(1)%x))
  end function precision_double_st_5D

  function precision_single_st_6D(x)
    type(single_st), dimension (:,:,:,:,:,:), intent(in), target, contiguous :: x
    type(single_st), dimension(:), pointer :: p_array
    integer precision_single_st_6D

    p_array(1:size(x)) => x
    precision_single_st_6D = precision((p_array(1)%x))
  end function precision_single_st_6D

  function precision_double_st_6D(x)
    type(double_st), dimension (:,:,:,:,:,:), intent(in), target, contiguous :: x
    type(double_st), dimension(:), pointer :: p_array
    integer precision_double_st_6D

    p_array(1:size(x)) => x
    precision_double_st_6D = precision((p_array(1)%x))
  end function precision_double_st_6D

  function precision_single_st_7D(x)
    type(single_st), dimension (:,:,:,:,:,:,:), intent(in), target, contiguous :: x
    type(single_st), dimension(:), pointer :: p_array
    integer precision_single_st_7D

    p_array(1:size(x)) => x
    precision_single_st_7D = precision((p_array(1)%x))
  end function precision_single_st_7D

  function precision_double_st_7D(x)
    type(double_st), dimension (:,:,:,:,:,:,:), intent(in), target, contiguous :: x
    type(double_st), dimension(:), pointer :: p_array
    integer precision_double_st_7D

    p_array(1:size(x)) => x
    precision_double_st_7D = precision((p_array(1)%x))
  end function precision_double_st_7D

  function range_single_st_1D(x)
    type(single_st), dimension (:), intent(in), target, contiguous :: x
    type(single_st), dimension(:), pointer :: p_array
    integer range_single_st_1D

    p_array(1:size(x)) => x
    range_single_st_1D = range((p_array(1)%x))
  end function range_single_st_1D

  function range_double_st_1D(x)
    type(double_st), dimension (:), intent(in), target, contiguous :: x
    type(double_st), dimension(:), pointer :: p_array
    integer range_double_st_1D

    p_array(1:size(x)) => x
    range_double_st_1D = range((p_array(1)%x))
  end function range_double_st_1D

  function range_single_st_2D(x)
    type(single_st), dimension (:,:), intent(in), target, contiguous :: x
    type(single_st), dimension(:), pointer :: p_array
    integer range_single_st_2D

    p_array(1:size(x)) => x
    range_single_st_2D = range((p_array(1)%x))
  end function range_single_st_2D

  function range_double_st_2D(x)
    type(double_st), dimension (:,:), intent(in), target, contiguous :: x
    type(double_st), dimension(:), pointer :: p_array
    integer range_double_st_2D

    p_array(1:size(x)) => x
    range_double_st_2D = range((p_array(1)%x))
  end function range_double_st_2D

  function range_single_st_3D(x)
    type(single_st), dimension (:,:,:), intent(in), target, contiguous :: x
    type(single_st), dimension(:), pointer :: p_array
    integer range_single_st_3D

    p_array(1:size(x)) => x
    range_single_st_3D = range((p_array(1)%x))
  end function range_single_st_3D

  function range_double_st_3D(x)
    type(double_st), dimension (:,:,:), intent(in), target, contiguous :: x
    type(double_st), dimension(:), pointer :: p_array
    integer range_double_st_3D

    p_array(1:size(x)) => x
    range_double_st_3D = range((p_array(1)%x))
  end function range_double_st_3D

  function range_single_st_4D(x)
    type(single_st), dimension (:,:,:,:), intent(in), target, contiguous :: x
    type(single_st), dimension(:), pointer :: p_array
    integer range_single_st_4D

    p_array(1:size(x)) => x
    range_single_st_4D = range((p_array(1)%x))
  end function range_single_st_4D

  function range_double_st_4D(x)
    type(double_st), dimension (:,:,:,:), intent(in), target, contiguous :: x
    type(double_st), dimension(:), pointer :: p_array
    integer range_double_st_4D

    p_array(1:size(x)) => x
    range_double_st_4D = range((p_array(1)%x))
  end function range_double_st_4D

  function range_single_st_5D(x)
    type(single_st), dimension (:,:,:,:,:), intent(in), target, contiguous :: x
    type(single_st), dimension(:), pointer :: p_array
    integer range_single_st_5D

    p_array(1:size(x)) => x
    range_single_st_5D = range((p_array(1)%x))
  end function range_single_st_5D

  function range_double_st_5D(x)
    type(double_st), dimension (:,:,:,:,:), intent(in), target, contiguous :: x
    type(double_st), dimension(:), pointer :: p_array
    integer range_double_st_5D

    p_array(1:size(x)) => x
    range_double_st_5D = range((p_array(1)%x))
  end function range_double_st_5D

  function range_single_st_6D(x)
    type(single_st), dimension (:,:,:,:,:,:), intent(in), target, contiguous :: x
    type(single_st), dimension(:), pointer :: p_array
    integer range_single_st_6D

    p_array(1:size(x)) => x
    range_single_st_6D = range((p_array(1)%x))
  end function range_single_st_6D

  function range_double_st_6D(x)
    type(double_st), dimension (:,:,:,:,:,:), intent(in), target, contiguous :: x
    type(double_st), dimension(:), pointer :: p_array
    integer range_double_st_6D

    p_array(1:size(x)) => x
    range_double_st_6D = range((p_array(1)%x))
  end function range_double_st_6D

  function range_single_st_7D(x)
    type(single_st), dimension (:,:,:,:,:,:,:), intent(in), target, contiguous :: x
    type(single_st), dimension(:), pointer :: p_array
    integer range_single_st_7D

    p_array(1:size(x)) => x
    range_single_st_7D = range((p_array(1)%x))
  end function range_single_st_7D

  function range_double_st_7D(x)
    type(double_st), dimension (:,:,:,:,:,:,:), intent(in), target, contiguous :: x
    type(double_st), dimension(:), pointer :: p_array
    integer range_double_st_7D

    p_array(1:size(x)) => x
    range_double_st_7D = range((p_array(1)%x))
  end function range_double_st_7D




end module cadna_prec

      program ex1
      implicit none
      double precision :: y,x,res
      print *,'Polynomial function of two variables without CADNA: '
      x=77617e0
      y=33096e0
      res=333.75*y*y*y*y*y*y+x*x*(11*x*x*y*y-y*y*y*y*y*y-121 &
     &    *y*y*y*y-2.0) &
     &  +5.5*y*y*y*y*y*y*y*y+x/(2*y)
      print *,'res = ',res
      end program ex1

!Copyright 2017 R. CARPENTIER, P. CORDE, F. JEZEQUEL, J.-L. LAMOTTE
!
!This file is part of CADNA.
!
!    CADNA is free software: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as
!    published by the Free Software Foundation, either version 3 of the
!    License, or (at your option) any later version.
!
!    CADNA is distributed in the hope that it will be useful, but WITHOUT
!    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
!    or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General
!    Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public
!    License along with CADNA. If not, see
!    <http://www.gnu.org/licenses/>.
!



! Module de surcharge de l'opérateur unaire "+"




module cadna_cmplx_plus
  use cadna_types
  use cadna_plus
  implicit none




  interface operator(+)
    module procedure plus_complex_single_st
  end interface operator(+)

  interface operator(+)
    module procedure plus_complex_double_st
  end interface operator(+)


contains



  elemental function plus_complex_single_st(a)
    type(complex_single_st), intent(in) :: a
    type(complex_single_st) plus_complex_single_st

    plus_complex_single_st%x = +a%x
    plus_complex_single_st%y = +a%y
  end function plus_complex_single_st

  elemental function plus_complex_double_st(a)
    type(complex_double_st), intent(in) :: a
    type(complex_double_st) plus_complex_double_st

    plus_complex_double_st%x = +a%x
    plus_complex_double_st%y = +a%y
  end function plus_complex_double_st




end module cadna_cmplx_plus

program exampleMPI1
  use ISO_FORTRAN_ENV, only : REAL64, OUTPUT_UNIT, ERROR_UNIT
  
  use mpi
  
  integer status(mpi_status_size)
  integer nb_procs, rank, code
  REAL(kind=REAL64) x, y
  REAL(kind=REAL64) res, tmp

  ! MPI Initialization
  call MPI_Init(code)
  call MPI_Comm_rank(MPI_COMM_WORLD, rank, code)
  call MPI_Comm_size(MPI_COMM_WORLD, nb_procs, code)

  if( rank == 0 ) then
     write( ERROR_UNIT, '(a)' ) "I am the Master"
     write( ERROR_UNIT, '(a)' ) "Computation with MPI without CADNA:"
  end if
  if( nb_procs /= 4 ) then
    if( rank == 0 ) write( ERROR_UNIT, '(a)' ) "4 processes are necessary"
    call MPI_Finalize(code)
    CALL MPI_ABORT ( MPI_COMM_WORLD, 4, code)
  end if
  
  x=10864.d0; y=18817.d0
  if ( rank /= 0 ) then
    select case(rank)
      case (1)
        res=9.d0*x*x*x*x
      case (2)
        res=- y*y*y*y
      case (3)
        res= 2.d0*y*y
    end select
    write( OUTPUT_UNIT, '(a, i0, a, e22.15)' ) "I am thread ", rank, " and I send ", res
    call MPI_Send( res, 1, MPI_DOUBLE_PRECISION, 0, 0, MPI_COMM_WORLD, code)
    
  else
    res=0.d0
    do i=1,3
      call MPI_Recv( tmp, 1, MPI_DOUBLE_PRECISION, MPI_ANY_SOURCE, 0, & 
                     MPI_COMM_WORLD, status, code)
      res = res + tmp
      write( OUTPUT_UNIT, '(a, e22.15)' ) "I have received ", tmp
    end do
    write( OUTPUT_UNIT, '(a, e22.15)' ) "Final result: ", res
    write( OUTPUT_UNIT, '(a)' )  "Exact result:  1.000000000000000e+00"
  end if
  
  call MPI_Finalize(code)
end program exampleMPI1

! Module de surcharge de l'opérateur "/"





module cadna_cmplx_div
  use ISO_C_BINDING, only : C_LONG_LONG, C_LONG, C_INT, C_SHORT, C_FLOAT, C_DOUBLE
  use ISO_FORTRAN_ENV, only : REAL32, REAL64
  use cadna_types
  use cadna_add
  use cadna_div
  use cadna_affect
  use cadna_pow
  use cadna_cmplx_mult
  use cadna_cmplx_convert
  implicit none




  interface operator(/)
    module procedure div_complex_double_st_complex_double_st
  end interface operator(/)

  interface operator(/)
    module procedure div_complex_double_st_complex_single_st
  end interface operator(/)

  interface operator(/)
    module procedure div_complex_double_st_double_st
  end interface operator(/)

  interface operator(/)
    module procedure div_complex_double_st_single_st
  end interface operator(/)

  interface operator(/)
    module procedure div_complex_double_st_complex_float
  end interface operator(/)

  interface operator(/)
    module procedure div_complex_double_st_complex_double
  end interface operator(/)

  interface operator(/)
    module procedure div_complex_double_st_double
  end interface operator(/)

  interface operator(/)
    module procedure div_complex_double_st_float
  end interface operator(/)

  interface operator(/)
    module procedure div_complex_double_st_long_long
  end interface operator(/)

!INTERFACE_OP(/, div, complex_double_st, long)
  interface operator(/)
    module procedure div_complex_double_st_int
  end interface operator(/)

  interface operator(/)
    module procedure div_complex_double_st_short
  end interface operator(/)

!
  interface operator(/)
    module procedure div_complex_single_st_complex_double_st
  end interface operator(/)

  interface operator(/)
    module procedure div_complex_single_st_complex_single_st
  end interface operator(/)

  interface operator(/)
    module procedure div_complex_single_st_double_st
  end interface operator(/)

  interface operator(/)
    module procedure div_complex_single_st_single_st
  end interface operator(/)

  interface operator(/)
    module procedure div_complex_single_st_complex_float
  end interface operator(/)

  interface operator(/)
    module procedure div_complex_single_st_complex_double
  end interface operator(/)

  interface operator(/)
    module procedure div_complex_single_st_double
  end interface operator(/)

  interface operator(/)
    module procedure div_complex_single_st_float
  end interface operator(/)

  interface operator(/)
    module procedure div_complex_single_st_long_long
  end interface operator(/)

!INTERFACE_OP(/, div, complex_single_st, long)
  interface operator(/)
    module procedure div_complex_single_st_int
  end interface operator(/)

  interface operator(/)
    module procedure div_complex_single_st_short
  end interface operator(/)

!
  interface operator(/)
    module procedure div_single_st_complex_double_st
  end interface operator(/)

  interface operator(/)
    module procedure div_single_st_complex_single_st
  end interface operator(/)


  interface operator(/)
    module procedure div_double_st_complex_double_st
  end interface operator(/)

  interface operator(/)
    module procedure div_double_st_complex_single_st
  end interface operator(/)


  interface operator(/)
    module procedure div_complex_float_complex_single_st
  end interface operator(/)

  interface operator(/)
    module procedure div_complex_float_complex_double_st
  end interface operator(/)


  interface operator(/)
    module procedure div_complex_double_complex_single_st
  end interface operator(/)

  interface operator(/)
    module procedure div_complex_double_complex_double_st
  end interface operator(/)


  interface operator(/)
    module procedure div_double_complex_double_st
  end interface operator(/)

  interface operator(/)
    module procedure div_double_complex_single_st
  end interface operator(/)

!
  interface operator(/)
    module procedure div_float_complex_double_st
  end interface operator(/)

  interface operator(/)
    module procedure div_float_complex_single_st
  end interface operator(/)

!
  interface operator(/)
    module procedure div_long_long_complex_double_st
  end interface operator(/)

  interface operator(/)
    module procedure div_long_long_complex_single_st
  end interface operator(/)

!
!INTERFACE_OP(/, div, long,              complex_double_st)
!INTERFACE_OP(/, div, long,              complex_single_st)
!
  interface operator(/)
    module procedure div_int_complex_double_st
  end interface operator(/)

  interface operator(/)
    module procedure div_int_complex_single_st
  end interface operator(/)

!
  interface operator(/)
    module procedure div_short_complex_double_st
  end interface operator(/)

  interface operator(/)
    module procedure div_short_complex_single_st
  end interface operator(/)


contains



  elemental function div_complex_double_st_complex_double_st(a, b)
    type(complex_double_st), intent(in) :: a
    type(complex_double_st), intent(in) :: b
    type(complex_double_st) div_complex_double_st_complex_double_st
    ! Local declarations
    type(double_st) norme2

    norme2 = b%x**2 + b%y**2
    div_complex_double_st_complex_double_st = a*conjg(b)/norme2
  end function div_complex_double_st_complex_double_st

  elemental function div_complex_double_st_complex_single_st(a, b)
    type(complex_double_st), intent(in) :: a
    type(complex_single_st), intent(in) :: b
    type(complex_double_st) div_complex_double_st_complex_single_st
    ! Local declarations
    type(double_st) norme2

    norme2 = b%x**2 + b%y**2
    div_complex_double_st_complex_single_st = a*conjg(b)/norme2
  end function div_complex_double_st_complex_single_st

  elemental function div_complex_double_st_double_st(a, b)
    type(complex_double_st), intent(in) :: a
    type(double_st), intent(in) :: b
    type(complex_double_st) div_complex_double_st_double_st
    ! Local declarations
    

    div_complex_double_st_double_st%x = a%x/b
    div_complex_double_st_double_st%y = a%y/b
  end function div_complex_double_st_double_st

  elemental function div_complex_double_st_single_st(a, b)
    type(complex_double_st), intent(in) :: a
    type(single_st), intent(in) :: b
    type(complex_double_st) div_complex_double_st_single_st
    ! Local declarations
    

    div_complex_double_st_single_st%x = a%x/b
    div_complex_double_st_single_st%y = a%y/b
  end function div_complex_double_st_single_st

  elemental function div_complex_double_st_complex_float(a, b)
    type(complex_double_st), intent(in) :: a
    complex(REAL32), intent(in) :: b
    type(complex_double_st) div_complex_double_st_complex_float
    ! Local declarations
    real(REAL32) norme2

    norme2 = real(b)**2 + aimag(b)**2
    div_complex_double_st_complex_float = a*conjg(b)/norme2
  end function div_complex_double_st_complex_float

  elemental function div_complex_double_st_complex_double(a, b)
    type(complex_double_st), intent(in) :: a
    complex(REAL64), intent(in) :: b
    type(complex_double_st) div_complex_double_st_complex_double
    ! Local declarations
    real(REAL64) norme2

    norme2 = real(b)**2 + aimag(b)**2
    div_complex_double_st_complex_double = a*conjg(b)/norme2
  end function div_complex_double_st_complex_double

  elemental function div_complex_double_st_double(a, b)
    type(complex_double_st), intent(in) :: a
    real(C_DOUBLE), intent(in) :: b
    type(complex_double_st) div_complex_double_st_double
    ! Local declarations
    

    div_complex_double_st_double%x = a%x/b
    div_complex_double_st_double%y = a%y/b
  end function div_complex_double_st_double

  elemental function div_complex_double_st_float(a, b)
    type(complex_double_st), intent(in) :: a
    real(C_FLOAT), intent(in) :: b
    type(complex_double_st) div_complex_double_st_float
    ! Local declarations
    

    div_complex_double_st_float%x = a%x/b
    div_complex_double_st_float%y = a%y/b
  end function div_complex_double_st_float

  elemental function div_complex_double_st_long_long(a, b)
    type(complex_double_st), intent(in) :: a
    integer(C_LONG_LONG), intent(in) :: b
    type(complex_double_st) div_complex_double_st_long_long
    ! Local declarations
    

    div_complex_double_st_long_long%x = a%x/b
    div_complex_double_st_long_long%y = a%y/b
  end function div_complex_double_st_long_long

!CONTAINS_OP(div, complex_double_st, long,              complex_double_st)
  elemental function div_complex_double_st_int(a, b)
    type(complex_double_st), intent(in) :: a
    integer(C_INT), intent(in) :: b
    type(complex_double_st) div_complex_double_st_int
    ! Local declarations
    

    div_complex_double_st_int%x = a%x/b
    div_complex_double_st_int%y = a%y/b
  end function div_complex_double_st_int

  elemental function div_complex_double_st_short(a, b)
    type(complex_double_st), intent(in) :: a
    integer(C_SHORT), intent(in) :: b
    type(complex_double_st) div_complex_double_st_short
    ! Local declarations
    

    div_complex_double_st_short%x = a%x/b
    div_complex_double_st_short%y = a%y/b
  end function div_complex_double_st_short

!
  elemental function div_complex_single_st_complex_double_st(a, b)
    type(complex_single_st), intent(in) :: a
    type(complex_double_st), intent(in) :: b
    type(complex_double_st) div_complex_single_st_complex_double_st
    ! Local declarations
    type(double_st) norme2

    norme2 = b%x**2 + b%y**2
    div_complex_single_st_complex_double_st = a*conjg(b)/norme2
  end function div_complex_single_st_complex_double_st

  elemental function div_complex_single_st_complex_single_st(a, b)
    type(complex_single_st), intent(in) :: a
    type(complex_single_st), intent(in) :: b
    type(complex_single_st) div_complex_single_st_complex_single_st
    ! Local declarations
    type(single_st) norme2

    norme2 = b%x**2 + b%y**2
    div_complex_single_st_complex_single_st = a*conjg(b)/norme2
  end function div_complex_single_st_complex_single_st

  elemental function div_complex_single_st_double_st(a, b)
    type(complex_single_st), intent(in) :: a
    type(double_st), intent(in) :: b
    type(complex_double_st) div_complex_single_st_double_st
    ! Local declarations
    

    div_complex_single_st_double_st%x = a%x/b
    div_complex_single_st_double_st%y = a%y/b
  end function div_complex_single_st_double_st

  elemental function div_complex_single_st_single_st(a, b)
    type(complex_single_st), intent(in) :: a
    type(single_st), intent(in) :: b
    type(complex_single_st) div_complex_single_st_single_st
    ! Local declarations
    

    div_complex_single_st_single_st%x = a%x/b
    div_complex_single_st_single_st%y = a%y/b
  end function div_complex_single_st_single_st

  elemental function div_complex_single_st_complex_float(a, b)
    type(complex_single_st), intent(in) :: a
    complex(REAL32), intent(in) :: b
    type(complex_single_st) div_complex_single_st_complex_float
    ! Local declarations
    real(REAL32) norme2

    norme2 = real(b)**2 + aimag(b)**2
    div_complex_single_st_complex_float = a*conjg(b)/norme2
  end function div_complex_single_st_complex_float

  elemental function div_complex_single_st_complex_double(a, b)
    type(complex_single_st), intent(in) :: a
    complex(REAL64), intent(in) :: b
    type(complex_single_st) div_complex_single_st_complex_double
    ! Local declarations
    real(REAL64) norme2

    norme2 = real(b)**2 + aimag(b)**2
    div_complex_single_st_complex_double = a*conjg(b)/norme2
  end function div_complex_single_st_complex_double

  elemental function div_complex_single_st_double(a, b)
    type(complex_single_st), intent(in) :: a
    real(C_DOUBLE), intent(in) :: b
    type(complex_single_st) div_complex_single_st_double
    ! Local declarations
    

    div_complex_single_st_double%x = a%x/b
    div_complex_single_st_double%y = a%y/b
  end function div_complex_single_st_double

  elemental function div_complex_single_st_float(a, b)
    type(complex_single_st), intent(in) :: a
    real(C_FLOAT), intent(in) :: b
    type(complex_single_st) div_complex_single_st_float
    ! Local declarations
    

    div_complex_single_st_float%x = a%x/b
    div_complex_single_st_float%y = a%y/b
  end function div_complex_single_st_float

  elemental function div_complex_single_st_long_long(a, b)
    type(complex_single_st), intent(in) :: a
    integer(C_LONG_LONG), intent(in) :: b
    type(complex_single_st) div_complex_single_st_long_long
    ! Local declarations
    

    div_complex_single_st_long_long%x = a%x/b
    div_complex_single_st_long_long%y = a%y/b
  end function div_complex_single_st_long_long

!CONTAINS_OP(div, complex_single_st, long,              complex_single_st)
  elemental function div_complex_single_st_int(a, b)
    type(complex_single_st), intent(in) :: a
    integer(C_INT), intent(in) :: b
    type(complex_single_st) div_complex_single_st_int
    ! Local declarations
    

    div_complex_single_st_int%x = a%x/b
    div_complex_single_st_int%y = a%y/b
  end function div_complex_single_st_int

  elemental function div_complex_single_st_short(a, b)
    type(complex_single_st), intent(in) :: a
    integer(C_SHORT), intent(in) :: b
    type(complex_single_st) div_complex_single_st_short
    ! Local declarations
    

    div_complex_single_st_short%x = a%x/b
    div_complex_single_st_short%y = a%y/b
  end function div_complex_single_st_short

!
  elemental function div_single_st_complex_double_st(a, b)
    type(single_st), intent(in) :: a
    type(complex_double_st), intent(in) :: b
    type(complex_double_st) div_single_st_complex_double_st
    ! Local declarations
    type(double_st) norme2

    norme2 = b%x**2 + b%y**2
    div_single_st_complex_double_st = a*conjg(b)/norme2
  end function div_single_st_complex_double_st

  elemental function div_single_st_complex_single_st(a, b)
    type(single_st), intent(in) :: a
    type(complex_single_st), intent(in) :: b
    type(complex_single_st) div_single_st_complex_single_st
    ! Local declarations
    type(single_st) norme2

    norme2 = b%x**2 + b%y**2
    div_single_st_complex_single_st = a*conjg(b)/norme2
  end function div_single_st_complex_single_st


  elemental function div_double_st_complex_double_st(a, b)
    type(double_st), intent(in) :: a
    type(complex_double_st), intent(in) :: b
    type(complex_double_st) div_double_st_complex_double_st
    ! Local declarations
    type(double_st) norme2

    norme2 = b%x**2 + b%y**2
    div_double_st_complex_double_st = a*conjg(b)/norme2
  end function div_double_st_complex_double_st

  elemental function div_double_st_complex_single_st(a, b)
    type(double_st), intent(in) :: a
    type(complex_single_st), intent(in) :: b
    type(complex_double_st) div_double_st_complex_single_st
    ! Local declarations
    type(double_st) norme2

    norme2 = b%x**2 + b%y**2
    div_double_st_complex_single_st = a*conjg(b)/norme2
  end function div_double_st_complex_single_st


  elemental function div_complex_float_complex_double_st(a, b)
    complex(REAL32), intent(in) :: a
    type(complex_double_st), intent(in) :: b
    type(complex_double_st) div_complex_float_complex_double_st
    ! Local declarations
    type(double_st) norme2

    norme2 = b%x**2 + b%y**2
    div_complex_float_complex_double_st = a*conjg(b)/norme2
  end function div_complex_float_complex_double_st

  elemental function div_complex_float_complex_single_st(a, b)
    complex(REAL32), intent(in) :: a
    type(complex_single_st), intent(in) :: b
    type(complex_single_st) div_complex_float_complex_single_st
    ! Local declarations
    type(single_st) norme2

    norme2 = b%x**2 + b%y**2
    div_complex_float_complex_single_st = a*conjg(b)/norme2
  end function div_complex_float_complex_single_st


  elemental function div_complex_double_complex_double_st(a, b)
    complex(REAL64), intent(in) :: a
    type(complex_double_st), intent(in) :: b
    type(complex_double_st) div_complex_double_complex_double_st
    ! Local declarations
    type(double_st) norme2

    norme2 = b%x**2 + b%y**2
    div_complex_double_complex_double_st = a*conjg(b)/norme2
  end function div_complex_double_complex_double_st

  elemental function div_complex_double_complex_single_st(a, b)
    complex(REAL64), intent(in) :: a
    type(complex_single_st), intent(in) :: b
    type(complex_single_st) div_complex_double_complex_single_st
    ! Local declarations
    type(single_st) norme2

    norme2 = b%x**2 + b%y**2
    div_complex_double_complex_single_st = a*conjg(b)/norme2
  end function div_complex_double_complex_single_st


  elemental function div_double_complex_double_st(a, b)
    real(C_DOUBLE), intent(in) :: a
    type(complex_double_st), intent(in) :: b
    type(complex_double_st) div_double_complex_double_st
    ! Local declarations
    type(double_st) norme2

    norme2 = b%x**2 + b%y**2
    div_double_complex_double_st = a*conjg(b)/norme2
  end function div_double_complex_double_st

  elemental function div_double_complex_single_st(a, b)
    real(C_DOUBLE), intent(in) :: a
    type(complex_single_st), intent(in) :: b
    type(complex_single_st) div_double_complex_single_st
    ! Local declarations
    type(single_st) norme2

    norme2 = b%x**2 + b%y**2
    div_double_complex_single_st = a*conjg(b)/norme2
  end function div_double_complex_single_st

!
  elemental function div_float_complex_double_st(a, b)
    real(C_FLOAT), intent(in) :: a
    type(complex_double_st), intent(in) :: b
    type(complex_double_st) div_float_complex_double_st
    ! Local declarations
    type(double_st) norme2

    norme2 = b%x**2 + b%y**2
    div_float_complex_double_st = a*conjg(b)/norme2
  end function div_float_complex_double_st

  elemental function div_float_complex_single_st(a, b)
    real(C_FLOAT), intent(in) :: a
    type(complex_single_st), intent(in) :: b
    type(complex_single_st) div_float_complex_single_st
    ! Local declarations
    type(single_st) norme2

    norme2 = b%x**2 + b%y**2
    div_float_complex_single_st = a*conjg(b)/norme2
  end function div_float_complex_single_st

!
  elemental function div_long_long_complex_double_st(a, b)
    integer(C_LONG_LONG), intent(in) :: a
    type(complex_double_st), intent(in) :: b
    type(complex_double_st) div_long_long_complex_double_st
    ! Local declarations
    type(double_st) norme2

    norme2 = b%x**2 + b%y**2
    div_long_long_complex_double_st = a*conjg(b)/norme2
  end function div_long_long_complex_double_st

  elemental function div_long_long_complex_single_st(a, b)
    integer(C_LONG_LONG), intent(in) :: a
    type(complex_single_st), intent(in) :: b
    type(complex_single_st) div_long_long_complex_single_st
    ! Local declarations
    type(single_st) norme2

    norme2 = b%x**2 + b%y**2
    div_long_long_complex_single_st = a*conjg(b)/norme2
  end function div_long_long_complex_single_st

!
!CONTAINS_OP(div, long,              complex_double_st, complex_double_st)
!CONTAINS_OP(div, long,              complex_single_st, complex_single_st)
!
  elemental function div_int_complex_double_st(a, b)
    integer(C_INT), intent(in) :: a
    type(complex_double_st), intent(in) :: b
    type(complex_double_st) div_int_complex_double_st
    ! Local declarations
    type(double_st) norme2

    norme2 = b%x**2 + b%y**2
    div_int_complex_double_st = a*conjg(b)/norme2
  end function div_int_complex_double_st

  elemental function div_int_complex_single_st(a, b)
    integer(C_INT), intent(in) :: a
    type(complex_single_st), intent(in) :: b
    type(complex_single_st) div_int_complex_single_st
    ! Local declarations
    type(single_st) norme2

    norme2 = b%x**2 + b%y**2
    div_int_complex_single_st = a*conjg(b)/norme2
  end function div_int_complex_single_st

!
  elemental function div_short_complex_double_st(a, b)
    integer(C_SHORT), intent(in) :: a
    type(complex_double_st), intent(in) :: b
    type(complex_double_st) div_short_complex_double_st
    ! Local declarations
    type(double_st) norme2

    norme2 = b%x**2 + b%y**2
    div_short_complex_double_st = a*conjg(b)/norme2
  end function div_short_complex_double_st

  elemental function div_short_complex_single_st(a, b)
    integer(C_SHORT), intent(in) :: a
    type(complex_single_st), intent(in) :: b
    type(complex_single_st) div_short_complex_single_st
    ! Local declarations
    type(single_st) norme2

    norme2 = b%x**2 + b%y**2
    div_short_complex_single_st = a*conjg(b)/norme2
  end function div_short_complex_single_st



end module cadna_cmplx_div

program exampleMPI1_cad
  use ISO_FORTRAN_ENV, only : OUTPUT_UNIT, ERROR_UNIT
  use mpi
  use cadna
  use cadna_mpi
  implicit none


  integer nb_procs, rank, code
  type(double_st) x, y
  type(double_st) res, somme

  ! MPI Initialization
  call MPI_Init(code)
  call MPI_Comm_rank(MPI_COMM_WORLD, rank, code)
  call MPI_Comm_size(MPI_COMM_WORLD, nb_procs, code)

  call cadna_mpi_init(rank, -1)

  if( rank == 0 ) then
     write( ERROR_UNIT, '(a)' ) "I am the Master"
     write( ERROR_UNIT, '(a)' ) "Computation with MPI using CADNA:"
  end if
  if( nb_procs /= 4 ) then
    if( rank == 0 ) write( ERROR_UNIT, '(a)' ) "4 processes are necessary"
    !CALL MPI_ABORT ( MPI_COMM_WORLD, 4, code)
    call MPI_Finalize(code)
    stop 4
  end if
  
  x=10864.d0; y=18817.d0
  res=0.d0 ; somme = 0.d0
  select case(rank)
    case (1)
      res=9.d0*x*x*x*x
    case (2)
      res=- y*y*y*y
    case (3)
      res= 2.d0*y*y
  end select
  write( OUTPUT_UNIT, '(a, i0, 2a)' ) "I am thread ", rank, " and I have res = ", str(res)
  call MPI_Reduce( res, somme, 1, MPIF_DOUBLE_ST, MPIF_CADNA_SUM_DP, 0, MPI_COMM_WORLD, code)
  if ( rank == 0 ) then
    write( OUTPUT_UNIT, '(2a)' ) "-->Final result: ", str(somme)
    write( OUTPUT_UNIT, '(a)' )  "Exact result:  1.000000000000000e+00"
  end if
  
  call cadna_mpi_end
  call MPI_Finalize(code)
end program exampleMPI1_cad

program ex7_cad
  use cadna
  implicit none
  type(double_st) :: r,r1,x,y,z
  integer :: i, nloop, ierr
  call cadna_init(-1)
  print *,'Example created on purpose to make CADNA fail'
  print *,'The same result r is computed for a number of iterations'
  print *,'chosen by the user.'
  print *,'The exact result is 1.4E-10.'
  print *,'But, in 1 case out of 4, CADNA estimates an incorrect accuracy.'
  print *,'Enter the number of iterations'
  read *,nloop
  ierr = 0
  do i=1,nloop
     x=6.83561d+05
     y=6.83560d+05
     z=1.00000000007d0
     r = z - x
     r1 = z - y
     r = r + y
     r1 = r1 + x
     r1 = r1 - 2
     r = r + r1
  !      r = ((z-x)+y) + ((z-y)+x-2)
     if(r.ne.1.4d-10) then 
        ierr = ierr + 1
     endif
  enddo
  print *, 'Last value of r: ', str(r)
  print *, 'Number of iterations when CADNA estimates an incorrect accuracy: ',ierr
  call cadna_end()
end program ex7_cad

      program ex4_cad
      use cadna
      implicit type (double_st) (a-h,o-z)
      call cadna_init(-1)
      !
      print *,'A second order recurrent sequence with CADNA:'
      a = 5.5d0
      b = 61.d0/11.d0
      do i=3,30
        c = b
        b = 111.d0 - 1130.d0/b + 3000.d0/(a*b)
        a = c
        write(*,'(a2,i2,a3,a23)')'U(',i,') = ',str(b)
      enddo
      write(*,*)'The exact limit is 6.'
      call cadna_end()
!
      end

      program ex1_cad
      use cadna
      implicit none
      type (double_st) :: y,x,res
      call cadna_init(-1)
      print *,'Polynomial function of two variables with CADNA: '
      x=77617e0
      y=33096e0
      res=333.75*y*y*y*y*y*y+x*x*(11*x*x*y*y-y*y*y*y*y*y-121 &
     &   *y*y*y*y-2.0) &
     &   +5.5*y*y*y*y*y*y*y*y+x/(2*y)
      print *,'res = ',str(res)
      call cadna_end()
      end program ex1_cad

! Module de conversion




module cadna_cmplx_convert
  use ISO_C_BINDING, only : C_INT
  use cadna_types
  use cadna_affect
  use cadna_cmplx_affect
  use cadna_convert
  use cadna_opp

  implicit none




  interface single_st
    module procedure single_st_complex_single_st
  end interface

  interface double_st
    module procedure double_st_complex_single_st
  end interface

  interface single_st
    module procedure single_st_complex_double_st
  end interface

  interface double_st
    module procedure double_st_complex_double_st
  end interface

  interface complex_single_st
    module procedure complex_single_st_complex_single_st
  end interface

  interface complex_single_st
    module procedure complex_single_st_complex_double_st
  end interface

  interface complex_single_st
    module procedure complex_single_st_single_st
  end interface

  interface complex_single_st
    module procedure complex_single_st_double_st
  end interface

  interface complex_double_st
    module procedure complex_double_st_complex_single_st
  end interface

  interface complex_double_st
    module procedure complex_double_st_complex_double_st
  end interface

  interface complex_double_st
    module procedure complex_double_st_single_st
  end interface

  interface complex_double_st
    module procedure complex_double_st_double_st
  end interface




  interface cmplx
    module procedure cmplx_complex_single_st_single_st
  end interface

  interface cmplx
    module procedure cmplx_complex_double_st_double_st
  end interface




  interface int
    module procedure int_complex_single_st
  end interface

  interface int
    module procedure int_complex_double_st
  end interface

  interface real
    module procedure single_st_complex_single_st
  end interface

  interface real
    module procedure double_st_complex_double_st
  end interface

  interface dble
    module procedure double_st_complex_single_st
  end interface

  interface dble
    module procedure double_st_complex_double_st
  end interface

  interface aimag
    module procedure aimag_complex_single_st
  end interface

  interface aimag
    module procedure aimag_complex_double_st
  end interface

  interface conjg
    module procedure conjg_complex_single_st
  end interface

  interface conjg
    module procedure conjg_complex_double_st
  end interface


contains



! REAL(complex_single_st)
  elemental function single_st_complex_single_st(z)
    type(complex_single_st), intent(in) :: z
    type(single_st) single_st_complex_single_st

    single_st_complex_single_st = z
  end function single_st_complex_single_st

! REAL(complex_single_st, KIND=8), DBLE(complex_single_st)
  elemental function double_st_complex_single_st(z)
    type(complex_single_st), intent(in) :: z
    type(double_st) double_st_complex_single_st

    double_st_complex_single_st = z
  end function double_st_complex_single_st

! REAL(complex_double_st, KIND=4)
  elemental function single_st_complex_double_st(z)
    type(complex_double_st), intent(in) :: z
    type(single_st) single_st_complex_double_st

    single_st_complex_double_st = z
  end function single_st_complex_double_st

! REAL(complex_double_st), DBLE(complex_double_st)
  elemental function double_st_complex_double_st(z)
    type(complex_double_st), intent(in) :: z
    type(double_st) double_st_complex_double_st

    double_st_complex_double_st = z
  end function double_st_complex_double_st

! CMPLX(complex_single_st, KIND=4)
  elemental function complex_single_st_complex_single_st(z)
    type(complex_single_st), intent(in) :: z
    type(complex_single_st) complex_single_st_complex_single_st

    complex_single_st_complex_single_st = z
  end function complex_single_st_complex_single_st

! CMPLX(complex_double_st, KIND=8)
  elemental function complex_double_st_complex_double_st(z)
    type(complex_double_st), intent(in) :: z
    type(complex_double_st) complex_double_st_complex_double_st

    complex_double_st_complex_double_st = z
  end function complex_double_st_complex_double_st

! CMPLX(complex_double_st, KIND=4)
  elemental function complex_single_st_complex_double_st(z)
    type(complex_double_st), intent(in) :: z
    type(complex_single_st) complex_single_st_complex_double_st

    complex_single_st_complex_double_st = z
  end function complex_single_st_complex_double_st

! CMPLX(complex_single_st, KIND=8)
  elemental function complex_double_st_complex_single_st(z)
    type(complex_single_st), intent(in) :: z
    type(complex_double_st) complex_double_st_complex_single_st

    complex_double_st_complex_single_st = z
  end function complex_double_st_complex_single_st





! surcharge des constructeurs par défaut pour permettre des arguments optionnels.
! CMPLX(single_st[, single_st], KIND=4)
  elemental function complex_single_st_single_st(x, y)
    type(single_st),           intent(in) :: x
    type(single_st), optional, intent(in) :: y
    type(complex_single_st) complex_single_st_single_st
    type(single_st) y_local

    y_local = MERGE(tsource=y, fsource=single_st(), mask=present(y))
    complex_single_st_single_st%x = x; complex_single_st_single_st%y = y_local
  end function complex_single_st_single_st

! CMPLX(double_st[, double_st], KIND=4)
  elemental function complex_single_st_double_st(x, y)
    type(double_st),           intent(in) :: x
    type(double_st), optional, intent(in) :: y
    type(complex_single_st) complex_single_st_double_st
    type(double_st) y_local

    y_local = MERGE(tsource=y, fsource=double_st(), mask=present(y))
    complex_single_st_double_st%x = x; complex_single_st_double_st%y = y_local
  end function complex_single_st_double_st

! CMPLX(single_st[, single_st], KIND=8)
  elemental function complex_double_st_single_st(x, y)
    type(single_st),           intent(in) :: x
    type(single_st), optional, intent(in) :: y
    type(complex_double_st) complex_double_st_single_st
    type(single_st) y_local

    y_local = MERGE(tsource=y, fsource=single_st(), mask=present(y))
    complex_double_st_single_st%x = x; complex_double_st_single_st%y = y_local
  end function complex_double_st_single_st

! CMPLX(double_st[, double_st], KIND=8)
  elemental function complex_double_st_double_st(x, y)
    type(double_st),           intent(in) :: x
    type(double_st), optional, intent(in) :: y
    type(complex_double_st) complex_double_st_double_st
    type(double_st) y_local

    y_local = MERGE(tsource=y, fsource=double_st(), mask=present(y))
    complex_double_st_double_st%x = x; complex_double_st_double_st%y = y_local
  end function complex_double_st_double_st




! CMPLX(single_st[, single_st])
  elemental function cmplx_complex_single_st_single_st(x, y)
    type(single_st),           intent(in) :: x
    type(single_st), optional, intent(in) :: y
    type(complex_single_st) cmplx_complex_single_st_single_st
    type(single_st) y_local

    y_local = MERGE(tsource=y, fsource=single_st(), mask=present(y))
    cmplx_complex_single_st_single_st%x = x
    cmplx_complex_single_st_single_st%y = y_local
  end function cmplx_complex_single_st_single_st

! CMPLX(double_st[, double_st])
  elemental function cmplx_complex_double_st_double_st(x, y)
    type(double_st),           intent(in) :: x
    type(double_st), optional, intent(in) :: y
    type(complex_double_st) cmplx_complex_double_st_double_st
    type(double_st) y_local

    y_local = MERGE(tsource=y, fsource=double_st(), mask=present(y))
    cmplx_complex_double_st_double_st%x = x
    cmplx_complex_double_st_double_st%y = y_local
  end function cmplx_complex_double_st_double_st




  elemental function int_complex_single_st(a)
    type(complex_single_st), intent(in) :: a
    integer(C_INT) int_complex_single_st

    int_complex_single_st = int(a%x) 
  end function int_complex_single_st

  elemental function int_complex_double_st(a)
    type(complex_double_st), intent(in) :: a
    integer(C_INT) int_complex_double_st

    int_complex_double_st = int(a%x) 
  end function int_complex_double_st

  elemental function aimag_complex_single_st(z)
    type(complex_single_st), intent(in) :: z
    type(single_st) aimag_complex_single_st

    aimag_complex_single_st = z%y
  end function aimag_complex_single_st

  elemental function aimag_complex_double_st(z)
    type(complex_double_st), intent(in) :: z
    type(double_st) aimag_complex_double_st

    aimag_complex_double_st = z%y
  end function aimag_complex_double_st

  elemental function conjg_complex_single_st(z)
    type(complex_single_st), intent(in) :: z
    type(complex_single_st) conjg_complex_single_st

    conjg_complex_single_st%x = z%x ; conjg_complex_single_st%y = -z%y
  end function conjg_complex_single_st

  elemental function conjg_complex_double_st(z)
    type(complex_double_st), intent(in) :: z
    type(complex_double_st) conjg_complex_double_st

    conjg_complex_double_st%x = z%x ; conjg_complex_double_st%y = -z%y
  end function conjg_complex_double_st




end module cadna_cmplx_convert

!Copyright 2017 R. CARPENTIER, P. CORDE, F. JEZEQUEL, J.-L. LAMOTTE
!
!This file is part of CADNA.
!
!    CADNA is free software: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as
!    published by the Free Software Foundation, either version 3 of the
!    License, or (at your option) any later version.
!
!    CADNA is distributed in the hope that it will be useful, but WITHOUT
!    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
!    or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General
!    Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public
!    License along with CADNA. If not, see
!    <http://www.gnu.org/licenses/>.
!


module cadna_types
  use ISO_C_BINDING, only : C_INT, C_FLOAT, C_DOUBLE
  type, BIND(C) :: single_st
    real(kind=C_FLOAT)  :: x=0._C_FLOAT
    real(kind=C_FLOAT)  :: y=0._C_FLOAT
    real(kind=C_FLOAT)  :: z=0._C_FLOAT
    integer(kind=C_INT) :: accuracy=7_C_INT
  end type single_st
  type, BIND(C) :: double_st
    real(kind=C_DOUBLE) :: x=0._C_DOUBLE
    real(kind=C_DOUBLE) :: y=0._C_DOUBLE
    real(kind=C_DOUBLE) :: z=0._C_DOUBLE
    integer(kind=C_INT) :: accuracy=15_C_INT
    integer(kind=C_INT) :: pad=0_C_INT
  end type double_st

  type complex_single_st
    type(single_st) :: x
    type(single_st) :: y
  end type complex_single_st
  type complex_double_st
    type(double_st) :: x
    type(double_st) :: y
 end type complex_double_st

 integer, parameter :: &
       & cadna_branching = 8, &
       & cadna_mathematic = 16, &
       & cadna_intrinsic = 32, &
       & cadna_cancellation = 64, &
       & cadna_division = 128, &
       & cadna_power = 256, &
       & cadna_multiplication = 512, &
       & cadna_all = 2048 

 integer, parameter :: DIGIT_NOT_COMPUTED = -1
end module cadna_types

      program ex3_cad
      use cadna
      implicit type (double_st) (a-h,o-z)
      dimension amat(11,11)
      call cadna_init(-1)
      !
      print *,'Computation of the determinant of Hilbert matrix'
      print *,'using Gaussian elimination with CADNA:'
      !
      do i=1,11
        do j=1,11
          amat(i,j) = 1.d0/(i+j-1)
        enddo
      enddo
      det = 1.d0
!
      do i=1,10
        write(*,'(a13,i2,a4,a23)')'Pivot number ',i,'  = ',&
     &                             str(amat(i,i))
        det = det*amat(i,i)
        aux = 1.d0/amat(i,i)
        do j=i+1,11
          amat(i,j) = amat(i,j)*aux
        enddo
!
        do j=i+1,11
          aux = amat(j,i)
          do k=i+1,11
            amat(j,k) = amat(j,k) - aux*amat(i,k)
          enddo
        enddo
!
      enddo
!
      write(*,'(a13,i2,a4,a23)')'Pivot number ',i,'  = ',str(amat(i,i))
      det = det*amat(i,i)
      write(*,'(a19,a23)')'Determinant      = ',str(det)
      call cadna_end()
!
      end

program exampleMPI1_cad
  use ISO_FORTRAN_ENV, only : OUTPUT_UNIT, ERROR_UNIT
  use mpi
  use cadna
   use cadna_mpi
  
  implicit none

    integer status(mpi_status_size)
  integer nb_procs, rank, code,i 
  type(single_st) x, y
  type(single_st) res, tmp
  
  ! MPI Initialization
  call MPI_Init(code)
  call MPI_Comm_rank(MPI_COMM_WORLD, rank, code)
  call MPI_Comm_size(MPI_COMM_WORLD, nb_procs, code)

  call cadna_mpi_init(rank, -1)
  
  
  if( rank == 0 ) then
     write( ERROR_UNIT, '(a)' ) "I am the Orig Master"
     write( ERROR_UNIT, '(a)' ) "Computation with MPI using CADNA:"
  end if
  if( nb_procs /= 4 ) then
    if( rank == 0 ) write( ERROR_UNIT, '(a)' ) "4 processes are necessary"
    !CALL MPI_ABORT ( MPI_COMM_WORLD, 4, code)
    call MPI_Finalize(code)
    stop 4
  end if
  
  x=10864.
  y=18817.
  if ( rank /= 0 ) then
    select case(rank)
      case (1)
        res=9.*x*x*x*x
      case (2)
        res=- y*y*y*y
      case (3)
        res= 2.*y*y
    end select
    write( OUTPUT_UNIT, '(a, i0, 2a)' ) "I am thread ", rank, " and I send ", str(res)
    call MPI_Send( res, 1, MPIF_SINGLE_ST, 0, 0, MPI_COMM_WORLD, code)
       write( OUTPUT_UNIT, '(a, i0, 2a)' ) "after I am thread ", rank, " and I send ", str(res)
  else
    res=0.d0
    do i=1,3
       call MPI_Recv( tmp, 1, MPIF_SINGLE_ST, MPI_ANY_SOURCE, 0, MPI_COMM_WORLD, status, code)
      res = res + tmp
      write( OUTPUT_UNIT, '(2a)' ) "I have received ", str(tmp)
    end do
    write( OUTPUT_UNIT, '(2a)' ) "-->Final result: ", str(res)
    write( OUTPUT_UNIT, '(a)' )  "Exact result:  1.000000000000000e+00"
  end if
  
 call cadna_mpi_end
  call MPI_Finalize(code)
end program exampleMPI1_cad

      program ex6
      parameter(idim=4,idim1=5)
      dimension a(idim,idim1),xsol(idim)
      !
      print *,'Solving a linear system using Gaussian elimination'
      print *,'with partial pivoting, without CADNA:'
      xsol(1) = 1.
      xsol(2) = 1.
      xsol(3) = 1.e-8
      xsol(4) = 1.
      a(1,1) = 21.0
      a(1,2) = 130.0
      a(1,3) = 0.0
      a(1,4) = 2.1
      a(1,5) = 153.1
      a(2,1) = 13.0
      a(2,2) = 80.0
      a(2,3) = 4.74e+8
      a(2,4) = 752.0
      a(2,5) = 849.74
      a(3,1) = 0.0
      a(3,2) = -0.4
      a(3,3) = 3.9816e+8
      a(3,4) = 4.2
      a(3,5) = 7.7816
      a(4,1) = 0.0
      a(4,2) = 0.0
      a(4,3) = 1.7
      a(4,4) = 9.0e-9
      a(4,5) = 2.6e-8
!
      do i=1,idim-1
!
        pmax = 0.0
        do j=i,idim
          if(abs(a(j,i)).gt.pmax) then
            pmax = abs(a(j,i))
            ll = j
          endif
        enddo
!
        if (ll.ne.i) then
          do j=i,idim1
            aux = a(i,j)
            a(i,j) = a(ll,j)
            a(ll,j) = aux
          enddo
        endif
!
        aux = a(i,i)
        do j =i+1,idim1
           a(i,j) = a(i,j)/aux
        end do
!
        do k=i+1,idim
          aux = a(k,i)
          do j=i+1,idim1
            a(k,j)=a(k,j) - aux*a(i,j)
          end do
        end do
!
      end do
!
      a(idim,idim1) = a(idim,idim1)/a(idim,idim)
!
      do i=idim-1,1,-1
        do j=i+1,idim
          a(i,idim1) = a(i,idim1) - a(i,j)*a(j,idim1)
        enddo
      enddo
!
      do i=1,idim
        write(*,'(a6,i1,a4,e17.7,a22,e17.7,a1)')'x_sol(',i,') = ', &
     &   a(i,idim1),'     (exact solution: ',xsol(i),')'
      enddo
! 
      end

      program ex3
      implicit double precision (a-h,o-z)
      dimension amat(11,11)
      !
      print *,'Computation of the determinant of Hilbert matrix'
      print *,'using Gaussian elimination without CADNA:'
      !
      do i=1,11
        do j=1,11
          amat(i,j) = 1.d0/(i+j-1)
        enddo
      enddo
      det = 1.d0
!
      do i=1,10
        write(*,'(a13,i2,a4,d23.16)')'Pivot number ',i,'  = ',amat(i,i)
        det = det*amat(i,i)
        aux = 1.d0/amat(i,i)
        do j=i+1,11
          amat(i,j) = amat(i,j)*aux
        enddo
!
        do j=i+1,11
          aux = amat(j,i)
          do k=i+1,11
            amat(j,k) = amat(j,k) - aux*amat(i,k)
          enddo
        enddo
!
      enddo
!
      write(*,'(a13,i2,a4,d23.16)')'Pivot number ',i,'  = ',amat(i,i)
      det = det*amat(i,i)
      write(*,'(a19,d23.16)')'Determinant      = ',det
!
      end

! Module de surcharge de l'opérateur "="





module cadna_cmplx_affect
  use ISO_C_BINDING, only : C_LONG_LONG, C_LONG, C_INT, C_SHORT, C_FLOAT, C_DOUBLE
  use cadna_types
  use cadna_affect
  implicit none




!INTERFACE_OP(=, affect, complex_double_st, complex_double_st)
  interface assignment(=)
    module procedure affect_complex_double_st_complex_single_st
  end interface assignment(=)

  interface assignment(=)
    module procedure affect_complex_double_st_complex
  end interface assignment(=)

  interface assignment(=)
    module procedure affect_complex_double_st_double_st
  end interface assignment(=)

  interface assignment(=)
    module procedure affect_complex_double_st_single_st
  end interface assignment(=)

  interface assignment(=)
    module procedure affect_complex_double_st_double
  end interface assignment(=)

  interface assignment(=)
    module procedure affect_complex_double_st_float
  end interface assignment(=)

  interface assignment(=)
    module procedure affect_complex_double_st_long_long
  end interface assignment(=)

!INTERFACE_OP(=, affect, complex_double_st, long)
  interface assignment(=)
    module procedure affect_complex_double_st_int
  end interface assignment(=)

  interface assignment(=)
    module procedure affect_complex_double_st_short
  end interface assignment(=)

!
  interface assignment(=)
    module procedure affect_complex_single_st_complex_double_st
  end interface assignment(=)

!INTERFACE_OP(=, affect, complex_single_st, complex_single_st)
  interface assignment(=)
    module procedure affect_complex_single_st_complex
  end interface assignment(=)

  interface assignment(=)
    module procedure affect_complex_single_st_double_st
  end interface assignment(=)

  interface assignment(=)
    module procedure affect_complex_single_st_single_st
  end interface assignment(=)

  interface assignment(=)
    module procedure affect_complex_single_st_double
  end interface assignment(=)

  interface assignment(=)
    module procedure affect_complex_single_st_float
  end interface assignment(=)

  interface assignment(=)
    module procedure affect_complex_single_st_long_long
  end interface assignment(=)

!INTERFACE_OP(=, affect, complex_single_st, long)
  interface assignment(=)
    module procedure affect_complex_single_st_int
  end interface assignment(=)

  interface assignment(=)
    module procedure affect_complex_single_st_short
  end interface assignment(=)

!
  interface assignment(=)
    module procedure affect_single_st_complex_double_st
  end interface assignment(=)

  interface assignment(=)
    module procedure affect_single_st_complex_single_st
  end interface assignment(=)


  interface assignment(=)
    module procedure affect_double_st_complex_double_st
  end interface assignment(=)

  interface assignment(=)
    module procedure affect_double_st_complex_single_st
  end interface assignment(=)


  interface assignment(=)
    module procedure affect_complex_complex_double_st
  end interface assignment(=)

  interface assignment(=)
    module procedure affect_complex_complex_single_st
  end interface assignment(=)


  interface assignment(=)
    module procedure affect_double_complex_double_st
  end interface assignment(=)

  interface assignment(=)
    module procedure affect_double_complex_single_st
  end interface assignment(=)

!
  interface assignment(=)
    module procedure affect_float_complex_double_st
  end interface assignment(=)

  interface assignment(=)
    module procedure affect_float_complex_single_st
  end interface assignment(=)

!
  interface assignment(=)
    module procedure affect_long_long_complex_double_st
  end interface assignment(=)

  interface assignment(=)
    module procedure affect_long_long_complex_single_st
  end interface assignment(=)

!
!INTERFACE_OP(=, affect, long,              complex_double_st)
!INTERFACE_OP(=, affect, long,              complex_single_st)
!
  interface assignment(=)
    module procedure affect_int_complex_double_st
  end interface assignment(=)

  interface assignment(=)
    module procedure affect_int_complex_single_st
  end interface assignment(=)

!
  interface assignment(=)
    module procedure affect_short_complex_double_st
  end interface assignment(=)

  interface assignment(=)
    module procedure affect_short_complex_single_st
  end interface assignment(=)


contains



!CONTAINS_OP(affect, complex_double_st, complex_double_st)
  elemental subroutine affect_complex_double_st_complex_single_st(a, b)
    type(complex_double_st), intent(out) :: a
    type(complex_single_st), intent(in) :: b
    a%x = b%x ; a%y = b%y
  end subroutine affect_complex_double_st_complex_single_st

  elemental subroutine affect_complex_double_st_complex(a, b)
    type(complex_double_st), intent(out) :: a
    complex, intent(in) :: b
    a%x = REAL(b)
    a%y = AIMAG(b)
  end subroutine affect_complex_double_st_complex

  elemental subroutine affect_complex_double_st_double_st(a, b)
    type(complex_double_st), intent(out) :: a
    type(double_st), intent(in) :: b
    a%x = b ; a%y = 0.
  end subroutine affect_complex_double_st_double_st

  elemental subroutine affect_complex_double_st_single_st(a, b)
    type(complex_double_st), intent(out) :: a
    type(single_st), intent(in) :: b
    a%x = b ; a%y = 0.
  end subroutine affect_complex_double_st_single_st

  elemental subroutine affect_complex_double_st_double(a, b)
    type(complex_double_st), intent(out) :: a
    real(C_DOUBLE), intent(in) :: b
    a%x = b ; a%y = 0.
  end subroutine affect_complex_double_st_double

  elemental subroutine affect_complex_double_st_float(a, b)
    type(complex_double_st), intent(out) :: a
    real(C_FLOAT), intent(in) :: b
    a%x = b ; a%y = 0.
  end subroutine affect_complex_double_st_float

  elemental subroutine affect_complex_double_st_long_long(a, b)
    type(complex_double_st), intent(out) :: a
    integer(C_LONG_LONG), intent(in) :: b
    a%x = b ; a%y = 0.
  end subroutine affect_complex_double_st_long_long

!CONTAINS_OP(affect, complex_double_st, long)
  elemental subroutine affect_complex_double_st_int(a, b)
    type(complex_double_st), intent(out) :: a
    integer(C_INT), intent(in) :: b
    a%x = b ; a%y = 0.
  end subroutine affect_complex_double_st_int

  elemental subroutine affect_complex_double_st_short(a, b)
    type(complex_double_st), intent(out) :: a
    integer(C_SHORT), intent(in) :: b
    a%x = b ; a%y = 0.
  end subroutine affect_complex_double_st_short

!
  elemental subroutine affect_complex_single_st_complex_double_st(a, b)
    type(complex_single_st), intent(out) :: a
    type(complex_double_st), intent(in) :: b
    a%x = b%x ; a%y = b%y
  end subroutine affect_complex_single_st_complex_double_st

!CONTAINS_OP(affect, complex_single_st, complex_single_st)
  elemental subroutine affect_complex_single_st_complex(a, b)
    type(complex_single_st), intent(out) :: a
    complex, intent(in) :: b
    a%x = REAL(b)
    a%y = AIMAG(b)
  end subroutine affect_complex_single_st_complex

  elemental subroutine affect_complex_single_st_double_st(a, b)
    type(complex_single_st), intent(out) :: a
    type(double_st), intent(in) :: b
    a%x = b ; a%y = 0.
  end subroutine affect_complex_single_st_double_st

  elemental subroutine affect_complex_single_st_single_st(a, b)
    type(complex_single_st), intent(out) :: a
    type(single_st), intent(in) :: b
    a%x = b ; a%y = 0.
  end subroutine affect_complex_single_st_single_st

  elemental subroutine affect_complex_single_st_double(a, b)
    type(complex_single_st), intent(out) :: a
    real(C_DOUBLE), intent(in) :: b
    a%x = b ; a%y = 0.
  end subroutine affect_complex_single_st_double

  elemental subroutine affect_complex_single_st_float(a, b)
    type(complex_single_st), intent(out) :: a
    real(C_FLOAT), intent(in) :: b
    a%x = b ; a%y = 0.
  end subroutine affect_complex_single_st_float

  elemental subroutine affect_complex_single_st_long_long(a, b)
    type(complex_single_st), intent(out) :: a
    integer(C_LONG_LONG), intent(in) :: b
    a%x = b ; a%y = 0.
  end subroutine affect_complex_single_st_long_long

!CONTAINS_OP(affect, complex_single_st, long)
  elemental subroutine affect_complex_single_st_int(a, b)
    type(complex_single_st), intent(out) :: a
    integer(C_INT), intent(in) :: b
    a%x = b ; a%y = 0.
  end subroutine affect_complex_single_st_int

  elemental subroutine affect_complex_single_st_short(a, b)
    type(complex_single_st), intent(out) :: a
    integer(C_SHORT), intent(in) :: b
    a%x = b ; a%y = 0.
  end subroutine affect_complex_single_st_short

!
  elemental subroutine affect_single_st_complex_double_st(a, b)
    type(single_st), intent(out) :: a
    type(complex_double_st), intent(in) :: b
    a = b%x
  end subroutine affect_single_st_complex_double_st

  elemental subroutine affect_single_st_complex_single_st(a, b)
    type(single_st), intent(out) :: a
    type(complex_single_st), intent(in) :: b
    a = b%x
  end subroutine affect_single_st_complex_single_st


  elemental subroutine affect_double_st_complex_double_st(a, b)
    type(double_st), intent(out) :: a
    type(complex_double_st), intent(in) :: b
    a = b%x
  end subroutine affect_double_st_complex_double_st

  elemental subroutine affect_double_st_complex_single_st(a, b)
    type(double_st), intent(out) :: a
    type(complex_single_st), intent(in) :: b
    a = b%x
  end subroutine affect_double_st_complex_single_st


  elemental subroutine affect_complex_complex_double_st(a, b)
    complex, intent(out) :: a
    type(complex_double_st), intent(in) :: b
    real x, y
    
    x = b%x ; y = b%y
    a = cmplx(x, y)
  end subroutine affect_complex_complex_double_st

  elemental subroutine affect_complex_complex_single_st(a, b)
    complex, intent(out) :: a
    type(complex_single_st), intent(in) :: b
    real x, y
    
    x = b%x ; y = b%y
    a = cmplx(x, y)
  end subroutine affect_complex_complex_single_st


  elemental subroutine affect_double_complex_double_st(a, b)
    real(C_DOUBLE), intent(out) :: a
    type(complex_double_st), intent(in) :: b
    a = b%x
  end subroutine affect_double_complex_double_st

  elemental subroutine affect_double_complex_single_st(a, b)
    real(C_DOUBLE), intent(out) :: a
    type(complex_single_st), intent(in) :: b
    a = b%x
  end subroutine affect_double_complex_single_st

!
  elemental subroutine affect_float_complex_double_st(a, b)
    real(C_FLOAT), intent(out) :: a
    type(complex_double_st), intent(in) :: b
    a = b%x
  end subroutine affect_float_complex_double_st

  elemental subroutine affect_float_complex_single_st(a, b)
    real(C_FLOAT), intent(out) :: a
    type(complex_single_st), intent(in) :: b
    a = b%x
  end subroutine affect_float_complex_single_st

!
  elemental subroutine affect_long_long_complex_double_st(a, b)
    integer(C_LONG_LONG), intent(out) :: a
    type(complex_double_st), intent(in) :: b
    a = b%x
  end subroutine affect_long_long_complex_double_st

  elemental subroutine affect_long_long_complex_single_st(a, b)
    integer(C_LONG_LONG), intent(out) :: a
    type(complex_single_st), intent(in) :: b
    a = b%x
  end subroutine affect_long_long_complex_single_st

!
!CONTAINS_OP(affect, long,             complex_double_st)
!CONTAINS_OP(affect, long,             complex_single_st)
!
  elemental subroutine affect_int_complex_double_st(a, b)
    integer(C_INT), intent(out) :: a
    type(complex_double_st), intent(in) :: b
    a = b%x
  end subroutine affect_int_complex_double_st

  elemental subroutine affect_int_complex_single_st(a, b)
    integer(C_INT), intent(out) :: a
    type(complex_single_st), intent(in) :: b
    a = b%x
  end subroutine affect_int_complex_single_st

!
  elemental subroutine affect_short_complex_double_st(a, b)
    integer(C_SHORT), intent(out) :: a
    type(complex_double_st), intent(in) :: b
    a = b%x
  end subroutine affect_short_complex_double_st

  elemental subroutine affect_short_complex_single_st(a, b)
    integer(C_SHORT), intent(out) :: a
    type(complex_single_st), intent(in) :: b
    a = b%x
  end subroutine affect_short_complex_single_st




end module cadna_cmplx_affect

! Module de surcharge des fonctions tableaux pour les complexes






module cadna_cmplx_array
  use cadna_types
  use cadna_cmplx_affect
  use cadna_cmplx_add
  use cadna_cmplx_mult
  use cadna_cmplx_convert

  implicit none




  interface dot_product
    module procedure dot_product_complex_single_st
  end interface dot_product
  interface dot_product
    module procedure dot_product_complex_double_st
  end interface dot_product



  interface matmul
    module procedure matmul_complex_single_st_1D2D
  end interface matmul
  interface matmul
    module procedure matmul_complex_double_st_1D2D
  end interface matmul
  interface matmul
    module procedure matmul_complex_single_st_2D1D
  end interface matmul
  interface matmul
    module procedure matmul_complex_double_st_2D1D
  end interface matmul
  interface matmul
    module procedure matmul_complex_single_st_2D2D
  end interface matmul
  interface matmul
    module procedure matmul_complex_double_st_2D2D
  end interface matmul



  interface sum
    module procedure sum_complex_single_st_1D
  end interface sum
  interface sum
    module procedure sum_complex_double_st_1D
  end interface sum
  interface sum
    module procedure sum_complex_single_st_dim_1D
  end interface sum
  interface sum
    module procedure sum_complex_double_st_dim_1D
  end interface sum
  interface sum
    module procedure sum_complex_single_st_2D
  end interface sum
  interface sum
    module procedure sum_complex_double_st_2D
  end interface sum
  interface sum
    module procedure sum_complex_single_st_dim_2D
  end interface sum
  interface sum
    module procedure sum_complex_double_st_dim_2D
  end interface sum
  interface sum
    module procedure sum_complex_single_st_3D
  end interface sum
  interface sum
    module procedure sum_complex_double_st_3D
  end interface sum
  interface sum
    module procedure sum_complex_single_st_dim_3D
  end interface sum
  interface sum
    module procedure sum_complex_double_st_dim_3D
  end interface sum
  interface sum
    module procedure sum_complex_single_st_4D
  end interface sum
  interface sum
    module procedure sum_complex_double_st_4D
  end interface sum
  interface sum
    module procedure sum_complex_single_st_dim_4D
  end interface sum
  interface sum
    module procedure sum_complex_double_st_dim_4D
  end interface sum
  interface sum
    module procedure sum_complex_single_st_5D
  end interface sum
  interface sum
    module procedure sum_complex_double_st_5D
  end interface sum
  interface sum
    module procedure sum_complex_single_st_dim_5D
  end interface sum
  interface sum
    module procedure sum_complex_double_st_dim_5D
  end interface sum
  interface sum
    module procedure sum_complex_single_st_6D
  end interface sum
  interface sum
    module procedure sum_complex_double_st_6D
  end interface sum
  interface sum
    module procedure sum_complex_single_st_dim_6D
  end interface sum
  interface sum
    module procedure sum_complex_double_st_dim_6D
  end interface sum
  interface sum
    module procedure sum_complex_single_st_7D
  end interface sum
  interface sum
    module procedure sum_complex_double_st_7D
  end interface sum
  interface sum
    module procedure sum_complex_single_st_dim_7D
  end interface sum
  interface sum
    module procedure sum_complex_double_st_dim_7D
  end interface sum

  interface product
    module procedure product_complex_single_st_1D
  end interface product
  interface product
    module procedure product_complex_double_st_1D
  end interface product
  interface product
    module procedure product_complex_single_st_dim_1D
  end interface product
  interface product
    module procedure product_complex_double_st_dim_1D
  end interface product
  interface product
    module procedure product_complex_single_st_2D
  end interface product
  interface product
    module procedure product_complex_double_st_2D
  end interface product
  interface product
    module procedure product_complex_single_st_dim_2D
  end interface product
  interface product
    module procedure product_complex_double_st_dim_2D
  end interface product
  interface product
    module procedure product_complex_single_st_3D
  end interface product
  interface product
    module procedure product_complex_double_st_3D
  end interface product
  interface product
    module procedure product_complex_single_st_dim_3D
  end interface product
  interface product
    module procedure product_complex_double_st_dim_3D
  end interface product
  interface product
    module procedure product_complex_single_st_4D
  end interface product
  interface product
    module procedure product_complex_double_st_4D
  end interface product
  interface product
    module procedure product_complex_single_st_dim_4D
  end interface product
  interface product
    module procedure product_complex_double_st_dim_4D
  end interface product
  interface product
    module procedure product_complex_single_st_5D
  end interface product
  interface product
    module procedure product_complex_double_st_5D
  end interface product
  interface product
    module procedure product_complex_single_st_dim_5D
  end interface product
  interface product
    module procedure product_complex_double_st_dim_5D
  end interface product
  interface product
    module procedure product_complex_single_st_6D
  end interface product
  interface product
    module procedure product_complex_double_st_6D
  end interface product
  interface product
    module procedure product_complex_single_st_dim_6D
  end interface product
  interface product
    module procedure product_complex_double_st_dim_6D
  end interface product
  interface product
    module procedure product_complex_single_st_7D
  end interface product
  interface product
    module procedure product_complex_double_st_7D
  end interface product
  interface product
    module procedure product_complex_single_st_dim_7D
  end interface product
  interface product
    module procedure product_complex_double_st_dim_7D
  end interface product

contains



  function dot_product_complex_single_st(vector_a, vector_b)
    ! Dummy arguments declaration
    type(complex_single_st), dimension(:), intent(in) :: vector_a, vector_b
    type(complex_single_st) :: dot_product_complex_single_st

    dot_product_complex_single_st = SUM(conjg(vector_a)*vector_b)
  end function dot_product_complex_single_st

  function dot_product_complex_double_st(vector_a, vector_b)
    ! Dummy arguments declaration
    type(complex_double_st), dimension(:), intent(in) :: vector_a, vector_b
    type(complex_double_st) :: dot_product_complex_double_st

    dot_product_complex_double_st = SUM(conjg(vector_a)*vector_b)
  end function dot_product_complex_double_st




  function matmul_complex_single_st_1D2D(matrix_a, matrix_b)
    ! Dummy arguments declaration
    type(complex_single_st), dimension (:), intent(in) :: matrix_a
    type(complex_single_st), dimension (:,:), intent(in) :: matrix_b 
    type(complex_single_st), dimension (size(matrix_b,2)) :: matmul_complex_single_st_1D2D
    ! Local declaration
    integer j

    do j=1,size(matrix_b,2)
      matmul_complex_single_st_1D2D(j) = SUM(matrix_a*matrix_b(:,j))
    enddo
  end function matmul_complex_single_st_1D2D

  function matmul_complex_double_st_1D2D(matrix_a, matrix_b)
    ! Dummy arguments declaration
    type(complex_double_st), dimension (:), intent(in) :: matrix_a
    type(complex_double_st), dimension (:,:), intent(in) :: matrix_b 
    type(complex_double_st), dimension (size(matrix_b,2)) :: matmul_complex_double_st_1D2D
    ! Local declaration
    integer j

    do j=1,size(matrix_b,2)
      matmul_complex_double_st_1D2D(j) = SUM(matrix_a*matrix_b(:,j))
    enddo
  end function matmul_complex_double_st_1D2D

  function matmul_complex_single_st_2D1D(matrix_a, matrix_b)
    ! Dummy arguments declaration
    type(complex_single_st), dimension (:,:), intent(in) :: matrix_a 
    type(complex_single_st), dimension (:), intent(in) :: matrix_b
    type(complex_single_st), dimension (size(matrix_a,1)) :: matmul_complex_single_st_2D1D
    ! Local declaration
    integer i

    do i=1,size(matrix_a,1)
      matmul_complex_single_st_2D1D(i) = SUM(matrix_a(i,:)*matrix_b)
    enddo
  end function matmul_complex_single_st_2D1D

  function matmul_complex_double_st_2D1D(matrix_a, matrix_b)
    ! Dummy arguments declaration
    type(complex_double_st), dimension (:,:), intent(in) :: matrix_a 
    type(complex_double_st), dimension (:), intent(in) :: matrix_b
    type(complex_double_st), dimension (size(matrix_a,1)) :: matmul_complex_double_st_2D1D
    ! Local declaration
    integer i

    do i=1,size(matrix_a,1)
      matmul_complex_double_st_2D1D(i) = SUM(matrix_a(i,:)*matrix_b)
    enddo
  end function matmul_complex_double_st_2D1D

  function matmul_complex_single_st_2D2D(matrix_a, matrix_b)
    ! Dummy arguments declaration
    type(complex_single_st), dimension (:,:), intent(in) :: matrix_a 
    type(complex_single_st), dimension (:,:), intent(in) :: matrix_b 
    type(complex_single_st), dimension (size(matrix_a,1), size(matrix_b,2)) :: matmul_complex_single_st_2D2D 
    ! Local declaration
    integer i, j 

    do i=1,size(matrix_a,1)
      do j=1,size(matrix_b,2)
        matmul_complex_single_st_2D2D(i,j) = SUM(matrix_a(i,:)*matrix_b(:,j))
      enddo
    enddo 
  end function matmul_complex_single_st_2D2D

  function matmul_complex_double_st_2D2D(matrix_a, matrix_b)
    ! Dummy arguments declaration
    type(complex_double_st), dimension (:,:), intent(in) :: matrix_a 
    type(complex_double_st), dimension (:,:), intent(in) :: matrix_b 
    type(complex_double_st), dimension (size(matrix_a,1), size(matrix_b,2)) :: matmul_complex_double_st_2D2D 
    ! Local declaration
    integer i, j 

    do i=1,size(matrix_a,1)
      do j=1,size(matrix_b,2)
        matmul_complex_double_st_2D2D(i,j) = SUM(matrix_a(i,:)*matrix_b(:,j))
      enddo
    enddo 
  end function matmul_complex_double_st_2D2D




  function sum_complex_single_st_1D(array, mask)
    ! Dummy arguments declaration
    type(complex_single_st), dimension (:), intent(in), target, contiguous :: array
    logical,                 dimension (:), intent(in), optional, target, contiguous :: mask
    type(complex_single_st) :: sum_complex_single_st_1D
    ! Local declaration
    type(complex_single_st), dimension(:), pointer :: p_array
    logical,                 dimension(:), pointer :: p_mask
    integer i

    p_array(1:size(array)) => array
    if (present(mask)) p_mask(1:size(mask)) => mask
    sum_complex_single_st_1D = 0
    do i=1,size(p_array)
      if (present(mask)) then
        if( .not.p_mask(i) ) cycle
      end if
      sum_complex_single_st_1D = sum_complex_single_st_1D + p_array(i)
    end do

  end function sum_complex_single_st_1D

  function sum_complex_double_st_1D(array, mask)
    ! Dummy arguments declaration
    type(complex_double_st), dimension (:), intent(in), target, contiguous :: array
    logical,                 dimension (:), intent(in), optional, target, contiguous :: mask
    type(complex_double_st) :: sum_complex_double_st_1D
    ! Local declaration
    type(complex_double_st), dimension(:), pointer :: p_array
    logical,                 dimension(:), pointer :: p_mask
    integer i

    p_array(1:size(array)) => array
    if (present(mask)) p_mask(1:size(mask)) => mask
    sum_complex_double_st_1D = 0
    do i=1,size(p_array)
      if (present(mask)) then
        if( .not.p_mask(i) ) cycle
      end if
      sum_complex_double_st_1D = sum_complex_double_st_1D + p_array(i)
    end do

  end function sum_complex_double_st_1D

  function sum_complex_single_st_2D(array, mask)
    ! Dummy arguments declaration
    type(complex_single_st), dimension (:,:), intent(in), target, contiguous :: array
    logical,                 dimension (:,:), intent(in), optional, target, contiguous :: mask
    type(complex_single_st) :: sum_complex_single_st_2D
    ! Local declaration
    type(complex_single_st), dimension(:), pointer :: p_array
    logical,                 dimension(:), pointer :: p_mask
    integer i

    p_array(1:size(array)) => array
    if (present(mask)) p_mask(1:size(mask)) => mask
    sum_complex_single_st_2D = 0
    do i=1,size(p_array)
      if (present(mask)) then
        if( .not.p_mask(i) ) cycle
      end if
      sum_complex_single_st_2D = sum_complex_single_st_2D + p_array(i)
    end do

  end function sum_complex_single_st_2D

  function sum_complex_double_st_2D(array, mask)
    ! Dummy arguments declaration
    type(complex_double_st), dimension (:,:), intent(in), target, contiguous :: array
    logical,                 dimension (:,:), intent(in), optional, target, contiguous :: mask
    type(complex_double_st) :: sum_complex_double_st_2D
    ! Local declaration
    type(complex_double_st), dimension(:), pointer :: p_array
    logical,                 dimension(:), pointer :: p_mask
    integer i

    p_array(1:size(array)) => array
    if (present(mask)) p_mask(1:size(mask)) => mask
    sum_complex_double_st_2D = 0
    do i=1,size(p_array)
      if (present(mask)) then
        if( .not.p_mask(i) ) cycle
      end if
      sum_complex_double_st_2D = sum_complex_double_st_2D + p_array(i)
    end do

  end function sum_complex_double_st_2D

  function sum_complex_single_st_3D(array, mask)
    ! Dummy arguments declaration
    type(complex_single_st), dimension (:,:,:), intent(in), target, contiguous :: array
    logical,                 dimension (:,:,:), intent(in), optional, target, contiguous :: mask
    type(complex_single_st) :: sum_complex_single_st_3D
    ! Local declaration
    type(complex_single_st), dimension(:), pointer :: p_array
    logical,                 dimension(:), pointer :: p_mask
    integer i

    p_array(1:size(array)) => array
    if (present(mask)) p_mask(1:size(mask)) => mask
    sum_complex_single_st_3D = 0
    do i=1,size(p_array)
      if (present(mask)) then
        if( .not.p_mask(i) ) cycle
      end if
      sum_complex_single_st_3D = sum_complex_single_st_3D + p_array(i)
    end do

  end function sum_complex_single_st_3D

  function sum_complex_double_st_3D(array, mask)
    ! Dummy arguments declaration
    type(complex_double_st), dimension (:,:,:), intent(in), target, contiguous :: array
    logical,                 dimension (:,:,:), intent(in), optional, target, contiguous :: mask
    type(complex_double_st) :: sum_complex_double_st_3D
    ! Local declaration
    type(complex_double_st), dimension(:), pointer :: p_array
    logical,                 dimension(:), pointer :: p_mask
    integer i

    p_array(1:size(array)) => array
    if (present(mask)) p_mask(1:size(mask)) => mask
    sum_complex_double_st_3D = 0
    do i=1,size(p_array)
      if (present(mask)) then
        if( .not.p_mask(i) ) cycle
      end if
      sum_complex_double_st_3D = sum_complex_double_st_3D + p_array(i)
    end do

  end function sum_complex_double_st_3D

  function sum_complex_single_st_4D(array, mask)
    ! Dummy arguments declaration
    type(complex_single_st), dimension (:,:,:,:), intent(in), target, contiguous :: array
    logical,                 dimension (:,:,:,:), intent(in), optional, target, contiguous :: mask
    type(complex_single_st) :: sum_complex_single_st_4D
    ! Local declaration
    type(complex_single_st), dimension(:), pointer :: p_array
    logical,                 dimension(:), pointer :: p_mask
    integer i

    p_array(1:size(array)) => array
    if (present(mask)) p_mask(1:size(mask)) => mask
    sum_complex_single_st_4D = 0
    do i=1,size(p_array)
      if (present(mask)) then
        if( .not.p_mask(i) ) cycle
      end if
      sum_complex_single_st_4D = sum_complex_single_st_4D + p_array(i)
    end do

  end function sum_complex_single_st_4D

  function sum_complex_double_st_4D(array, mask)
    ! Dummy arguments declaration
    type(complex_double_st), dimension (:,:,:,:), intent(in), target, contiguous :: array
    logical,                 dimension (:,:,:,:), intent(in), optional, target, contiguous :: mask
    type(complex_double_st) :: sum_complex_double_st_4D
    ! Local declaration
    type(complex_double_st), dimension(:), pointer :: p_array
    logical,                 dimension(:), pointer :: p_mask
    integer i

    p_array(1:size(array)) => array
    if (present(mask)) p_mask(1:size(mask)) => mask
    sum_complex_double_st_4D = 0
    do i=1,size(p_array)
      if (present(mask)) then
        if( .not.p_mask(i) ) cycle
      end if
      sum_complex_double_st_4D = sum_complex_double_st_4D + p_array(i)
    end do

  end function sum_complex_double_st_4D

  function sum_complex_single_st_5D(array, mask)
    ! Dummy arguments declaration
    type(complex_single_st), dimension (:,:,:,:,:), intent(in), target, contiguous :: array
    logical,                 dimension (:,:,:,:,:), intent(in), optional, target, contiguous :: mask
    type(complex_single_st) :: sum_complex_single_st_5D
    ! Local declaration
    type(complex_single_st), dimension(:), pointer :: p_array
    logical,                 dimension(:), pointer :: p_mask
    integer i

    p_array(1:size(array)) => array
    if (present(mask)) p_mask(1:size(mask)) => mask
    sum_complex_single_st_5D = 0
    do i=1,size(p_array)
      if (present(mask)) then
        if( .not.p_mask(i) ) cycle
      end if
      sum_complex_single_st_5D = sum_complex_single_st_5D + p_array(i)
    end do

  end function sum_complex_single_st_5D

  function sum_complex_double_st_5D(array, mask)
    ! Dummy arguments declaration
    type(complex_double_st), dimension (:,:,:,:,:), intent(in), target, contiguous :: array
    logical,                 dimension (:,:,:,:,:), intent(in), optional, target, contiguous :: mask
    type(complex_double_st) :: sum_complex_double_st_5D
    ! Local declaration
    type(complex_double_st), dimension(:), pointer :: p_array
    logical,                 dimension(:), pointer :: p_mask
    integer i

    p_array(1:size(array)) => array
    if (present(mask)) p_mask(1:size(mask)) => mask
    sum_complex_double_st_5D = 0
    do i=1,size(p_array)
      if (present(mask)) then
        if( .not.p_mask(i) ) cycle
      end if
      sum_complex_double_st_5D = sum_complex_double_st_5D + p_array(i)
    end do

  end function sum_complex_double_st_5D

  function sum_complex_single_st_6D(array, mask)
    ! Dummy arguments declaration
    type(complex_single_st), dimension (:,:,:,:,:,:), intent(in), target, contiguous :: array
    logical,                 dimension (:,:,:,:,:,:), intent(in), optional, target, contiguous :: mask
    type(complex_single_st) :: sum_complex_single_st_6D
    ! Local declaration
    type(complex_single_st), dimension(:), pointer :: p_array
    logical,                 dimension(:), pointer :: p_mask
    integer i

    p_array(1:size(array)) => array
    if (present(mask)) p_mask(1:size(mask)) => mask
    sum_complex_single_st_6D = 0
    do i=1,size(p_array)
      if (present(mask)) then
        if( .not.p_mask(i) ) cycle
      end if
      sum_complex_single_st_6D = sum_complex_single_st_6D + p_array(i)
    end do

  end function sum_complex_single_st_6D

  function sum_complex_double_st_6D(array, mask)
    ! Dummy arguments declaration
    type(complex_double_st), dimension (:,:,:,:,:,:), intent(in), target, contiguous :: array
    logical,                 dimension (:,:,:,:,:,:), intent(in), optional, target, contiguous :: mask
    type(complex_double_st) :: sum_complex_double_st_6D
    ! Local declaration
    type(complex_double_st), dimension(:), pointer :: p_array
    logical,                 dimension(:), pointer :: p_mask
    integer i

    p_array(1:size(array)) => array
    if (present(mask)) p_mask(1:size(mask)) => mask
    sum_complex_double_st_6D = 0
    do i=1,size(p_array)
      if (present(mask)) then
        if( .not.p_mask(i) ) cycle
      end if
      sum_complex_double_st_6D = sum_complex_double_st_6D + p_array(i)
    end do

  end function sum_complex_double_st_6D

  function sum_complex_single_st_7D(array, mask)
    ! Dummy arguments declaration
    type(complex_single_st), dimension (:,:,:,:,:,:,:), intent(in), target, contiguous :: array
    logical,                 dimension (:,:,:,:,:,:,:), intent(in), optional, target, contiguous :: mask
    type(complex_single_st) :: sum_complex_single_st_7D
    ! Local declaration
    type(complex_single_st), dimension(:), pointer :: p_array
    logical,                 dimension(:), pointer :: p_mask
    integer i

    p_array(1:size(array)) => array
    if (present(mask)) p_mask(1:size(mask)) => mask
    sum_complex_single_st_7D = 0
    do i=1,size(p_array)
      if (present(mask)) then
        if( .not.p_mask(i) ) cycle
      end if
      sum_complex_single_st_7D = sum_complex_single_st_7D + p_array(i)
    end do

  end function sum_complex_single_st_7D

  function sum_complex_double_st_7D(array, mask)
    ! Dummy arguments declaration
    type(complex_double_st), dimension (:,:,:,:,:,:,:), intent(in), target, contiguous :: array
    logical,                 dimension (:,:,:,:,:,:,:), intent(in), optional, target, contiguous :: mask
    type(complex_double_st) :: sum_complex_double_st_7D
    ! Local declaration
    type(complex_double_st), dimension(:), pointer :: p_array
    logical,                 dimension(:), pointer :: p_mask
    integer i

    p_array(1:size(array)) => array
    if (present(mask)) p_mask(1:size(mask)) => mask
    sum_complex_double_st_7D = 0
    do i=1,size(p_array)
      if (present(mask)) then
        if( .not.p_mask(i) ) cycle
      end if
      sum_complex_double_st_7D = sum_complex_double_st_7D + p_array(i)
    end do

  end function sum_complex_double_st_7D


  function product_complex_single_st_1D(array, mask)
    ! Dummy arguments declaration
    type(complex_single_st), dimension (:), intent(in), target, contiguous :: array
    logical,                 dimension (:), intent(in), optional, target, contiguous :: mask
    type(complex_single_st) :: product_complex_single_st_1D
    ! Local declaration
    type(complex_single_st), dimension(:), pointer :: p_array
    logical,                 dimension(:), pointer :: p_mask
    integer i

    p_array(1:size(array)) => array
    if (present(mask)) p_mask(1:size(mask)) => mask
    product_complex_single_st_1D = 1
    do i=1,size(p_array)
      if (present(mask)) then
        if( .not.p_mask(i) ) cycle
      end if
      product_complex_single_st_1D = product_complex_single_st_1D * p_array(i) 
    end do

  end function product_complex_single_st_1D

  function product_complex_double_st_1D(array, mask)
    ! Dummy arguments declaration
    type(complex_double_st), dimension (:), intent(in), target, contiguous :: array
    logical,                 dimension (:), intent(in), optional, target, contiguous :: mask
    type(complex_double_st) :: product_complex_double_st_1D
    ! Local declaration
    type(complex_double_st), dimension(:), pointer :: p_array
    logical,                 dimension(:), pointer :: p_mask
    integer i

    p_array(1:size(array)) => array
    if (present(mask)) p_mask(1:size(mask)) => mask
    product_complex_double_st_1D = 1
    do i=1,size(p_array)
      if (present(mask)) then
        if( .not.p_mask(i) ) cycle
      end if
      product_complex_double_st_1D = product_complex_double_st_1D * p_array(i) 
    end do

  end function product_complex_double_st_1D

  function product_complex_single_st_2D(array, mask)
    ! Dummy arguments declaration
    type(complex_single_st), dimension (:,:), intent(in), target, contiguous :: array
    logical,                 dimension (:,:), intent(in), optional, target, contiguous :: mask
    type(complex_single_st) :: product_complex_single_st_2D
    ! Local declaration
    type(complex_single_st), dimension(:), pointer :: p_array
    logical,                 dimension(:), pointer :: p_mask
    integer i

    p_array(1:size(array)) => array
    if (present(mask)) p_mask(1:size(mask)) => mask
    product_complex_single_st_2D = 1
    do i=1,size(p_array)
      if (present(mask)) then
        if( .not.p_mask(i) ) cycle
      end if
      product_complex_single_st_2D = product_complex_single_st_2D * p_array(i) 
    end do

  end function product_complex_single_st_2D

  function product_complex_double_st_2D(array, mask)
    ! Dummy arguments declaration
    type(complex_double_st), dimension (:,:), intent(in), target, contiguous :: array
    logical,                 dimension (:,:), intent(in), optional, target, contiguous :: mask
    type(complex_double_st) :: product_complex_double_st_2D
    ! Local declaration
    type(complex_double_st), dimension(:), pointer :: p_array
    logical,                 dimension(:), pointer :: p_mask
    integer i

    p_array(1:size(array)) => array
    if (present(mask)) p_mask(1:size(mask)) => mask
    product_complex_double_st_2D = 1
    do i=1,size(p_array)
      if (present(mask)) then
        if( .not.p_mask(i) ) cycle
      end if
      product_complex_double_st_2D = product_complex_double_st_2D * p_array(i) 
    end do

  end function product_complex_double_st_2D

  function product_complex_single_st_3D(array, mask)
    ! Dummy arguments declaration
    type(complex_single_st), dimension (:,:,:), intent(in), target, contiguous :: array
    logical,                 dimension (:,:,:), intent(in), optional, target, contiguous :: mask
    type(complex_single_st) :: product_complex_single_st_3D
    ! Local declaration
    type(complex_single_st), dimension(:), pointer :: p_array
    logical,                 dimension(:), pointer :: p_mask
    integer i

    p_array(1:size(array)) => array
    if (present(mask)) p_mask(1:size(mask)) => mask
    product_complex_single_st_3D = 1
    do i=1,size(p_array)
      if (present(mask)) then
        if( .not.p_mask(i) ) cycle
      end if
      product_complex_single_st_3D = product_complex_single_st_3D * p_array(i) 
    end do

  end function product_complex_single_st_3D

  function product_complex_double_st_3D(array, mask)
    ! Dummy arguments declaration
    type(complex_double_st), dimension (:,:,:), intent(in), target, contiguous :: array
    logical,                 dimension (:,:,:), intent(in), optional, target, contiguous :: mask
    type(complex_double_st) :: product_complex_double_st_3D
    ! Local declaration
    type(complex_double_st), dimension(:), pointer :: p_array
    logical,                 dimension(:), pointer :: p_mask
    integer i

    p_array(1:size(array)) => array
    if (present(mask)) p_mask(1:size(mask)) => mask
    product_complex_double_st_3D = 1
    do i=1,size(p_array)
      if (present(mask)) then
        if( .not.p_mask(i) ) cycle
      end if
      product_complex_double_st_3D = product_complex_double_st_3D * p_array(i) 
    end do

  end function product_complex_double_st_3D

  function product_complex_single_st_4D(array, mask)
    ! Dummy arguments declaration
    type(complex_single_st), dimension (:,:,:,:), intent(in), target, contiguous :: array
    logical,                 dimension (:,:,:,:), intent(in), optional, target, contiguous :: mask
    type(complex_single_st) :: product_complex_single_st_4D
    ! Local declaration
    type(complex_single_st), dimension(:), pointer :: p_array
    logical,                 dimension(:), pointer :: p_mask
    integer i

    p_array(1:size(array)) => array
    if (present(mask)) p_mask(1:size(mask)) => mask
    product_complex_single_st_4D = 1
    do i=1,size(p_array)
      if (present(mask)) then
        if( .not.p_mask(i) ) cycle
      end if
      product_complex_single_st_4D = product_complex_single_st_4D * p_array(i) 
    end do

  end function product_complex_single_st_4D

  function product_complex_double_st_4D(array, mask)
    ! Dummy arguments declaration
    type(complex_double_st), dimension (:,:,:,:), intent(in), target, contiguous :: array
    logical,                 dimension (:,:,:,:), intent(in), optional, target, contiguous :: mask
    type(complex_double_st) :: product_complex_double_st_4D
    ! Local declaration
    type(complex_double_st), dimension(:), pointer :: p_array
    logical,                 dimension(:), pointer :: p_mask
    integer i

    p_array(1:size(array)) => array
    if (present(mask)) p_mask(1:size(mask)) => mask
    product_complex_double_st_4D = 1
    do i=1,size(p_array)
      if (present(mask)) then
        if( .not.p_mask(i) ) cycle
      end if
      product_complex_double_st_4D = product_complex_double_st_4D * p_array(i) 
    end do

  end function product_complex_double_st_4D

  function product_complex_single_st_5D(array, mask)
    ! Dummy arguments declaration
    type(complex_single_st), dimension (:,:,:,:,:), intent(in), target, contiguous :: array
    logical,                 dimension (:,:,:,:,:), intent(in), optional, target, contiguous :: mask
    type(complex_single_st) :: product_complex_single_st_5D
    ! Local declaration
    type(complex_single_st), dimension(:), pointer :: p_array
    logical,                 dimension(:), pointer :: p_mask
    integer i

    p_array(1:size(array)) => array
    if (present(mask)) p_mask(1:size(mask)) => mask
    product_complex_single_st_5D = 1
    do i=1,size(p_array)
      if (present(mask)) then
        if( .not.p_mask(i) ) cycle
      end if
      product_complex_single_st_5D = product_complex_single_st_5D * p_array(i) 
    end do

  end function product_complex_single_st_5D

  function product_complex_double_st_5D(array, mask)
    ! Dummy arguments declaration
    type(complex_double_st), dimension (:,:,:,:,:), intent(in), target, contiguous :: array
    logical,                 dimension (:,:,:,:,:), intent(in), optional, target, contiguous :: mask
    type(complex_double_st) :: product_complex_double_st_5D
    ! Local declaration
    type(complex_double_st), dimension(:), pointer :: p_array
    logical,                 dimension(:), pointer :: p_mask
    integer i

    p_array(1:size(array)) => array
    if (present(mask)) p_mask(1:size(mask)) => mask
    product_complex_double_st_5D = 1
    do i=1,size(p_array)
      if (present(mask)) then
        if( .not.p_mask(i) ) cycle
      end if
      product_complex_double_st_5D = product_complex_double_st_5D * p_array(i) 
    end do

  end function product_complex_double_st_5D

  function product_complex_single_st_6D(array, mask)
    ! Dummy arguments declaration
    type(complex_single_st), dimension (:,:,:,:,:,:), intent(in), target, contiguous :: array
    logical,                 dimension (:,:,:,:,:,:), intent(in), optional, target, contiguous :: mask
    type(complex_single_st) :: product_complex_single_st_6D
    ! Local declaration
    type(complex_single_st), dimension(:), pointer :: p_array
    logical,                 dimension(:), pointer :: p_mask
    integer i

    p_array(1:size(array)) => array
    if (present(mask)) p_mask(1:size(mask)) => mask
    product_complex_single_st_6D = 1
    do i=1,size(p_array)
      if (present(mask)) then
        if( .not.p_mask(i) ) cycle
      end if
      product_complex_single_st_6D = product_complex_single_st_6D * p_array(i) 
    end do

  end function product_complex_single_st_6D

  function product_complex_double_st_6D(array, mask)
    ! Dummy arguments declaration
    type(complex_double_st), dimension (:,:,:,:,:,:), intent(in), target, contiguous :: array
    logical,                 dimension (:,:,:,:,:,:), intent(in), optional, target, contiguous :: mask
    type(complex_double_st) :: product_complex_double_st_6D
    ! Local declaration
    type(complex_double_st), dimension(:), pointer :: p_array
    logical,                 dimension(:), pointer :: p_mask
    integer i

    p_array(1:size(array)) => array
    if (present(mask)) p_mask(1:size(mask)) => mask
    product_complex_double_st_6D = 1
    do i=1,size(p_array)
      if (present(mask)) then
        if( .not.p_mask(i) ) cycle
      end if
      product_complex_double_st_6D = product_complex_double_st_6D * p_array(i) 
    end do

  end function product_complex_double_st_6D

  function product_complex_single_st_7D(array, mask)
    ! Dummy arguments declaration
    type(complex_single_st), dimension (:,:,:,:,:,:,:), intent(in), target, contiguous :: array
    logical,                 dimension (:,:,:,:,:,:,:), intent(in), optional, target, contiguous :: mask
    type(complex_single_st) :: product_complex_single_st_7D
    ! Local declaration
    type(complex_single_st), dimension(:), pointer :: p_array
    logical,                 dimension(:), pointer :: p_mask
    integer i

    p_array(1:size(array)) => array
    if (present(mask)) p_mask(1:size(mask)) => mask
    product_complex_single_st_7D = 1
    do i=1,size(p_array)
      if (present(mask)) then
        if( .not.p_mask(i) ) cycle
      end if
      product_complex_single_st_7D = product_complex_single_st_7D * p_array(i) 
    end do

  end function product_complex_single_st_7D

  function product_complex_double_st_7D(array, mask)
    ! Dummy arguments declaration
    type(complex_double_st), dimension (:,:,:,:,:,:,:), intent(in), target, contiguous :: array
    logical,                 dimension (:,:,:,:,:,:,:), intent(in), optional, target, contiguous :: mask
    type(complex_double_st) :: product_complex_double_st_7D
    ! Local declaration
    type(complex_double_st), dimension(:), pointer :: p_array
    logical,                 dimension(:), pointer :: p_mask
    integer i

    p_array(1:size(array)) => array
    if (present(mask)) p_mask(1:size(mask)) => mask
    product_complex_double_st_7D = 1
    do i=1,size(p_array)
      if (present(mask)) then
        if( .not.p_mask(i) ) cycle
      end if
      product_complex_double_st_7D = product_complex_double_st_7D * p_array(i) 
    end do

  end function product_complex_double_st_7D




  function sum_complex_single_st_dim_1D(array, dim, mask)
    use ISO_FORTRAN_ENV, only : ERROR_UNIT
    ! Dummy arguments declaration
    type(complex_single_st), dimension(:), intent(in) :: array
    logical,       optional, dimension(:), intent(in) :: mask
    integer,                               intent(in) :: dim
    type(complex_single_st) :: sum_complex_single_st_dim_1D

    select case(dim)
      case (1)
        if (present(mask)) then
          sum_complex_single_st_dim_1D = sum(array, mask)
        else
          sum_complex_single_st_dim_1D = sum(array)
        end if
      case default
        write(ERROR_UNIT, *) "Incorrect value of DIM argument."
        sum_complex_single_st_dim_1D = 0.
    end select
  end function sum_complex_single_st_dim_1D

  function sum_complex_double_st_dim_1D(array, dim, mask)
    use ISO_FORTRAN_ENV, only : ERROR_UNIT
    ! Dummy arguments declaration
    type(complex_double_st), dimension(:), intent(in) :: array
    logical,       optional, dimension(:), intent(in) :: mask
    integer,                               intent(in) :: dim
    type(complex_double_st) :: sum_complex_double_st_dim_1D

    select case(dim)
      case (1)
        if (present(mask)) then
          sum_complex_double_st_dim_1D = sum(array, mask)
        else
          sum_complex_double_st_dim_1D = sum(array)
        end if
      case default
        write(ERROR_UNIT, *) "Incorrect value of DIM argument."
        sum_complex_double_st_dim_1D = 0.d0
    end select
  end function sum_complex_double_st_dim_1D

  function product_complex_single_st_dim_1D(array, dim, mask)
    use ISO_FORTRAN_ENV, only : ERROR_UNIT
    ! Dummy arguments declaration
    type(complex_single_st), dimension(:), intent(in) :: array
    logical,       optional, dimension(:), intent(in) :: mask
    integer,                               intent(in) :: dim
    type(complex_single_st) :: product_complex_single_st_dim_1D

    select case(dim)
      case (1)
        if (present(mask)) then
          product_complex_single_st_dim_1D = product(array, mask)
        else
          product_complex_single_st_dim_1D = product(array)
        end if
      case default
        write(ERROR_UNIT, *) "Incorrect value of DIM argument."
        product_complex_single_st_dim_1D = 1. 
    end select
  end function product_complex_single_st_dim_1D

  function product_complex_double_st_dim_1D(array, dim, mask)
    use ISO_FORTRAN_ENV, only : ERROR_UNIT
    ! Dummy arguments declaration
    type(complex_double_st), dimension(:), intent(in) :: array
    logical,       optional, dimension(:), intent(in) :: mask
    integer,                               intent(in) :: dim
    type(complex_double_st) :: product_complex_double_st_dim_1D

    select case(dim)
      case (1)
        if (present(mask)) then
          product_complex_double_st_dim_1D = product(array, mask)
        else
          product_complex_double_st_dim_1D = product(array)
        end if
      case default
        write(ERROR_UNIT, *) "Incorrect value of DIM argument."
        product_complex_double_st_dim_1D = 1.d0 
    end select
  end function product_complex_double_st_dim_1D




  function sum_complex_single_st_dim_2D(array, dim, mask)
    use ISO_FORTRAN_ENV, only : ERROR_UNIT
    ! Dummy arguments declaration
    type(complex_single_st), dimension(:,:), intent(in) :: array
    logical,       optional, dimension(:,:), intent(in) :: mask
    integer,                                 intent(in) :: dim
    type(complex_single_st), dimension(:), allocatable :: sum_complex_single_st_dim_2D
    ! Local declaration
    integer i1

    select case (dim)
      case (1)
        allocate( sum_complex_single_st_dim_2D(size(array,2)) ) 
        do i1=1,size(sum_complex_single_st_dim_2D,1)
          if (present(mask)) then
            sum_complex_single_st_dim_2D(i1) = sum(array(:,i1), mask(:,i1))
          else
            sum_complex_single_st_dim_2D(i1) = sum(array(:,i1))
          end if
        end do
      case (2)
        allocate( sum_complex_single_st_dim_2D(size(array,1)) ) 
        do i1=1,size(sum_complex_single_st_dim_2D,1)
          if (present(mask)) then
            sum_complex_single_st_dim_2D(i1) = sum(array(i1,:), mask(i1,:))
          else
            sum_complex_single_st_dim_2D(i1) = sum(array(i1,:))
          end if
        end do
      case default
        allocate( sum_complex_single_st_dim_2D(0) ) 
        write(ERROR_UNIT, *) "Incorrect value of DIM argument :"
        write(ERROR_UNIT, *) "a zero-sized array has been returned."
    end select
  end function sum_complex_single_st_dim_2D

  function sum_complex_double_st_dim_2D(array, dim, mask)
    use ISO_FORTRAN_ENV, only : ERROR_UNIT
    ! Dummy arguments declaration
    type(complex_double_st), dimension(:,:), intent(in) :: array
    logical,       optional, dimension(:,:), intent(in) :: mask
    integer,                                 intent(in) :: dim
    type(complex_double_st), dimension(:), allocatable :: sum_complex_double_st_dim_2D
    ! Local declaration
    integer i1

    select case (dim)
      case (1)
        allocate( sum_complex_double_st_dim_2D(size(array,2)) ) 
        do i1=1,size(sum_complex_double_st_dim_2D,1)
          if (present(mask)) then
            sum_complex_double_st_dim_2D(i1) = sum(array(:,i1), mask(:,i1))
          else
            sum_complex_double_st_dim_2D(i1) = sum(array(:,i1))
          end if
        end do
      case (2)
        allocate( sum_complex_double_st_dim_2D(size(array,1)) ) 
        do i1=1,size(sum_complex_double_st_dim_2D,1)
          if (present(mask)) then
            sum_complex_double_st_dim_2D(i1) = sum(array(i1,:), mask(i1,:))
          else
            sum_complex_double_st_dim_2D(i1) = sum(array(i1,:))
          end if
        end do
      case default
        allocate( sum_complex_double_st_dim_2D(0) ) 
        write(ERROR_UNIT, *) "Incorrect value of DIM argument :"
        write(ERROR_UNIT, *) "a zero-sized array has been returned."
    end select
  end function sum_complex_double_st_dim_2D

  function product_complex_single_st_dim_2D(array, dim, mask)
    use ISO_FORTRAN_ENV, only : ERROR_UNIT
    ! Dummy arguments declaration
    type(complex_single_st), dimension(:,:), intent(in) :: array
    logical,       optional, dimension(:,:), intent(in) :: mask
    integer,                                 intent(in) :: dim
    type(complex_single_st), dimension(:), allocatable :: product_complex_single_st_dim_2D
    ! Local declaration
    integer i1

    select case (dim)
      case (1)
        allocate( product_complex_single_st_dim_2D(size(array,2)) ) 
        do i1=1,size(product_complex_single_st_dim_2D,1)
          if (present(mask)) then
            product_complex_single_st_dim_2D(i1) = product(array(:,i1), mask(:,i1))
          else
            product_complex_single_st_dim_2D(i1) = product(array(:,i1))
          end if
        end do
      case (2)
        allocate( product_complex_single_st_dim_2D(size(array,1)) ) 
        do i1=1,size(product_complex_single_st_dim_2D,1)
          if (present(mask)) then
            product_complex_single_st_dim_2D(i1) = product(array(i1,:), mask(i1,:))
          else
            product_complex_single_st_dim_2D(i1) = product(array(i1,:))
          end if
        end do
      case default
        allocate( product_complex_single_st_dim_2D(0) ) 
        write(ERROR_UNIT, *) "Incorrect value of DIM argument :"
        write(ERROR_UNIT, *) "a zero-sized array has been returned."
    end select
  end function product_complex_single_st_dim_2D

  function product_complex_double_st_dim_2D(array, dim, mask)
    use ISO_FORTRAN_ENV, only : ERROR_UNIT
    ! Dummy arguments declaration
    type(complex_double_st), dimension(:,:), intent(in) :: array
    logical,       optional, dimension(:,:), intent(in) :: mask
    integer,                                 intent(in) :: dim
    type(complex_double_st), dimension(:), allocatable :: product_complex_double_st_dim_2D
    ! Local declaration
    integer i1

    select case (dim)
      case (1)
        allocate( product_complex_double_st_dim_2D(size(array,2)) ) 
        do i1=1,size(product_complex_double_st_dim_2D,1)
          if (present(mask)) then
            product_complex_double_st_dim_2D(i1) = product(array(:,i1), mask(:,i1))
          else
            product_complex_double_st_dim_2D(i1) = product(array(:,i1))
          end if
        end do
      case (2)
        allocate( product_complex_double_st_dim_2D(size(array,1)) ) 
        do i1=1,size(product_complex_double_st_dim_2D,1)
          if (present(mask)) then
            product_complex_double_st_dim_2D(i1) = product(array(i1,:), mask(i1,:))
          else
            product_complex_double_st_dim_2D(i1) = product(array(i1,:))
          end if
        end do
      case default
        allocate( product_complex_double_st_dim_2D(0) ) 
        write(ERROR_UNIT, *) "Incorrect value of DIM argument :"
        write(ERROR_UNIT, *) "a zero-sized array has been returned."
    end select
  end function product_complex_double_st_dim_2D




  function sum_complex_single_st_dim_3D(array, dim, mask)
    use ISO_FORTRAN_ENV, only : ERROR_UNIT
    ! Dummy arguments declaration
    type(complex_single_st), dimension(:,:,:), intent(in) :: array
    logical,       optional, dimension(:,:,:), intent(in) :: mask
    integer,                                   intent(in) :: dim
    type(complex_single_st), dimension(:,:), allocatable :: sum_complex_single_st_dim_3D
    ! Local declaration
    integer i1, i2

    select case (dim)
      case (1)
        allocate( sum_complex_single_st_dim_3D(size(array,2), size(array,3)) ) 
        do i2=1,size(sum_complex_single_st_dim_3D,2)
          do i1=1,size(sum_complex_single_st_dim_3D,1)
            if (present(mask)) then
              sum_complex_single_st_dim_3D(i1,i2) = sum(array(:,i1,i2), mask(:,i1,i2))
            else
              sum_complex_single_st_dim_3D(i1,i2) = sum(array(:,i1,i2))
            end if
          end do
        end do
      case (2)
        allocate( sum_complex_single_st_dim_3D(size(array,1), size(array,3)) ) 
        do i2=1,size(sum_complex_single_st_dim_3D,2)
          do i1=1,size(sum_complex_single_st_dim_3D,1)
            if (present(mask)) then
              sum_complex_single_st_dim_3D(i1,i2) = sum(array(i1,:,i2), mask(i1,:,i2))
            else
              sum_complex_single_st_dim_3D(i1,i2) = sum(array(i1,:,i2))
            end if
          end do
        end do
      case (3)
        allocate( sum_complex_single_st_dim_3D(size(array,1), size(array,2)) ) 
        do i2=1,size(sum_complex_single_st_dim_3D,2)
          do i1=1,size(sum_complex_single_st_dim_3D,1)
            if (present(mask)) then
              sum_complex_single_st_dim_3D(i1,i2) = sum(array(i1,i2,:), mask(i1,i2,:))
            else
              sum_complex_single_st_dim_3D(i1,i2) = sum(array(i1,i2,:))
            end if
          end do
        end do
      case default
        allocate( sum_complex_single_st_dim_3D(0,0) ) 
        write(ERROR_UNIT, *) "Incorrect value of DIM argument :"
        write(ERROR_UNIT, *) "a zero-sized array has been returned."
    end select
  end function sum_complex_single_st_dim_3D

  function sum_complex_double_st_dim_3D(array, dim, mask)
    use ISO_FORTRAN_ENV, only : ERROR_UNIT
    ! Dummy arguments declaration
    type(complex_double_st), dimension(:,:,:), intent(in) :: array
    logical,       optional, dimension(:,:,:), intent(in) :: mask
    integer,                                   intent(in) :: dim
    type(complex_double_st), dimension(:,:), allocatable :: sum_complex_double_st_dim_3D
    ! Local declaration
    integer i1, i2

    select case (dim)
      case (1)
        allocate( sum_complex_double_st_dim_3D(size(array,2), size(array,3)) ) 
        do i2=1,size(sum_complex_double_st_dim_3D,2)
          do i1=1,size(sum_complex_double_st_dim_3D,1)
            if (present(mask)) then
              sum_complex_double_st_dim_3D(i1,i2) = sum(array(:,i1,i2), mask(:,i1,i2))
            else
              sum_complex_double_st_dim_3D(i1,i2) = sum(array(:,i1,i2))
            end if
          end do
        end do
      case (2)
        allocate( sum_complex_double_st_dim_3D(size(array,1), size(array,3)) ) 
        do i2=1,size(sum_complex_double_st_dim_3D,2)
          do i1=1,size(sum_complex_double_st_dim_3D,1)
            if (present(mask)) then
              sum_complex_double_st_dim_3D(i1,i2) = sum(array(i1,:,i2), mask(i1,:,i2))
            else
              sum_complex_double_st_dim_3D(i1,i2) = sum(array(i1,:,i2))
            end if
          end do
        end do
      case (3)
        allocate( sum_complex_double_st_dim_3D(size(array,1), size(array,2)) ) 
        do i2=1,size(sum_complex_double_st_dim_3D,2)
          do i1=1,size(sum_complex_double_st_dim_3D,1)
            if (present(mask)) then
              sum_complex_double_st_dim_3D(i1,i2) = sum(array(i1,i2,:), mask(i1,i2,:))
            else
              sum_complex_double_st_dim_3D(i1,i2) = sum(array(i1,i2,:))
            end if
          end do
        end do
      case default
        allocate( sum_complex_double_st_dim_3D(0,0) ) 
        write(ERROR_UNIT, *) "Incorrect value of DIM argument :"
        write(ERROR_UNIT, *) "a zero-sized array has been returned."
    end select
  end function sum_complex_double_st_dim_3D

  function product_complex_single_st_dim_3D(array, dim, mask)
    use ISO_FORTRAN_ENV, only : ERROR_UNIT
    ! Dummy arguments declaration
    type(complex_single_st), dimension(:,:,:), intent(in) :: array
    logical,       optional, dimension(:,:,:), intent(in) :: mask
    integer,                                   intent(in) :: dim
    type(complex_single_st), dimension(:,:), allocatable :: product_complex_single_st_dim_3D
    ! Local declaration
    integer i1, i2

    select case (dim)
      case (1)
        allocate( product_complex_single_st_dim_3D(size(array,2), size(array,3)) ) 
        do i2=1,size(product_complex_single_st_dim_3D,2)
          do i1=1,size(product_complex_single_st_dim_3D,1)
            if (present(mask)) then
              product_complex_single_st_dim_3D(i1,i2) = product(array(:,i1,i2), mask(:,i1,i2))
            else
              product_complex_single_st_dim_3D(i1,i2) = product(array(:,i1,i2))
            end if
          end do
        end do
      case (2)
        allocate( product_complex_single_st_dim_3D(size(array,1), size(array,3)) ) 
        do i2=1,size(product_complex_single_st_dim_3D,2)
          do i1=1,size(product_complex_single_st_dim_3D,1)
            if (present(mask)) then
              product_complex_single_st_dim_3D(i1,i2) = product(array(i1,:,i2), mask(i1,:,i2))
            else
              product_complex_single_st_dim_3D(i1,i2) = product(array(i1,:,i2))
            end if
          end do
        end do
      case (3)
        allocate( product_complex_single_st_dim_3D(size(array,1), size(array,2)) ) 
        do i2=1,size(product_complex_single_st_dim_3D,2)
          do i1=1,size(product_complex_single_st_dim_3D,1)
            if (present(mask)) then
              product_complex_single_st_dim_3D(i1,i2) = product(array(i1,i2,:), mask(i1,i2,:))
            else
              product_complex_single_st_dim_3D(i1,i2) = product(array(i1,i2,:))
            end if
          end do
        end do
      case default
        allocate( product_complex_single_st_dim_3D(0,0) ) 
        write(ERROR_UNIT, *) "Incorrect value of DIM argument :"
        write(ERROR_UNIT, *) "a zero-sized array has been returned."
    end select
  end function product_complex_single_st_dim_3D

  function product_complex_double_st_dim_3D(array, dim, mask)
    use ISO_FORTRAN_ENV, only : ERROR_UNIT
    ! Dummy arguments declaration
    type(complex_double_st), dimension(:,:,:), intent(in) :: array
    logical,       optional, dimension(:,:,:), intent(in) :: mask
    integer,                                   intent(in) :: dim
    type(complex_double_st), dimension(:,:), allocatable :: product_complex_double_st_dim_3D
    ! Local declaration
    integer i1, i2

    select case (dim)
      case (1)
        allocate( product_complex_double_st_dim_3D(size(array,2), size(array,3)) ) 
        do i2=1,size(product_complex_double_st_dim_3D,2)
          do i1=1,size(product_complex_double_st_dim_3D,1)
            if (present(mask)) then
              product_complex_double_st_dim_3D(i1,i2) = product(array(:,i1,i2), mask(:,i1,i2))
            else
              product_complex_double_st_dim_3D(i1,i2) = product(array(:,i1,i2))
            end if
          end do
        end do
      case (2)
        allocate( product_complex_double_st_dim_3D(size(array,1), size(array,3)) ) 
        do i2=1,size(product_complex_double_st_dim_3D,2)
          do i1=1,size(product_complex_double_st_dim_3D,1)
            if (present(mask)) then
              product_complex_double_st_dim_3D(i1,i2) = product(array(i1,:,i2), mask(i1,:,i2))
            else
              product_complex_double_st_dim_3D(i1,i2) = product(array(i1,:,i2))
            end if
          end do
        end do
      case (3)
        allocate( product_complex_double_st_dim_3D(size(array,1), size(array,2)) ) 
        do i2=1,size(product_complex_double_st_dim_3D,2)
          do i1=1,size(product_complex_double_st_dim_3D,1)
            if (present(mask)) then
              product_complex_double_st_dim_3D(i1,i2) = product(array(i1,i2,:), mask(i1,i2,:))
            else
              product_complex_double_st_dim_3D(i1,i2) = product(array(i1,i2,:))
            end if
          end do
        end do
      case default
        allocate( product_complex_double_st_dim_3D(0,0) ) 
        write(ERROR_UNIT, *) "Incorrect value of DIM argument :"
        write(ERROR_UNIT, *) "a zero-sized array has been returned."
    end select
  end function product_complex_double_st_dim_3D




  function sum_complex_single_st_dim_4D(array, dim, mask)
    use ISO_FORTRAN_ENV, only : ERROR_UNIT
    ! Dummy arguments declaration
    type(complex_single_st), dimension(:,:,:,:), intent(in) :: array
    logical,       optional, dimension(:,:,:,:), intent(in) :: mask
    integer,                                     intent(in) :: dim
    type(complex_single_st), dimension(:,:,:), allocatable :: sum_complex_single_st_dim_4D
    ! Local declaration
    integer i1, i2, i3

    select case (dim)
      case (1)
        allocate( sum_complex_single_st_dim_4D(size(array,2), size(array,3), size(array,4)) ) 
        do i3=1,size(sum_complex_single_st_dim_4D,3)
          do i2=1,size(sum_complex_single_st_dim_4D,2)
            do i1=1,size(sum_complex_single_st_dim_4D,1)
              if (present(mask)) then
                sum_complex_single_st_dim_4D(i1,i2,i3) = sum(array(:,i1,i2,i3), mask(:,i1,i2,i3))
              else
                sum_complex_single_st_dim_4D(i1,i2,i3) = sum(array(:,i1,i2,i3))
              end if
            end do
          end do
        end do
      case (2)
        allocate( sum_complex_single_st_dim_4D(size(array,1), size(array,3), size(array,4)) ) 
        do i3=1,size(sum_complex_single_st_dim_4D,3)
          do i2=1,size(sum_complex_single_st_dim_4D,2)
            do i1=1,size(sum_complex_single_st_dim_4D,1)
              if (present(mask)) then
                sum_complex_single_st_dim_4D(i1,i2,i3) = sum(array(i1,:,i2,i3), mask(i1,:,i2,i3))
              else
                sum_complex_single_st_dim_4D(i1,i2,i3) = sum(array(i1,:,i2,i3))
              end if
            end do
          end do
        end do
      case (3)
        allocate( sum_complex_single_st_dim_4D(size(array,1), size(array,2), size(array,4)) ) 
        do i3=1,size(sum_complex_single_st_dim_4D,3)
          do i2=1,size(sum_complex_single_st_dim_4D,2)
            do i1=1,size(sum_complex_single_st_dim_4D,1)
              if (present(mask)) then
                sum_complex_single_st_dim_4D(i1,i2,i3) = sum(array(i1,i2,:,i3), mask(i1,i2,:,i3))
              else
                sum_complex_single_st_dim_4D(i1,i2,i3) = sum(array(i1,i2,:,i3))
              end if
            end do
          end do
        end do
      case (4)
        allocate( sum_complex_single_st_dim_4D(size(array,1), size(array,2), size(array,3)) ) 
        do i3=1,size(sum_complex_single_st_dim_4D,3)
          do i2=1,size(sum_complex_single_st_dim_4D,2)
            do i1=1,size(sum_complex_single_st_dim_4D,1)
              if (present(mask)) then
                sum_complex_single_st_dim_4D(i1,i2,i3) = sum(array(i1,i2,i3,:), mask(i1,i2,i3,:))
              else
                sum_complex_single_st_dim_4D(i1,i2,i3) = sum(array(i1,i2,i3,:))
              end if
            end do
          end do
        end do
      case default
        allocate( sum_complex_single_st_dim_4D(0,0,0) ) 
        write(ERROR_UNIT, *) "Incorrect value of DIM argument :"
        write(ERROR_UNIT, *) "a zero-sized array has been returned."
    end select
  end function sum_complex_single_st_dim_4D

  function sum_complex_double_st_dim_4D(array, dim, mask)
    use ISO_FORTRAN_ENV, only : ERROR_UNIT
    ! Dummy arguments declaration
    type(complex_double_st), dimension(:,:,:,:), intent(in) :: array
    logical,       optional, dimension(:,:,:,:), intent(in) :: mask
    integer,                                     intent(in) :: dim
    type(complex_double_st), dimension(:,:,:), allocatable :: sum_complex_double_st_dim_4D
    ! Local declaration
    integer i1, i2, i3

    select case (dim)
      case (1)
        allocate( sum_complex_double_st_dim_4D(size(array,2), size(array,3), size(array,4)) ) 
        do i3=1,size(sum_complex_double_st_dim_4D,3)
          do i2=1,size(sum_complex_double_st_dim_4D,2)
            do i1=1,size(sum_complex_double_st_dim_4D,1)
              if (present(mask)) then
                sum_complex_double_st_dim_4D(i1,i2,i3) = sum(array(:,i1,i2,i3), mask(:,i1,i2,i3))
              else
                sum_complex_double_st_dim_4D(i1,i2,i3) = sum(array(:,i1,i2,i3))
              end if
            end do
          end do
        end do
      case (2)
        allocate( sum_complex_double_st_dim_4D(size(array,1), size(array,3), size(array,4)) ) 
        do i3=1,size(sum_complex_double_st_dim_4D,3)
          do i2=1,size(sum_complex_double_st_dim_4D,2)
            do i1=1,size(sum_complex_double_st_dim_4D,1)
              if (present(mask)) then
                sum_complex_double_st_dim_4D(i1,i2,i3) = sum(array(i1,:,i2,i3), mask(i1,:,i2,i3))
              else
                sum_complex_double_st_dim_4D(i1,i2,i3) = sum(array(i1,:,i2,i3))
              end if
            end do
          end do
        end do
      case (3)
        allocate( sum_complex_double_st_dim_4D(size(array,1), size(array,2), size(array,4)) ) 
        do i3=1,size(sum_complex_double_st_dim_4D,3)
          do i2=1,size(sum_complex_double_st_dim_4D,2)
            do i1=1,size(sum_complex_double_st_dim_4D,1)
              if (present(mask)) then
                sum_complex_double_st_dim_4D(i1,i2,i3) = sum(array(i1,i2,:,i3), mask(i1,i2,:,i3))
              else
                sum_complex_double_st_dim_4D(i1,i2,i3) = sum(array(i1,i2,:,i3))
              end if
            end do
          end do
        end do
      case (4)
        allocate( sum_complex_double_st_dim_4D(size(array,1), size(array,2), size(array,3)) ) 
        do i3=1,size(sum_complex_double_st_dim_4D,3)
          do i2=1,size(sum_complex_double_st_dim_4D,2)
            do i1=1,size(sum_complex_double_st_dim_4D,1)
              if (present(mask)) then
                sum_complex_double_st_dim_4D(i1,i2,i3) = sum(array(i1,i2,i3,:), mask(i1,i2,i3,:))
              else
                sum_complex_double_st_dim_4D(i1,i2,i3) = sum(array(i1,i2,i3,:))
              end if
            end do
          end do
        end do
      case default
        allocate( sum_complex_double_st_dim_4D(0,0,0) ) 
        write(ERROR_UNIT, *) "Incorrect value of DIM argument :"
        write(ERROR_UNIT, *) "a zero-sized array has been returned."
    end select
  end function sum_complex_double_st_dim_4D

  function product_complex_single_st_dim_4D(array, dim, mask)
    use ISO_FORTRAN_ENV, only : ERROR_UNIT
    ! Dummy arguments declaration
    type(complex_single_st), dimension(:,:,:,:), intent(in) :: array
    logical,       optional, dimension(:,:,:,:), intent(in) :: mask
    integer,                                     intent(in) :: dim
    type(complex_single_st), dimension(:,:,:), allocatable :: product_complex_single_st_dim_4D
    ! Local declaration
    integer i1, i2, i3

    select case (dim)
      case (1)
        allocate( product_complex_single_st_dim_4D(size(array,2), size(array,3), size(array,4)) ) 
        do i3=1,size(product_complex_single_st_dim_4D,3)
          do i2=1,size(product_complex_single_st_dim_4D,2)
            do i1=1,size(product_complex_single_st_dim_4D,1)
              if (present(mask)) then
                product_complex_single_st_dim_4D(i1,i2,i3) = product(array(:,i1,i2,i3), mask(:,i1,i2,i3))
              else
                product_complex_single_st_dim_4D(i1,i2,i3) = product(array(:,i1,i2,i3))
              end if
            end do
          end do
        end do
      case (2)
        allocate( product_complex_single_st_dim_4D(size(array,1), size(array,3), size(array,4)) ) 
        do i3=1,size(product_complex_single_st_dim_4D,3)
          do i2=1,size(product_complex_single_st_dim_4D,2)
            do i1=1,size(product_complex_single_st_dim_4D,1)
              if (present(mask)) then
                product_complex_single_st_dim_4D(i1,i2,i3) = product(array(i1,:,i2,i3), mask(i1,:,i2,i3))
              else
                product_complex_single_st_dim_4D(i1,i2,i3) = product(array(i1,:,i2,i3))
              end if
            end do
          end do
        end do
      case (3)
        allocate( product_complex_single_st_dim_4D(size(array,1), size(array,2), size(array,4)) ) 
        do i3=1,size(product_complex_single_st_dim_4D,3)
          do i2=1,size(product_complex_single_st_dim_4D,2)
            do i1=1,size(product_complex_single_st_dim_4D,1)
              if (present(mask)) then
                product_complex_single_st_dim_4D(i1,i2,i3) = product(array(i1,i2,:,i3), mask(i1,i2,:,i3))
              else
                product_complex_single_st_dim_4D(i1,i2,i3) = product(array(i1,i2,:,i3))
              end if
            end do
          end do
        end do
      case (4)
        allocate( product_complex_single_st_dim_4D(size(array,1), size(array,2), size(array,3)) ) 
        do i3=1,size(product_complex_single_st_dim_4D,3)
          do i2=1,size(product_complex_single_st_dim_4D,2)
            do i1=1,size(product_complex_single_st_dim_4D,1)
              if (present(mask)) then
                product_complex_single_st_dim_4D(i1,i2,i3) = product(array(i1,i2,i3,:), mask(i1,i2,i3,:))
              else
                product_complex_single_st_dim_4D(i1,i2,i3) = product(array(i1,i2,i3,:))
              end if
            end do
          end do
        end do
      case default
        allocate( product_complex_single_st_dim_4D(0,0,0) ) 
        write(ERROR_UNIT, *) "Incorrect value of DIM argument :"
        write(ERROR_UNIT, *) "a zero-sized array has been returned."
    end select
  end function product_complex_single_st_dim_4D

  function product_complex_double_st_dim_4D(array, dim, mask)
    use ISO_FORTRAN_ENV, only : ERROR_UNIT
    ! Dummy arguments declaration
    type(complex_double_st), dimension(:,:,:,:), intent(in) :: array
    logical,       optional, dimension(:,:,:,:), intent(in) :: mask
    integer,                                     intent(in) :: dim
    type(complex_double_st), dimension(:,:,:), allocatable :: product_complex_double_st_dim_4D
    ! Local declaration
    integer i1, i2, i3

    select case (dim)
      case (1)
        allocate( product_complex_double_st_dim_4D(size(array,2), size(array,3), size(array,4)) ) 
        do i3=1,size(product_complex_double_st_dim_4D,3)
          do i2=1,size(product_complex_double_st_dim_4D,2)
            do i1=1,size(product_complex_double_st_dim_4D,1)
              if (present(mask)) then
                product_complex_double_st_dim_4D(i1,i2,i3) = product(array(:,i1,i2,i3), mask(:,i1,i2,i3))
              else
                product_complex_double_st_dim_4D(i1,i2,i3) = product(array(:,i1,i2,i3))
              end if
            end do
          end do
        end do
      case (2)
        allocate( product_complex_double_st_dim_4D(size(array,1), size(array,3), size(array,4)) ) 
        do i3=1,size(product_complex_double_st_dim_4D,3)
          do i2=1,size(product_complex_double_st_dim_4D,2)
            do i1=1,size(product_complex_double_st_dim_4D,1)
              if (present(mask)) then
                product_complex_double_st_dim_4D(i1,i2,i3) = product(array(i1,:,i2,i3), mask(i1,:,i2,i3))
              else
                product_complex_double_st_dim_4D(i1,i2,i3) = product(array(i1,:,i2,i3))
              end if
            end do
          end do
        end do
      case (3)
        allocate( product_complex_double_st_dim_4D(size(array,1), size(array,2), size(array,4)) ) 
        do i3=1,size(product_complex_double_st_dim_4D,3)
          do i2=1,size(product_complex_double_st_dim_4D,2)
            do i1=1,size(product_complex_double_st_dim_4D,1)
              if (present(mask)) then
                product_complex_double_st_dim_4D(i1,i2,i3) = product(array(i1,i2,:,i3), mask(i1,i2,:,i3))
              else
                product_complex_double_st_dim_4D(i1,i2,i3) = product(array(i1,i2,:,i3))
              end if
            end do
          end do
        end do
      case (4)
        allocate( product_complex_double_st_dim_4D(size(array,1), size(array,2), size(array,3)) ) 
        do i3=1,size(product_complex_double_st_dim_4D,3)
          do i2=1,size(product_complex_double_st_dim_4D,2)
            do i1=1,size(product_complex_double_st_dim_4D,1)
              if (present(mask)) then
                product_complex_double_st_dim_4D(i1,i2,i3) = product(array(i1,i2,i3,:), mask(i1,i2,i3,:))
              else
                product_complex_double_st_dim_4D(i1,i2,i3) = product(array(i1,i2,i3,:))
              end if
            end do
          end do
        end do
      case default
        allocate( product_complex_double_st_dim_4D(0,0,0) ) 
        write(ERROR_UNIT, *) "Incorrect value of DIM argument :"
        write(ERROR_UNIT, *) "a zero-sized array has been returned."
    end select
  end function product_complex_double_st_dim_4D




  function sum_complex_single_st_dim_5D(array, dim, mask)
    use ISO_FORTRAN_ENV, only : ERROR_UNIT
    ! Dummy arguments declaration
    type(complex_single_st), dimension(:,:,:,:,:), intent(in) :: array
    logical,       optional, dimension(:,:,:,:,:), intent(in) :: mask
    integer,                                       intent(in) :: dim
    type(complex_single_st), dimension(:,:,:,:), allocatable :: sum_complex_single_st_dim_5D
    ! Local declaration
    integer i1, i2, i3, i4

    select case (dim)
      case (1)
        allocate( sum_complex_single_st_dim_5D(size(array,2), size(array,3), size(array,4), size(array,5)) ) 
        do i4=1,size(sum_complex_single_st_dim_5D,4)
          do i3=1,size(sum_complex_single_st_dim_5D,3)
            do i2=1,size(sum_complex_single_st_dim_5D,2)
              do i1=1,size(sum_complex_single_st_dim_5D,1)
                if (present(mask)) then
                  sum_complex_single_st_dim_5D(i1,i2,i3,i4) = sum(array(:,i1,i2,i3,i4), mask(:,i1,i2,i3,i4))
                else
                  sum_complex_single_st_dim_5D(i1,i2,i3,i4) = sum(array(:,i1,i2,i3,i4))
                end if
              end do
            end do
          end do
        end do
      case (2)
        allocate( sum_complex_single_st_dim_5D(size(array,1), size(array,3), size(array,4), size(array,5)) ) 
        do i4=1,size(sum_complex_single_st_dim_5D,4)
          do i3=1,size(sum_complex_single_st_dim_5D,3)
            do i2=1,size(sum_complex_single_st_dim_5D,2)
              do i1=1,size(sum_complex_single_st_dim_5D,1)
                if (present(mask)) then
                  sum_complex_single_st_dim_5D(i1,i2,i3,i4) = sum(array(i1,:,i2,i3,i4), mask(i1,:,i2,i3,i4))
                else
                  sum_complex_single_st_dim_5D(i1,i2,i3,i4) = sum(array(i1,:,i2,i3,i4))
                end if
              end do
            end do
          end do
        end do
      case (3)
        allocate( sum_complex_single_st_dim_5D(size(array,1), size(array,2), size(array,4), size(array,5)) ) 
        do i4=1,size(sum_complex_single_st_dim_5D,4)
          do i3=1,size(sum_complex_single_st_dim_5D,3)
            do i2=1,size(sum_complex_single_st_dim_5D,2)
              do i1=1,size(sum_complex_single_st_dim_5D,1)
                if (present(mask)) then
                  sum_complex_single_st_dim_5D(i1,i2,i3,i4) = sum(array(i1,i2,:,i3,i4), mask(i1,i2,:,i3,i4))
                else
                  sum_complex_single_st_dim_5D(i1,i2,i3,i4) = sum(array(i1,i2,:,i3,i4))
                end if
              end do
            end do
          end do
        end do
      case (4)
        allocate( sum_complex_single_st_dim_5D(size(array,1), size(array,2), size(array,3), size(array,5) )) 
        do i4=1,size(sum_complex_single_st_dim_5D,4)
          do i3=1,size(sum_complex_single_st_dim_5D,3)
            do i2=1,size(sum_complex_single_st_dim_5D,2)
              do i1=1,size(sum_complex_single_st_dim_5D,1)
                if (present(mask)) then
                  sum_complex_single_st_dim_5D(i1,i2,i3,i4) = sum(array(i1,i2,i3,:,i4), mask(i1,i2,i3,:,i4))
                else
                  sum_complex_single_st_dim_5D(i1,i2,i3,i4) = sum(array(i1,i2,i3,:,i4))
                end if
              end do
            end do
          end do
        end do
      case (5)
        allocate( sum_complex_single_st_dim_5D(size(array,1), size(array,2), size(array,3), size(array,4)) ) 
        do i4=1,size(sum_complex_single_st_dim_5D,4)
          do i3=1,size(sum_complex_single_st_dim_5D,3)
            do i2=1,size(sum_complex_single_st_dim_5D,2)
              do i1=1,size(sum_complex_single_st_dim_5D,1)
                if (present(mask)) then
                  sum_complex_single_st_dim_5D(i1,i2,i3,i4) = sum(array(i1,i2,i3,i4,:), mask(i1,i2,i3,i4,:))
                else
                  sum_complex_single_st_dim_5D(i1,i2,i3,i4) = sum(array(i1,i2,i3,i4,:))
                end if
              end do
            end do
          end do
        end do
      case default
        allocate( sum_complex_single_st_dim_5D(0,0,0,0) ) 
        write(ERROR_UNIT, *) "Incorrect value of DIM argument :"
        write(ERROR_UNIT, *) "a zero-sized array has been returned."
    end select
  end function sum_complex_single_st_dim_5D

  function sum_complex_double_st_dim_5D(array, dim, mask)
    use ISO_FORTRAN_ENV, only : ERROR_UNIT
    ! Dummy arguments declaration
    type(complex_double_st), dimension(:,:,:,:,:), intent(in) :: array
    logical,       optional, dimension(:,:,:,:,:), intent(in) :: mask
    integer,                                       intent(in) :: dim
    type(complex_double_st), dimension(:,:,:,:), allocatable :: sum_complex_double_st_dim_5D
    ! Local declaration
    integer i1, i2, i3, i4

    select case (dim)
      case (1)
        allocate( sum_complex_double_st_dim_5D(size(array,2), size(array,3), size(array,4), size(array,5)) ) 
        do i4=1,size(sum_complex_double_st_dim_5D,4)
          do i3=1,size(sum_complex_double_st_dim_5D,3)
            do i2=1,size(sum_complex_double_st_dim_5D,2)
              do i1=1,size(sum_complex_double_st_dim_5D,1)
                if (present(mask)) then
                  sum_complex_double_st_dim_5D(i1,i2,i3,i4) = sum(array(:,i1,i2,i3,i4), mask(:,i1,i2,i3,i4))
                else
                  sum_complex_double_st_dim_5D(i1,i2,i3,i4) = sum(array(:,i1,i2,i3,i4))
                end if
              end do
            end do
          end do
        end do
      case (2)
        allocate( sum_complex_double_st_dim_5D(size(array,1), size(array,3), size(array,4), size(array,5)) ) 
        do i4=1,size(sum_complex_double_st_dim_5D,4)
          do i3=1,size(sum_complex_double_st_dim_5D,3)
            do i2=1,size(sum_complex_double_st_dim_5D,2)
              do i1=1,size(sum_complex_double_st_dim_5D,1)
                if (present(mask)) then
                  sum_complex_double_st_dim_5D(i1,i2,i3,i4) = sum(array(i1,:,i2,i3,i4), mask(i1,:,i2,i3,i4))
                else
                  sum_complex_double_st_dim_5D(i1,i2,i3,i4) = sum(array(i1,:,i2,i3,i4))
                end if
              end do
            end do
          end do
        end do
      case (3)
        allocate( sum_complex_double_st_dim_5D(size(array,1), size(array,2), size(array,4), size(array,5)) ) 
        do i4=1,size(sum_complex_double_st_dim_5D,4)
          do i3=1,size(sum_complex_double_st_dim_5D,3)
            do i2=1,size(sum_complex_double_st_dim_5D,2)
              do i1=1,size(sum_complex_double_st_dim_5D,1)
                if (present(mask)) then
                  sum_complex_double_st_dim_5D(i1,i2,i3,i4) = sum(array(i1,i2,:,i3,i4), mask(i1,i2,:,i3,i4))
                else
                  sum_complex_double_st_dim_5D(i1,i2,i3,i4) = sum(array(i1,i2,:,i3,i4))
                end if
              end do
            end do
          end do
        end do
      case (4)
        allocate( sum_complex_double_st_dim_5D(size(array,1), size(array,2), size(array,3), size(array,5) )) 
        do i4=1,size(sum_complex_double_st_dim_5D,4)
          do i3=1,size(sum_complex_double_st_dim_5D,3)
            do i2=1,size(sum_complex_double_st_dim_5D,2)
              do i1=1,size(sum_complex_double_st_dim_5D,1)
                if (present(mask)) then
                  sum_complex_double_st_dim_5D(i1,i2,i3,i4) = sum(array(i1,i2,i3,:,i4), mask(i1,i2,i3,:,i4))
                else
                  sum_complex_double_st_dim_5D(i1,i2,i3,i4) = sum(array(i1,i2,i3,:,i4))
                end if
              end do
            end do
          end do
        end do
      case (5)
        allocate( sum_complex_double_st_dim_5D(size(array,1), size(array,2), size(array,3), size(array,4)) ) 
        do i4=1,size(sum_complex_double_st_dim_5D,4)
          do i3=1,size(sum_complex_double_st_dim_5D,3)
            do i2=1,size(sum_complex_double_st_dim_5D,2)
              do i1=1,size(sum_complex_double_st_dim_5D,1)
                if (present(mask)) then
                  sum_complex_double_st_dim_5D(i1,i2,i3,i4) = sum(array(i1,i2,i3,i4,:), mask(i1,i2,i3,i4,:))
                else
                  sum_complex_double_st_dim_5D(i1,i2,i3,i4) = sum(array(i1,i2,i3,i4,:))
                end if
              end do
            end do
          end do
        end do
      case default
        allocate( sum_complex_double_st_dim_5D(0,0,0,0) ) 
        write(ERROR_UNIT, *) "Incorrect value of DIM argument :"
        write(ERROR_UNIT, *) "a zero-sized array has been returned."
    end select
  end function sum_complex_double_st_dim_5D

  function product_complex_single_st_dim_5D(array, dim, mask)
    use ISO_FORTRAN_ENV, only : ERROR_UNIT
    ! Dummy arguments declaration
    type(complex_single_st), dimension(:,:,:,:,:), intent(in) :: array
    logical,       optional, dimension(:,:,:,:,:), intent(in) :: mask
    integer,                                       intent(in) :: dim
    type(complex_single_st), dimension(:,:,:,:), allocatable :: product_complex_single_st_dim_5D
    ! Local declaration
    integer i1, i2, i3, i4

    select case (dim)
      case (1)
        allocate( product_complex_single_st_dim_5D(size(array,2), size(array,3), size(array,4), size(array,5)) ) 
        do i4=1,size(product_complex_single_st_dim_5D,4)
          do i3=1,size(product_complex_single_st_dim_5D,3)
            do i2=1,size(product_complex_single_st_dim_5D,2)
              do i1=1,size(product_complex_single_st_dim_5D,1)
                if (present(mask)) then
                  product_complex_single_st_dim_5D(i1,i2,i3,i4) = product(array(:,i1,i2,i3,i4), mask(:,i1,i2,i3,i4))
                else
                  product_complex_single_st_dim_5D(i1,i2,i3,i4) = product(array(:,i1,i2,i3,i4))
                end if
              end do
            end do
          end do
        end do
      case (2)
        allocate( product_complex_single_st_dim_5D(size(array,1), size(array,3), size(array,4), size(array,5)) ) 
        do i4=1,size(product_complex_single_st_dim_5D,4)
          do i3=1,size(product_complex_single_st_dim_5D,3)
            do i2=1,size(product_complex_single_st_dim_5D,2)
              do i1=1,size(product_complex_single_st_dim_5D,1)
                if (present(mask)) then
                  product_complex_single_st_dim_5D(i1,i2,i3,i4) = product(array(i1,:,i2,i3,i4), mask(i1,:,i2,i3,i4))
                else
                  product_complex_single_st_dim_5D(i1,i2,i3,i4) = product(array(i1,:,i2,i3,i4))
                end if
              end do
            end do
          end do
        end do
      case (3)
        allocate( product_complex_single_st_dim_5D(size(array,1), size(array,2), size(array,4), size(array,5)) ) 
        do i4=1,size(product_complex_single_st_dim_5D,4)
          do i3=1,size(product_complex_single_st_dim_5D,3)
            do i2=1,size(product_complex_single_st_dim_5D,2)
              do i1=1,size(product_complex_single_st_dim_5D,1)
                if (present(mask)) then
                  product_complex_single_st_dim_5D(i1,i2,i3,i4) = product(array(i1,i2,:,i3,i4), mask(i1,i2,:,i3,i4))
                else
                  product_complex_single_st_dim_5D(i1,i2,i3,i4) = product(array(i1,i2,:,i3,i4))
                end if
              end do
            end do
          end do
        end do
      case (4)
        allocate( product_complex_single_st_dim_5D(size(array,1), size(array,2), size(array,3), size(array,5) )) 
        do i4=1,size(product_complex_single_st_dim_5D,4)
          do i3=1,size(product_complex_single_st_dim_5D,3)
            do i2=1,size(product_complex_single_st_dim_5D,2)
              do i1=1,size(product_complex_single_st_dim_5D,1)
                if (present(mask)) then
                  product_complex_single_st_dim_5D(i1,i2,i3,i4) = product(array(i1,i2,i3,:,i4), mask(i1,i2,i3,:,i4))
                else
                  product_complex_single_st_dim_5D(i1,i2,i3,i4) = product(array(i1,i2,i3,:,i4))
                end if
              end do
            end do
          end do
        end do
      case (5)
        allocate( product_complex_single_st_dim_5D(size(array,1), size(array,2), size(array,3), size(array,4)) ) 
        do i4=1,size(product_complex_single_st_dim_5D,4)
          do i3=1,size(product_complex_single_st_dim_5D,3)
            do i2=1,size(product_complex_single_st_dim_5D,2)
              do i1=1,size(product_complex_single_st_dim_5D,1)
                if (present(mask)) then
                  product_complex_single_st_dim_5D(i1,i2,i3,i4) = product(array(i1,i2,i3,i4,:), mask(i1,i2,i3,i4,:))
                else
                  product_complex_single_st_dim_5D(i1,i2,i3,i4) = product(array(i1,i2,i3,i4,:))
                end if
              end do
            end do
          end do
        end do
      case default
        allocate( product_complex_single_st_dim_5D(0,0,0,0) ) 
        write(ERROR_UNIT, *) "Incorrect value of DIM argument :"
        write(ERROR_UNIT, *) "a zero-sized array has been returned."
    end select
  end function product_complex_single_st_dim_5D

  function product_complex_double_st_dim_5D(array, dim, mask)
    use ISO_FORTRAN_ENV, only : ERROR_UNIT
    ! Dummy arguments declaration
    type(complex_double_st), dimension(:,:,:,:,:), intent(in) :: array
    logical,       optional, dimension(:,:,:,:,:), intent(in) :: mask
    integer,                                       intent(in) :: dim
    type(complex_double_st), dimension(:,:,:,:), allocatable :: product_complex_double_st_dim_5D
    ! Local declaration
    integer i1, i2, i3, i4

    select case (dim)
      case (1)
        allocate( product_complex_double_st_dim_5D(size(array,2), size(array,3), size(array,4), size(array,5)) ) 
        do i4=1,size(product_complex_double_st_dim_5D,4)
          do i3=1,size(product_complex_double_st_dim_5D,3)
            do i2=1,size(product_complex_double_st_dim_5D,2)
              do i1=1,size(product_complex_double_st_dim_5D,1)
                if (present(mask)) then
                  product_complex_double_st_dim_5D(i1,i2,i3,i4) = product(array(:,i1,i2,i3,i4), mask(:,i1,i2,i3,i4))
                else
                  product_complex_double_st_dim_5D(i1,i2,i3,i4) = product(array(:,i1,i2,i3,i4))
                end if
              end do
            end do
          end do
        end do
      case (2)
        allocate( product_complex_double_st_dim_5D(size(array,1), size(array,3), size(array,4), size(array,5)) ) 
        do i4=1,size(product_complex_double_st_dim_5D,4)
          do i3=1,size(product_complex_double_st_dim_5D,3)
            do i2=1,size(product_complex_double_st_dim_5D,2)
              do i1=1,size(product_complex_double_st_dim_5D,1)
                if (present(mask)) then
                  product_complex_double_st_dim_5D(i1,i2,i3,i4) = product(array(i1,:,i2,i3,i4), mask(i1,:,i2,i3,i4))
                else
                  product_complex_double_st_dim_5D(i1,i2,i3,i4) = product(array(i1,:,i2,i3,i4))
                end if
              end do
            end do
          end do
        end do
      case (3)
        allocate( product_complex_double_st_dim_5D(size(array,1), size(array,2), size(array,4), size(array,5)) ) 
        do i4=1,size(product_complex_double_st_dim_5D,4)
          do i3=1,size(product_complex_double_st_dim_5D,3)
            do i2=1,size(product_complex_double_st_dim_5D,2)
              do i1=1,size(product_complex_double_st_dim_5D,1)
                if (present(mask)) then
                  product_complex_double_st_dim_5D(i1,i2,i3,i4) = product(array(i1,i2,:,i3,i4), mask(i1,i2,:,i3,i4))
                else
                  product_complex_double_st_dim_5D(i1,i2,i3,i4) = product(array(i1,i2,:,i3,i4))
                end if
              end do
            end do
          end do
        end do
      case (4)
        allocate( product_complex_double_st_dim_5D(size(array,1), size(array,2), size(array,3), size(array,5) )) 
        do i4=1,size(product_complex_double_st_dim_5D,4)
          do i3=1,size(product_complex_double_st_dim_5D,3)
            do i2=1,size(product_complex_double_st_dim_5D,2)
              do i1=1,size(product_complex_double_st_dim_5D,1)
                if (present(mask)) then
                  product_complex_double_st_dim_5D(i1,i2,i3,i4) = product(array(i1,i2,i3,:,i4), mask(i1,i2,i3,:,i4))
                else
                  product_complex_double_st_dim_5D(i1,i2,i3,i4) = product(array(i1,i2,i3,:,i4))
                end if
              end do
            end do
          end do
        end do
      case (5)
        allocate( product_complex_double_st_dim_5D(size(array,1), size(array,2), size(array,3), size(array,4)) ) 
        do i4=1,size(product_complex_double_st_dim_5D,4)
          do i3=1,size(product_complex_double_st_dim_5D,3)
            do i2=1,size(product_complex_double_st_dim_5D,2)
              do i1=1,size(product_complex_double_st_dim_5D,1)
                if (present(mask)) then
                  product_complex_double_st_dim_5D(i1,i2,i3,i4) = product(array(i1,i2,i3,i4,:), mask(i1,i2,i3,i4,:))
                else
                  product_complex_double_st_dim_5D(i1,i2,i3,i4) = product(array(i1,i2,i3,i4,:))
                end if
              end do
            end do
          end do
        end do
      case default
        allocate( product_complex_double_st_dim_5D(0,0,0,0) ) 
        write(ERROR_UNIT, *) "Incorrect value of DIM argument :"
        write(ERROR_UNIT, *) "a zero-sized array has been returned."
    end select
  end function product_complex_double_st_dim_5D




  function sum_complex_single_st_dim_6D(array, dim, mask)
    use ISO_FORTRAN_ENV, only : ERROR_UNIT
    ! Dummy arguments declaration
    type(complex_single_st), dimension(:,:,:,:,:,:), intent(in) :: array
    logical,       optional, dimension(:,:,:,:,:,:), intent(in) :: mask
    integer,                                         intent(in) :: dim
    type(complex_single_st), dimension(:,:,:,:,:), allocatable :: sum_complex_single_st_dim_6D
    ! Local declaration
    integer i1, i2, i3, i4, i5

    select case (dim)
      case (1)
        allocate( sum_complex_single_st_dim_6D(size(array,2), size(array,3), size(array,4), size(array,5), size(array,6)) ) 
        do i5=1,size(sum_complex_single_st_dim_6D,5)
          do i4=1,size(sum_complex_single_st_dim_6D,4)
            do i3=1,size(sum_complex_single_st_dim_6D,3)
              do i2=1,size(sum_complex_single_st_dim_6D,2)
                do i1=1,size(sum_complex_single_st_dim_6D,1)
                  if (present(mask)) then
                    sum_complex_single_st_dim_6D(i1,i2,i3,i4,i5) = sum(array(:,i1,i2,i3,i4,i5), mask(:,i1,i2,i3,i4,i5))
                  else
                    sum_complex_single_st_dim_6D(i1,i2,i3,i4,i5) = sum(array(:,i1,i2,i3,i4,i5))
                  end if
                end do
              end do
            end do
          end do
        end do
      case (2)
        allocate( sum_complex_single_st_dim_6D(size(array,1), size(array,3), size(array,4), size(array,5), size(array,6)) ) 
        do i5=1,size(sum_complex_single_st_dim_6D,5)
          do i4=1,size(sum_complex_single_st_dim_6D,4)
            do i3=1,size(sum_complex_single_st_dim_6D,3)
              do i2=1,size(sum_complex_single_st_dim_6D,2)
                do i1=1,size(sum_complex_single_st_dim_6D,1)
                  if (present(mask)) then
                    sum_complex_single_st_dim_6D(i1,i2,i3,i4,i5) = sum(array(i1,:,i2,i3,i4,i5), mask(i1,:,i2,i3,i4,i5))
                  else
                    sum_complex_single_st_dim_6D(i1,i2,i3,i4,i5) = sum(array(i1,:,i2,i3,i4,i5))
                  end if
                end do
              end do
            end do
          end do
        end do
      case (3)
        allocate( sum_complex_single_st_dim_6D(size(array,1), size(array,2), size(array,4), size(array,5), size(array,6)) ) 
        do i5=1,size(sum_complex_single_st_dim_6D,5)
          do i4=1,size(sum_complex_single_st_dim_6D,4)
            do i3=1,size(sum_complex_single_st_dim_6D,3)
              do i2=1,size(sum_complex_single_st_dim_6D,2)
                do i1=1,size(sum_complex_single_st_dim_6D,1)
                  if (present(mask)) then
                    sum_complex_single_st_dim_6D(i1,i2,i3,i4,i5) = sum(array(i1,i2,:,i3,i4,i5), mask(i1,i2,:,i3,i4,i5))
                  else
                    sum_complex_single_st_dim_6D(i1,i2,i3,i4,i5) = sum(array(i1,i2,:,i3,i4,i5))
                  end if
                end do
              end do
            end do
          end do
        end do
      case (4)
        allocate( sum_complex_single_st_dim_6D(size(array,1), size(array,2), size(array,3), size(array,5), size(array,6)) ) 
        do i5=1,size(sum_complex_single_st_dim_6D,5)
          do i4=1,size(sum_complex_single_st_dim_6D,4)
            do i3=1,size(sum_complex_single_st_dim_6D,3)
              do i2=1,size(sum_complex_single_st_dim_6D,2)
                do i1=1,size(sum_complex_single_st_dim_6D,1)
                  if (present(mask)) then
                    sum_complex_single_st_dim_6D(i1,i2,i3,i4,i5) = sum(array(i1,i2,i3,:,i4,i5), mask(i1,i2,i3,:,i4,i5))
                  else
                    sum_complex_single_st_dim_6D(i1,i2,i3,i4,i5) = sum(array(i1,i2,i3,:,i4,i5))
                  end if
                end do
              end do
            end do
          end do
        end do
      case (5)
        allocate( sum_complex_single_st_dim_6D(size(array,1), size(array,2), size(array,3), size(array,4), size(array,6)) ) 
        do i5=1,size(sum_complex_single_st_dim_6D,5)
          do i4=1,size(sum_complex_single_st_dim_6D,4)
            do i3=1,size(sum_complex_single_st_dim_6D,3)
              do i2=1,size(sum_complex_single_st_dim_6D,2)
                do i1=1,size(sum_complex_single_st_dim_6D,1)
                  if (present(mask)) then
                    sum_complex_single_st_dim_6D(i1,i2,i3,i4,i5) = sum(array(i1,i2,i3,i4,:,i5), mask(i1,i2,i3,i4,:,i5))
                  else
                    sum_complex_single_st_dim_6D(i1,i2,i3,i4,i5) = sum(array(i1,i2,i3,i4,:,i5))
                  end if
                end do
              end do
            end do
          end do
        end do
      case (6)
        allocate( sum_complex_single_st_dim_6D(size(array,1), size(array,2), size(array,3), size(array,4), size(array,5)) ) 
        do i5=1,size(sum_complex_single_st_dim_6D,5)
          do i4=1,size(sum_complex_single_st_dim_6D,4)
            do i3=1,size(sum_complex_single_st_dim_6D,3)
              do i2=1,size(sum_complex_single_st_dim_6D,2)
                do i1=1,size(sum_complex_single_st_dim_6D,1)
                  if (present(mask)) then
                    sum_complex_single_st_dim_6D(i1,i2,i3,i4,i5) = sum(array(i1,i2,i3,i4,i5,:), mask(i1,i2,i3,i4,i5,:))
                  else
                    sum_complex_single_st_dim_6D(i1,i2,i3,i4,i5) = sum(array(i1,i2,i3,i4,i5,:))
                  end if
                end do
              end do
            end do
          end do
        end do
      case default
        allocate( sum_complex_single_st_dim_6D(0,0,0,0,0) ) 
        write(ERROR_UNIT, *) "Incorrect value of DIM argument :"
        write(ERROR_UNIT, *) "a zero-sized array has been returned."
    end select
  end function sum_complex_single_st_dim_6D

  function sum_complex_double_st_dim_6D(array, dim, mask)
    use ISO_FORTRAN_ENV, only : ERROR_UNIT
    ! Dummy arguments declaration
    type(complex_double_st), dimension(:,:,:,:,:,:), intent(in) :: array
    logical,       optional, dimension(:,:,:,:,:,:), intent(in) :: mask
    integer,                                         intent(in) :: dim
    type(complex_double_st), dimension(:,:,:,:,:), allocatable :: sum_complex_double_st_dim_6D
    ! Local declaration
    integer i1, i2, i3, i4, i5

    select case (dim)
      case (1)
        allocate( sum_complex_double_st_dim_6D(size(array,2), size(array,3), size(array,4), size(array,5), size(array,6)) ) 
        do i5=1,size(sum_complex_double_st_dim_6D,5)
          do i4=1,size(sum_complex_double_st_dim_6D,4)
            do i3=1,size(sum_complex_double_st_dim_6D,3)
              do i2=1,size(sum_complex_double_st_dim_6D,2)
                do i1=1,size(sum_complex_double_st_dim_6D,1)
                  if (present(mask)) then
                    sum_complex_double_st_dim_6D(i1,i2,i3,i4,i5) = sum(array(:,i1,i2,i3,i4,i5), mask(:,i1,i2,i3,i4,i5))
                  else
                    sum_complex_double_st_dim_6D(i1,i2,i3,i4,i5) = sum(array(:,i1,i2,i3,i4,i5))
                  end if
                end do
              end do
            end do
          end do
        end do
      case (2)
        allocate( sum_complex_double_st_dim_6D(size(array,1), size(array,3), size(array,4), size(array,5), size(array,6)) ) 
        do i5=1,size(sum_complex_double_st_dim_6D,5)
          do i4=1,size(sum_complex_double_st_dim_6D,4)
            do i3=1,size(sum_complex_double_st_dim_6D,3)
              do i2=1,size(sum_complex_double_st_dim_6D,2)
                do i1=1,size(sum_complex_double_st_dim_6D,1)
                  if (present(mask)) then
                    sum_complex_double_st_dim_6D(i1,i2,i3,i4,i5) = sum(array(i1,:,i2,i3,i4,i5), mask(i1,:,i2,i3,i4,i5))
                  else
                    sum_complex_double_st_dim_6D(i1,i2,i3,i4,i5) = sum(array(i1,:,i2,i3,i4,i5))
                  end if
                end do
              end do
            end do
          end do
        end do
      case (3)
        allocate( sum_complex_double_st_dim_6D(size(array,1), size(array,2), size(array,4), size(array,5), size(array,6)) ) 
        do i5=1,size(sum_complex_double_st_dim_6D,5)
          do i4=1,size(sum_complex_double_st_dim_6D,4)
            do i3=1,size(sum_complex_double_st_dim_6D,3)
              do i2=1,size(sum_complex_double_st_dim_6D,2)
                do i1=1,size(sum_complex_double_st_dim_6D,1)
                  if (present(mask)) then
                    sum_complex_double_st_dim_6D(i1,i2,i3,i4,i5) = sum(array(i1,i2,:,i3,i4,i5), mask(i1,i2,:,i3,i4,i5))
                  else
                    sum_complex_double_st_dim_6D(i1,i2,i3,i4,i5) = sum(array(i1,i2,:,i3,i4,i5))
                  end if
                end do
              end do
            end do
          end do
        end do
      case (4)
        allocate( sum_complex_double_st_dim_6D(size(array,1), size(array,2), size(array,3), size(array,5), size(array,6)) ) 
        do i5=1,size(sum_complex_double_st_dim_6D,5)
          do i4=1,size(sum_complex_double_st_dim_6D,4)
            do i3=1,size(sum_complex_double_st_dim_6D,3)
              do i2=1,size(sum_complex_double_st_dim_6D,2)
                do i1=1,size(sum_complex_double_st_dim_6D,1)
                  if (present(mask)) then
                    sum_complex_double_st_dim_6D(i1,i2,i3,i4,i5) = sum(array(i1,i2,i3,:,i4,i5), mask(i1,i2,i3,:,i4,i5))
                  else
                    sum_complex_double_st_dim_6D(i1,i2,i3,i4,i5) = sum(array(i1,i2,i3,:,i4,i5))
                  end if
                end do
              end do
            end do
          end do
        end do
      case (5)
        allocate( sum_complex_double_st_dim_6D(size(array,1), size(array,2), size(array,3), size(array,4), size(array,6)) ) 
        do i5=1,size(sum_complex_double_st_dim_6D,5)
          do i4=1,size(sum_complex_double_st_dim_6D,4)
            do i3=1,size(sum_complex_double_st_dim_6D,3)
              do i2=1,size(sum_complex_double_st_dim_6D,2)
                do i1=1,size(sum_complex_double_st_dim_6D,1)
                  if (present(mask)) then
                    sum_complex_double_st_dim_6D(i1,i2,i3,i4,i5) = sum(array(i1,i2,i3,i4,:,i5), mask(i1,i2,i3,i4,:,i5))
                  else
                    sum_complex_double_st_dim_6D(i1,i2,i3,i4,i5) = sum(array(i1,i2,i3,i4,:,i5))
                  end if
                end do
              end do
            end do
          end do
        end do
      case (6)
        allocate( sum_complex_double_st_dim_6D(size(array,1), size(array,2), size(array,3), size(array,4), size(array,5)) ) 
        do i5=1,size(sum_complex_double_st_dim_6D,5)
          do i4=1,size(sum_complex_double_st_dim_6D,4)
            do i3=1,size(sum_complex_double_st_dim_6D,3)
              do i2=1,size(sum_complex_double_st_dim_6D,2)
                do i1=1,size(sum_complex_double_st_dim_6D,1)
                  if (present(mask)) then
                    sum_complex_double_st_dim_6D(i1,i2,i3,i4,i5) = sum(array(i1,i2,i3,i4,i5,:), mask(i1,i2,i3,i4,i5,:))
                  else
                    sum_complex_double_st_dim_6D(i1,i2,i3,i4,i5) = sum(array(i1,i2,i3,i4,i5,:))
                  end if
                end do
              end do
            end do
          end do
        end do
      case default
        allocate( sum_complex_double_st_dim_6D(0,0,0,0,0) ) 
        write(ERROR_UNIT, *) "Incorrect value of DIM argument :"
        write(ERROR_UNIT, *) "a zero-sized array has been returned."
    end select
  end function sum_complex_double_st_dim_6D

  function product_complex_single_st_dim_6D(array, dim, mask)
    use ISO_FORTRAN_ENV, only : ERROR_UNIT
    ! Dummy arguments declaration
    type(complex_single_st), dimension(:,:,:,:,:,:), intent(in) :: array
    logical,       optional, dimension(:,:,:,:,:,:), intent(in) :: mask
    integer,                                         intent(in) :: dim
    type(complex_single_st), dimension(:,:,:,:,:), allocatable :: product_complex_single_st_dim_6D
    ! Local declaration
    integer i1, i2, i3, i4, i5

    select case (dim)
      case (1)
        allocate( product_complex_single_st_dim_6D(size(array,2), size(array,3), size(array,4), size(array,5), size(array,6)) ) 
        do i5=1,size(product_complex_single_st_dim_6D,5)
          do i4=1,size(product_complex_single_st_dim_6D,4)
            do i3=1,size(product_complex_single_st_dim_6D,3)
              do i2=1,size(product_complex_single_st_dim_6D,2)
                do i1=1,size(product_complex_single_st_dim_6D,1)
                  if (present(mask)) then
                    product_complex_single_st_dim_6D(i1,i2,i3,i4,i5) = product(array(:,i1,i2,i3,i4,i5), mask(:,i1,i2,i3,i4,i5))
                  else
                    product_complex_single_st_dim_6D(i1,i2,i3,i4,i5) = product(array(:,i1,i2,i3,i4,i5))
                  end if
                end do
              end do
            end do
          end do
        end do
      case (2)
        allocate( product_complex_single_st_dim_6D(size(array,1), size(array,3), size(array,4), size(array,5), size(array,6)) ) 
        do i5=1,size(product_complex_single_st_dim_6D,5)
          do i4=1,size(product_complex_single_st_dim_6D,4)
            do i3=1,size(product_complex_single_st_dim_6D,3)
              do i2=1,size(product_complex_single_st_dim_6D,2)
                do i1=1,size(product_complex_single_st_dim_6D,1)
                  if (present(mask)) then
                    product_complex_single_st_dim_6D(i1,i2,i3,i4,i5) = product(array(i1,:,i2,i3,i4,i5), mask(i1,:,i2,i3,i4,i5))
                  else
                    product_complex_single_st_dim_6D(i1,i2,i3,i4,i5) = product(array(i1,:,i2,i3,i4,i5))
                  end if
                end do
              end do
            end do
          end do
        end do
      case (3)
        allocate( product_complex_single_st_dim_6D(size(array,1), size(array,2), size(array,4), size(array,5), size(array,6)) ) 
        do i5=1,size(product_complex_single_st_dim_6D,5)
          do i4=1,size(product_complex_single_st_dim_6D,4)
            do i3=1,size(product_complex_single_st_dim_6D,3)
              do i2=1,size(product_complex_single_st_dim_6D,2)
                do i1=1,size(product_complex_single_st_dim_6D,1)
                  if (present(mask)) then
                    product_complex_single_st_dim_6D(i1,i2,i3,i4,i5) = product(array(i1,i2,:,i3,i4,i5), mask(i1,i2,:,i3,i4,i5))
                  else
                    product_complex_single_st_dim_6D(i1,i2,i3,i4,i5) = product(array(i1,i2,:,i3,i4,i5))
                  end if
                end do
              end do
            end do
          end do
        end do
      case (4)
        allocate( product_complex_single_st_dim_6D(size(array,1), size(array,2), size(array,3), size(array,5), size(array,6)) ) 
        do i5=1,size(product_complex_single_st_dim_6D,5)
          do i4=1,size(product_complex_single_st_dim_6D,4)
            do i3=1,size(product_complex_single_st_dim_6D,3)
              do i2=1,size(product_complex_single_st_dim_6D,2)
                do i1=1,size(product_complex_single_st_dim_6D,1)
                  if (present(mask)) then
                    product_complex_single_st_dim_6D(i1,i2,i3,i4,i5) = product(array(i1,i2,i3,:,i4,i5), mask(i1,i2,i3,:,i4,i5))
                  else
                    product_complex_single_st_dim_6D(i1,i2,i3,i4,i5) = product(array(i1,i2,i3,:,i4,i5))
                  end if
                end do
              end do
            end do
          end do
        end do
      case (5)
        allocate( product_complex_single_st_dim_6D(size(array,1), size(array,2), size(array,3), size(array,4), size(array,6)) ) 
        do i5=1,size(product_complex_single_st_dim_6D,5)
          do i4=1,size(product_complex_single_st_dim_6D,4)
            do i3=1,size(product_complex_single_st_dim_6D,3)
              do i2=1,size(product_complex_single_st_dim_6D,2)
                do i1=1,size(product_complex_single_st_dim_6D,1)
                  if (present(mask)) then
                    product_complex_single_st_dim_6D(i1,i2,i3,i4,i5) = product(array(i1,i2,i3,i4,:,i5), mask(i1,i2,i3,i4,:,i5))
                  else
                    product_complex_single_st_dim_6D(i1,i2,i3,i4,i5) = product(array(i1,i2,i3,i4,:,i5))
                  end if
                end do
              end do
            end do
          end do
        end do
      case (6)
        allocate( product_complex_single_st_dim_6D(size(array,1), size(array,2), size(array,3), size(array,4), size(array,5)) ) 
        do i5=1,size(product_complex_single_st_dim_6D,5)
          do i4=1,size(product_complex_single_st_dim_6D,4)
            do i3=1,size(product_complex_single_st_dim_6D,3)
              do i2=1,size(product_complex_single_st_dim_6D,2)
                do i1=1,size(product_complex_single_st_dim_6D,1)
                  if (present(mask)) then
                    product_complex_single_st_dim_6D(i1,i2,i3,i4,i5) = product(array(i1,i2,i3,i4,i5,:), mask(i1,i2,i3,i4,i5,:))
                  else
                    product_complex_single_st_dim_6D(i1,i2,i3,i4,i5) = product(array(i1,i2,i3,i4,i5,:))
                  end if
                end do
              end do
            end do
          end do
        end do
      case default
        allocate( product_complex_single_st_dim_6D(0,0,0,0,0) ) 
        write(ERROR_UNIT, *) "Incorrect value of DIM argument :"
        write(ERROR_UNIT, *) "a zero-sized array has been returned."
    end select
  end function product_complex_single_st_dim_6D

  function product_complex_double_st_dim_6D(array, dim, mask)
    use ISO_FORTRAN_ENV, only : ERROR_UNIT
    ! Dummy arguments declaration
    type(complex_double_st), dimension(:,:,:,:,:,:), intent(in) :: array
    logical,       optional, dimension(:,:,:,:,:,:), intent(in) :: mask
    integer,                                         intent(in) :: dim
    type(complex_double_st), dimension(:,:,:,:,:), allocatable :: product_complex_double_st_dim_6D
    ! Local declaration
    integer i1, i2, i3, i4, i5

    select case (dim)
      case (1)
        allocate( product_complex_double_st_dim_6D(size(array,2), size(array,3), size(array,4), size(array,5), size(array,6)) ) 
        do i5=1,size(product_complex_double_st_dim_6D,5)
          do i4=1,size(product_complex_double_st_dim_6D,4)
            do i3=1,size(product_complex_double_st_dim_6D,3)
              do i2=1,size(product_complex_double_st_dim_6D,2)
                do i1=1,size(product_complex_double_st_dim_6D,1)
                  if (present(mask)) then
                    product_complex_double_st_dim_6D(i1,i2,i3,i4,i5) = product(array(:,i1,i2,i3,i4,i5), mask(:,i1,i2,i3,i4,i5))
                  else
                    product_complex_double_st_dim_6D(i1,i2,i3,i4,i5) = product(array(:,i1,i2,i3,i4,i5))
                  end if
                end do
              end do
            end do
          end do
        end do
      case (2)
        allocate( product_complex_double_st_dim_6D(size(array,1), size(array,3), size(array,4), size(array,5), size(array,6)) ) 
        do i5=1,size(product_complex_double_st_dim_6D,5)
          do i4=1,size(product_complex_double_st_dim_6D,4)
            do i3=1,size(product_complex_double_st_dim_6D,3)
              do i2=1,size(product_complex_double_st_dim_6D,2)
                do i1=1,size(product_complex_double_st_dim_6D,1)
                  if (present(mask)) then
                    product_complex_double_st_dim_6D(i1,i2,i3,i4,i5) = product(array(i1,:,i2,i3,i4,i5), mask(i1,:,i2,i3,i4,i5))
                  else
                    product_complex_double_st_dim_6D(i1,i2,i3,i4,i5) = product(array(i1,:,i2,i3,i4,i5))
                  end if
                end do
              end do
            end do
          end do
        end do
      case (3)
        allocate( product_complex_double_st_dim_6D(size(array,1), size(array,2), size(array,4), size(array,5), size(array,6)) ) 
        do i5=1,size(product_complex_double_st_dim_6D,5)
          do i4=1,size(product_complex_double_st_dim_6D,4)
            do i3=1,size(product_complex_double_st_dim_6D,3)
              do i2=1,size(product_complex_double_st_dim_6D,2)
                do i1=1,size(product_complex_double_st_dim_6D,1)
                  if (present(mask)) then
                    product_complex_double_st_dim_6D(i1,i2,i3,i4,i5) = product(array(i1,i2,:,i3,i4,i5), mask(i1,i2,:,i3,i4,i5))
                  else
                    product_complex_double_st_dim_6D(i1,i2,i3,i4,i5) = product(array(i1,i2,:,i3,i4,i5))
                  end if
                end do
              end do
            end do
          end do
        end do
      case (4)
        allocate( product_complex_double_st_dim_6D(size(array,1), size(array,2), size(array,3), size(array,5), size(array,6)) ) 
        do i5=1,size(product_complex_double_st_dim_6D,5)
          do i4=1,size(product_complex_double_st_dim_6D,4)
            do i3=1,size(product_complex_double_st_dim_6D,3)
              do i2=1,size(product_complex_double_st_dim_6D,2)
                do i1=1,size(product_complex_double_st_dim_6D,1)
                  if (present(mask)) then
                    product_complex_double_st_dim_6D(i1,i2,i3,i4,i5) = product(array(i1,i2,i3,:,i4,i5), mask(i1,i2,i3,:,i4,i5))
                  else
                    product_complex_double_st_dim_6D(i1,i2,i3,i4,i5) = product(array(i1,i2,i3,:,i4,i5))
                  end if
                end do
              end do
            end do
          end do
        end do
      case (5)
        allocate( product_complex_double_st_dim_6D(size(array,1), size(array,2), size(array,3), size(array,4), size(array,6)) ) 
        do i5=1,size(product_complex_double_st_dim_6D,5)
          do i4=1,size(product_complex_double_st_dim_6D,4)
            do i3=1,size(product_complex_double_st_dim_6D,3)
              do i2=1,size(product_complex_double_st_dim_6D,2)
                do i1=1,size(product_complex_double_st_dim_6D,1)
                  if (present(mask)) then
                    product_complex_double_st_dim_6D(i1,i2,i3,i4,i5) = product(array(i1,i2,i3,i4,:,i5), mask(i1,i2,i3,i4,:,i5))
                  else
                    product_complex_double_st_dim_6D(i1,i2,i3,i4,i5) = product(array(i1,i2,i3,i4,:,i5))
                  end if
                end do
              end do
            end do
          end do
        end do
      case (6)
        allocate( product_complex_double_st_dim_6D(size(array,1), size(array,2), size(array,3), size(array,4), size(array,5)) ) 
        do i5=1,size(product_complex_double_st_dim_6D,5)
          do i4=1,size(product_complex_double_st_dim_6D,4)
            do i3=1,size(product_complex_double_st_dim_6D,3)
              do i2=1,size(product_complex_double_st_dim_6D,2)
                do i1=1,size(product_complex_double_st_dim_6D,1)
                  if (present(mask)) then
                    product_complex_double_st_dim_6D(i1,i2,i3,i4,i5) = product(array(i1,i2,i3,i4,i5,:), mask(i1,i2,i3,i4,i5,:))
                  else
                    product_complex_double_st_dim_6D(i1,i2,i3,i4,i5) = product(array(i1,i2,i3,i4,i5,:))
                  end if
                end do
              end do
            end do
          end do
        end do
      case default
        allocate( product_complex_double_st_dim_6D(0,0,0,0,0) ) 
        write(ERROR_UNIT, *) "Incorrect value of DIM argument :"
        write(ERROR_UNIT, *) "a zero-sized array has been returned."
    end select
  end function product_complex_double_st_dim_6D




  function sum_complex_single_st_dim_7D(array, dim, mask)
    use ISO_FORTRAN_ENV, only : ERROR_UNIT
    ! Dummy arguments declaration
    type(complex_single_st), dimension(:,:,:,:,:,:,:), intent(in) :: array
    logical,       optional, dimension(:,:,:,:,:,:,:), intent(in) :: mask
    integer,                                           intent(in) :: dim
    type(complex_single_st), dimension(:,:,:,:,:,:), allocatable :: sum_complex_single_st_dim_7D
    ! Local declaration
    integer i1, i2, i3, i4, i5, i6

    select case (dim)
      case (1)
        allocate( sum_complex_single_st_dim_7D(size(array,2), size(array,3), size(array,4), &
                                               size(array,5), size(array,6), size(array,7)) ) 
        do i6=1,size(sum_complex_single_st_dim_7D,6)
          do i5=1,size(sum_complex_single_st_dim_7D,5)
            do i4=1,size(sum_complex_single_st_dim_7D,4)
              do i3=1,size(sum_complex_single_st_dim_7D,3)
                do i2=1,size(sum_complex_single_st_dim_7D,2)
                  do i1=1,size(sum_complex_single_st_dim_7D,1)
                    if (present(mask)) then
                      sum_complex_single_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          sum(array(:,i1,i2,i3,i4,i5,i6), mask(:,i1,i2,i3,i4,i5,i6))
                    else
                      sum_complex_single_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          sum(array(:,i1,i2,i3,i4,i5,i6))
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      case (2)
        allocate( sum_complex_single_st_dim_7D(size(array,1), size(array,3), size(array,4), &
                                               size(array,5), size(array,6), size(array,7)) ) 
        do i6=1,size(sum_complex_single_st_dim_7D,6)
          do i5=1,size(sum_complex_single_st_dim_7D,5)
            do i4=1,size(sum_complex_single_st_dim_7D,4)
              do i3=1,size(sum_complex_single_st_dim_7D,3)
                do i2=1,size(sum_complex_single_st_dim_7D,2)
                  do i1=1,size(sum_complex_single_st_dim_7D,1)
                    if (present(mask)) then
                      sum_complex_single_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          sum(array(i1,:,i2,i3,i4,i5,i6), mask(i1,:,i2,i3,i4,i5,i6))
                    else
                      sum_complex_single_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          sum(array(i1,:,i2,i3,i4,i5,i6))
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      case (3)
        allocate( sum_complex_single_st_dim_7D(size(array,1), size(array,2), size(array,4), &
                                               size(array,5), size(array,6), size(array,7)) ) 
        do i6=1,size(sum_complex_single_st_dim_7D,6)
          do i5=1,size(sum_complex_single_st_dim_7D,5)
            do i4=1,size(sum_complex_single_st_dim_7D,4)
              do i3=1,size(sum_complex_single_st_dim_7D,3)
                do i2=1,size(sum_complex_single_st_dim_7D,2)
                  do i1=1,size(sum_complex_single_st_dim_7D,1)
                    if (present(mask)) then
                      sum_complex_single_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          sum(array(i1,i2,:,i3,i4,i5,i6), mask(i1,i2,:,i3,i4,i5,i6))
                    else
                      sum_complex_single_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          sum(array(i1,i2,:,i3,i4,i5,i6))
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      case (4)
        allocate( sum_complex_single_st_dim_7D(size(array,1), size(array,2), size(array,3), &
                                               size(array,5), size(array,6), size(array,7)) ) 
        do i6=1,size(sum_complex_single_st_dim_7D,6)
          do i5=1,size(sum_complex_single_st_dim_7D,5)
            do i4=1,size(sum_complex_single_st_dim_7D,4)
              do i3=1,size(sum_complex_single_st_dim_7D,3)
                do i2=1,size(sum_complex_single_st_dim_7D,2)
                  do i1=1,size(sum_complex_single_st_dim_7D,1)
                    if (present(mask)) then
                      sum_complex_single_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          sum(array(i1,i2,i3,:,i4,i5,i6), mask(i1,i2,i3,:,i4,i5,i6))
                    else
                      sum_complex_single_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          sum(array(i1,i2,i3,:,i4,i5,i6))
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      case (5)
        allocate( sum_complex_single_st_dim_7D(size(array,1), size(array,2), size(array,3), &
                                               size(array,4), size(array,6), size(array,7)) ) 
        do i6=1,size(sum_complex_single_st_dim_7D,6)
          do i5=1,size(sum_complex_single_st_dim_7D,5)
            do i4=1,size(sum_complex_single_st_dim_7D,4)
              do i3=1,size(sum_complex_single_st_dim_7D,3)
                do i2=1,size(sum_complex_single_st_dim_7D,2)
                  do i1=1,size(sum_complex_single_st_dim_7D,1)
                    if (present(mask)) then
                      sum_complex_single_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          sum(array(i1,i2,i3,i4,:,i5,i6), mask(i1,i2,i3,i4,:,i5,i6))
                    else
                      sum_complex_single_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          sum(array(i1,i2,i3,i4,:,i5,i6))
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      case (6)
        allocate( sum_complex_single_st_dim_7D(size(array,1), size(array,2), size(array,3), &
                                               size(array,4), size(array,5), size(array,7)) ) 
        do i6=1,size(sum_complex_single_st_dim_7D,6)
          do i5=1,size(sum_complex_single_st_dim_7D,5)
            do i4=1,size(sum_complex_single_st_dim_7D,4)
              do i3=1,size(sum_complex_single_st_dim_7D,3)
                do i2=1,size(sum_complex_single_st_dim_7D,2)
                  do i1=1,size(sum_complex_single_st_dim_7D,1)
                    if (present(mask)) then
                      sum_complex_single_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          sum(array(i1,i2,i3,i4,i5,:,i6), mask(i1,i2,i3,i4,i5,:,i6))
                    else
                      sum_complex_single_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          sum(array(i1,i2,i3,i4,i5,:,i6))
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      case (7)
        allocate( sum_complex_single_st_dim_7D(size(array,1), size(array,2), size(array,3), &
                                               size(array,4), size(array,5), size(array,6)) ) 
        do i6=1,size(sum_complex_single_st_dim_7D,6)
          do i5=1,size(sum_complex_single_st_dim_7D,5)
            do i4=1,size(sum_complex_single_st_dim_7D,4)
              do i3=1,size(sum_complex_single_st_dim_7D,3)
                do i2=1,size(sum_complex_single_st_dim_7D,2)
                  do i1=1,size(sum_complex_single_st_dim_7D,1)
                    if (present(mask)) then
                      sum_complex_single_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          sum(array(i1,i2,i3,i4,i5,i6,:), mask(i1,i2,i3,i4,i5,i6,:))
                    else
                      sum_complex_single_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          sum(array(i1,i2,i3,i4,i5,i6,:))
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      case default
        allocate( sum_complex_single_st_dim_7D(0,0,0,0,0,0) ) 
        write(ERROR_UNIT, *) "Incorrect value of DIM argument :"
        write(ERROR_UNIT, *) "a zero-sized array has been returned."
    end select
  end function sum_complex_single_st_dim_7D

  function sum_complex_double_st_dim_7D(array, dim, mask)
    use ISO_FORTRAN_ENV, only : ERROR_UNIT
    ! Dummy arguments declaration
    type(complex_double_st), dimension(:,:,:,:,:,:,:), intent(in) :: array
    logical,       optional, dimension(:,:,:,:,:,:,:), intent(in) :: mask
    integer,                                           intent(in) :: dim
    type(complex_double_st), dimension(:,:,:,:,:,:), allocatable :: sum_complex_double_st_dim_7D
    ! Local declaration
    integer i1, i2, i3, i4, i5, i6

    select case (dim)
      case (1)
        allocate( sum_complex_double_st_dim_7D(size(array,2), size(array,3), size(array,4), &
                                               size(array,5), size(array,6), size(array,7)) ) 
        do i6=1,size(sum_complex_double_st_dim_7D,6)
          do i5=1,size(sum_complex_double_st_dim_7D,5)
            do i4=1,size(sum_complex_double_st_dim_7D,4)
              do i3=1,size(sum_complex_double_st_dim_7D,3)
                do i2=1,size(sum_complex_double_st_dim_7D,2)
                  do i1=1,size(sum_complex_double_st_dim_7D,1)
                    if (present(mask)) then
                      sum_complex_double_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          sum(array(:,i1,i2,i3,i4,i5,i6), mask(:,i1,i2,i3,i4,i5,i6))
                    else
                      sum_complex_double_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          sum(array(:,i1,i2,i3,i4,i5,i6))
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      case (2)
        allocate( sum_complex_double_st_dim_7D(size(array,1), size(array,3), size(array,4), &
                                               size(array,5), size(array,6), size(array,7)) ) 
        do i6=1,size(sum_complex_double_st_dim_7D,6)
          do i5=1,size(sum_complex_double_st_dim_7D,5)
            do i4=1,size(sum_complex_double_st_dim_7D,4)
              do i3=1,size(sum_complex_double_st_dim_7D,3)
                do i2=1,size(sum_complex_double_st_dim_7D,2)
                  do i1=1,size(sum_complex_double_st_dim_7D,1)
                    if (present(mask)) then
                      sum_complex_double_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          sum(array(i1,:,i2,i3,i4,i5,i6), mask(i1,:,i2,i3,i4,i5,i6))
                    else
                      sum_complex_double_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          sum(array(i1,:,i2,i3,i4,i5,i6))
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      case (3)
        allocate( sum_complex_double_st_dim_7D(size(array,1), size(array,2), size(array,4), &
                                               size(array,5), size(array,6), size(array,7)) ) 
        do i6=1,size(sum_complex_double_st_dim_7D,6)
          do i5=1,size(sum_complex_double_st_dim_7D,5)
            do i4=1,size(sum_complex_double_st_dim_7D,4)
              do i3=1,size(sum_complex_double_st_dim_7D,3)
                do i2=1,size(sum_complex_double_st_dim_7D,2)
                  do i1=1,size(sum_complex_double_st_dim_7D,1)
                    if (present(mask)) then
                      sum_complex_double_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          sum(array(i1,i2,:,i3,i4,i5,i6), mask(i1,i2,:,i3,i4,i5,i6))
                    else
                      sum_complex_double_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          sum(array(i1,i2,:,i3,i4,i5,i6))
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      case (4)
        allocate( sum_complex_double_st_dim_7D(size(array,1), size(array,2), size(array,3), &
                                               size(array,5), size(array,6), size(array,7)) ) 
        do i6=1,size(sum_complex_double_st_dim_7D,6)
          do i5=1,size(sum_complex_double_st_dim_7D,5)
            do i4=1,size(sum_complex_double_st_dim_7D,4)
              do i3=1,size(sum_complex_double_st_dim_7D,3)
                do i2=1,size(sum_complex_double_st_dim_7D,2)
                  do i1=1,size(sum_complex_double_st_dim_7D,1)
                    if (present(mask)) then
                      sum_complex_double_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          sum(array(i1,i2,i3,:,i4,i5,i6), mask(i1,i2,i3,:,i4,i5,i6))
                    else
                      sum_complex_double_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          sum(array(i1,i2,i3,:,i4,i5,i6))
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      case (5)
        allocate( sum_complex_double_st_dim_7D(size(array,1), size(array,2), size(array,3), &
                                               size(array,4), size(array,6), size(array,7)) ) 
        do i6=1,size(sum_complex_double_st_dim_7D,6)
          do i5=1,size(sum_complex_double_st_dim_7D,5)
            do i4=1,size(sum_complex_double_st_dim_7D,4)
              do i3=1,size(sum_complex_double_st_dim_7D,3)
                do i2=1,size(sum_complex_double_st_dim_7D,2)
                  do i1=1,size(sum_complex_double_st_dim_7D,1)
                    if (present(mask)) then
                      sum_complex_double_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          sum(array(i1,i2,i3,i4,:,i5,i6), mask(i1,i2,i3,i4,:,i5,i6))
                    else
                      sum_complex_double_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          sum(array(i1,i2,i3,i4,:,i5,i6))
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      case (6)
        allocate( sum_complex_double_st_dim_7D(size(array,1), size(array,2), size(array,3), &
                                               size(array,4), size(array,5), size(array,7)) ) 
        do i6=1,size(sum_complex_double_st_dim_7D,6)
          do i5=1,size(sum_complex_double_st_dim_7D,5)
            do i4=1,size(sum_complex_double_st_dim_7D,4)
              do i3=1,size(sum_complex_double_st_dim_7D,3)
                do i2=1,size(sum_complex_double_st_dim_7D,2)
                  do i1=1,size(sum_complex_double_st_dim_7D,1)
                    if (present(mask)) then
                      sum_complex_double_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          sum(array(i1,i2,i3,i4,i5,:,i6), mask(i1,i2,i3,i4,i5,:,i6))
                    else
                      sum_complex_double_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          sum(array(i1,i2,i3,i4,i5,:,i6))
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      case (7)
        allocate( sum_complex_double_st_dim_7D(size(array,1), size(array,2), size(array,3), &
                                               size(array,4), size(array,5), size(array,6)) ) 
        do i6=1,size(sum_complex_double_st_dim_7D,6)
          do i5=1,size(sum_complex_double_st_dim_7D,5)
            do i4=1,size(sum_complex_double_st_dim_7D,4)
              do i3=1,size(sum_complex_double_st_dim_7D,3)
                do i2=1,size(sum_complex_double_st_dim_7D,2)
                  do i1=1,size(sum_complex_double_st_dim_7D,1)
                    if (present(mask)) then
                      sum_complex_double_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          sum(array(i1,i2,i3,i4,i5,i6,:), mask(i1,i2,i3,i4,i5,i6,:))
                    else
                      sum_complex_double_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          sum(array(i1,i2,i3,i4,i5,i6,:))
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      case default
        allocate( sum_complex_double_st_dim_7D(0,0,0,0,0,0) ) 
        write(ERROR_UNIT, *) "Incorrect value of DIM argument :"
        write(ERROR_UNIT, *) "a zero-sized array has been returned."
    end select
  end function sum_complex_double_st_dim_7D

  function product_complex_single_st_dim_7D(array, dim, mask)
    use ISO_FORTRAN_ENV, only : ERROR_UNIT
    ! Dummy arguments declaration
    type(complex_single_st), dimension(:,:,:,:,:,:,:), intent(in) :: array
    logical,       optional, dimension(:,:,:,:,:,:,:), intent(in) :: mask
    integer,                                           intent(in) :: dim
    type(complex_single_st), dimension(:,:,:,:,:,:), allocatable :: product_complex_single_st_dim_7D
    ! Local declaration
    integer i1, i2, i3, i4, i5, i6

    select case (dim)
      case (1)
        allocate( product_complex_single_st_dim_7D(size(array,2), size(array,3), size(array,4), &
                                               size(array,5), size(array,6), size(array,7)) ) 
        do i6=1,size(product_complex_single_st_dim_7D,6)
          do i5=1,size(product_complex_single_st_dim_7D,5)
            do i4=1,size(product_complex_single_st_dim_7D,4)
              do i3=1,size(product_complex_single_st_dim_7D,3)
                do i2=1,size(product_complex_single_st_dim_7D,2)
                  do i1=1,size(product_complex_single_st_dim_7D,1)
                    if (present(mask)) then
                      product_complex_single_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          product(array(:,i1,i2,i3,i4,i5,i6), mask(:,i1,i2,i3,i4,i5,i6))
                    else
                      product_complex_single_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          product(array(:,i1,i2,i3,i4,i5,i6))
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      case (2)
        allocate( product_complex_single_st_dim_7D(size(array,1), size(array,3), size(array,4), &
                                               size(array,5), size(array,6), size(array,7)) ) 
        do i6=1,size(product_complex_single_st_dim_7D,6)
          do i5=1,size(product_complex_single_st_dim_7D,5)
            do i4=1,size(product_complex_single_st_dim_7D,4)
              do i3=1,size(product_complex_single_st_dim_7D,3)
                do i2=1,size(product_complex_single_st_dim_7D,2)
                  do i1=1,size(product_complex_single_st_dim_7D,1)
                    if (present(mask)) then
                      product_complex_single_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          product(array(i1,:,i2,i3,i4,i5,i6), mask(i1,:,i2,i3,i4,i5,i6))
                    else
                      product_complex_single_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          product(array(i1,:,i2,i3,i4,i5,i6))
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      case (3)
        allocate( product_complex_single_st_dim_7D(size(array,1), size(array,2), size(array,4), &
                                               size(array,5), size(array,6), size(array,7)) ) 
        do i6=1,size(product_complex_single_st_dim_7D,6)
          do i5=1,size(product_complex_single_st_dim_7D,5)
            do i4=1,size(product_complex_single_st_dim_7D,4)
              do i3=1,size(product_complex_single_st_dim_7D,3)
                do i2=1,size(product_complex_single_st_dim_7D,2)
                  do i1=1,size(product_complex_single_st_dim_7D,1)
                    if (present(mask)) then
                      product_complex_single_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          product(array(i1,i2,:,i3,i4,i5,i6), mask(i1,i2,:,i3,i4,i5,i6))
                    else
                      product_complex_single_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          product(array(i1,i2,:,i3,i4,i5,i6))
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      case (4)
        allocate( product_complex_single_st_dim_7D(size(array,1), size(array,2), size(array,3), &
                                               size(array,5), size(array,6), size(array,7)) ) 
        do i6=1,size(product_complex_single_st_dim_7D,6)
          do i5=1,size(product_complex_single_st_dim_7D,5)
            do i4=1,size(product_complex_single_st_dim_7D,4)
              do i3=1,size(product_complex_single_st_dim_7D,3)
                do i2=1,size(product_complex_single_st_dim_7D,2)
                  do i1=1,size(product_complex_single_st_dim_7D,1)
                    if (present(mask)) then
                      product_complex_single_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          product(array(i1,i2,i3,:,i4,i5,i6), mask(i1,i2,i3,:,i4,i5,i6))
                    else
                      product_complex_single_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          product(array(i1,i2,i3,:,i4,i5,i6))
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      case (5)
        allocate( product_complex_single_st_dim_7D(size(array,1), size(array,2), size(array,3), &
                                               size(array,4), size(array,6), size(array,7)) ) 
        do i6=1,size(product_complex_single_st_dim_7D,6)
          do i5=1,size(product_complex_single_st_dim_7D,5)
            do i4=1,size(product_complex_single_st_dim_7D,4)
              do i3=1,size(product_complex_single_st_dim_7D,3)
                do i2=1,size(product_complex_single_st_dim_7D,2)
                  do i1=1,size(product_complex_single_st_dim_7D,1)
                    if (present(mask)) then
                      product_complex_single_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          product(array(i1,i2,i3,i4,:,i5,i6), mask(i1,i2,i3,i4,:,i5,i6))
                    else
                      product_complex_single_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          product(array(i1,i2,i3,i4,:,i5,i6))
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      case (6)
        allocate( product_complex_single_st_dim_7D(size(array,1), size(array,2), size(array,3), &
                                               size(array,4), size(array,5), size(array,7)) ) 
        do i6=1,size(product_complex_single_st_dim_7D,6)
          do i5=1,size(product_complex_single_st_dim_7D,5)
            do i4=1,size(product_complex_single_st_dim_7D,4)
              do i3=1,size(product_complex_single_st_dim_7D,3)
                do i2=1,size(product_complex_single_st_dim_7D,2)
                  do i1=1,size(product_complex_single_st_dim_7D,1)
                    if (present(mask)) then
                      product_complex_single_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          product(array(i1,i2,i3,i4,i5,:,i6), mask(i1,i2,i3,i4,i5,:,i6))
                    else
                      product_complex_single_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          product(array(i1,i2,i3,i4,i5,:,i6))
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      case (7)
        allocate( product_complex_single_st_dim_7D(size(array,1), size(array,2), size(array,3), &
                                               size(array,4), size(array,5), size(array,6)) ) 
        do i6=1,size(product_complex_single_st_dim_7D,6)
          do i5=1,size(product_complex_single_st_dim_7D,5)
            do i4=1,size(product_complex_single_st_dim_7D,4)
              do i3=1,size(product_complex_single_st_dim_7D,3)
                do i2=1,size(product_complex_single_st_dim_7D,2)
                  do i1=1,size(product_complex_single_st_dim_7D,1)
                    if (present(mask)) then
                      product_complex_single_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          product(array(i1,i2,i3,i4,i5,i6,:), mask(i1,i2,i3,i4,i5,i6,:))
                    else
                      product_complex_single_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          product(array(i1,i2,i3,i4,i5,i6,:))
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      case default
        allocate( product_complex_single_st_dim_7D(0,0,0,0,0,0) ) 
        write(ERROR_UNIT, *) "Incorrect value of DIM argument :"
        write(ERROR_UNIT, *) "a zero-sized array has been returned."
    end select
  end function product_complex_single_st_dim_7D

  function product_complex_double_st_dim_7D(array, dim, mask)
    use ISO_FORTRAN_ENV, only : ERROR_UNIT
    ! Dummy arguments declaration
    type(complex_double_st), dimension(:,:,:,:,:,:,:), intent(in) :: array
    logical,       optional, dimension(:,:,:,:,:,:,:), intent(in) :: mask
    integer,                                           intent(in) :: dim
    type(complex_double_st), dimension(:,:,:,:,:,:), allocatable :: product_complex_double_st_dim_7D
    ! Local declaration
    integer i1, i2, i3, i4, i5, i6

    select case (dim)
      case (1)
        allocate( product_complex_double_st_dim_7D(size(array,2), size(array,3), size(array,4), &
                                               size(array,5), size(array,6), size(array,7)) ) 
        do i6=1,size(product_complex_double_st_dim_7D,6)
          do i5=1,size(product_complex_double_st_dim_7D,5)
            do i4=1,size(product_complex_double_st_dim_7D,4)
              do i3=1,size(product_complex_double_st_dim_7D,3)
                do i2=1,size(product_complex_double_st_dim_7D,2)
                  do i1=1,size(product_complex_double_st_dim_7D,1)
                    if (present(mask)) then
                      product_complex_double_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          product(array(:,i1,i2,i3,i4,i5,i6), mask(:,i1,i2,i3,i4,i5,i6))
                    else
                      product_complex_double_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          product(array(:,i1,i2,i3,i4,i5,i6))
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      case (2)
        allocate( product_complex_double_st_dim_7D(size(array,1), size(array,3), size(array,4), &
                                               size(array,5), size(array,6), size(array,7)) ) 
        do i6=1,size(product_complex_double_st_dim_7D,6)
          do i5=1,size(product_complex_double_st_dim_7D,5)
            do i4=1,size(product_complex_double_st_dim_7D,4)
              do i3=1,size(product_complex_double_st_dim_7D,3)
                do i2=1,size(product_complex_double_st_dim_7D,2)
                  do i1=1,size(product_complex_double_st_dim_7D,1)
                    if (present(mask)) then
                      product_complex_double_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          product(array(i1,:,i2,i3,i4,i5,i6), mask(i1,:,i2,i3,i4,i5,i6))
                    else
                      product_complex_double_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          product(array(i1,:,i2,i3,i4,i5,i6))
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      case (3)
        allocate( product_complex_double_st_dim_7D(size(array,1), size(array,2), size(array,4), &
                                               size(array,5), size(array,6), size(array,7)) ) 
        do i6=1,size(product_complex_double_st_dim_7D,6)
          do i5=1,size(product_complex_double_st_dim_7D,5)
            do i4=1,size(product_complex_double_st_dim_7D,4)
              do i3=1,size(product_complex_double_st_dim_7D,3)
                do i2=1,size(product_complex_double_st_dim_7D,2)
                  do i1=1,size(product_complex_double_st_dim_7D,1)
                    if (present(mask)) then
                      product_complex_double_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          product(array(i1,i2,:,i3,i4,i5,i6), mask(i1,i2,:,i3,i4,i5,i6))
                    else
                      product_complex_double_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          product(array(i1,i2,:,i3,i4,i5,i6))
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      case (4)
        allocate( product_complex_double_st_dim_7D(size(array,1), size(array,2), size(array,3), &
                                               size(array,5), size(array,6), size(array,7)) ) 
        do i6=1,size(product_complex_double_st_dim_7D,6)
          do i5=1,size(product_complex_double_st_dim_7D,5)
            do i4=1,size(product_complex_double_st_dim_7D,4)
              do i3=1,size(product_complex_double_st_dim_7D,3)
                do i2=1,size(product_complex_double_st_dim_7D,2)
                  do i1=1,size(product_complex_double_st_dim_7D,1)
                    if (present(mask)) then
                      product_complex_double_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          product(array(i1,i2,i3,:,i4,i5,i6), mask(i1,i2,i3,:,i4,i5,i6))
                    else
                      product_complex_double_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          product(array(i1,i2,i3,:,i4,i5,i6))
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      case (5)
        allocate( product_complex_double_st_dim_7D(size(array,1), size(array,2), size(array,3), &
                                               size(array,4), size(array,6), size(array,7)) ) 
        do i6=1,size(product_complex_double_st_dim_7D,6)
          do i5=1,size(product_complex_double_st_dim_7D,5)
            do i4=1,size(product_complex_double_st_dim_7D,4)
              do i3=1,size(product_complex_double_st_dim_7D,3)
                do i2=1,size(product_complex_double_st_dim_7D,2)
                  do i1=1,size(product_complex_double_st_dim_7D,1)
                    if (present(mask)) then
                      product_complex_double_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          product(array(i1,i2,i3,i4,:,i5,i6), mask(i1,i2,i3,i4,:,i5,i6))
                    else
                      product_complex_double_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          product(array(i1,i2,i3,i4,:,i5,i6))
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      case (6)
        allocate( product_complex_double_st_dim_7D(size(array,1), size(array,2), size(array,3), &
                                               size(array,4), size(array,5), size(array,7)) ) 
        do i6=1,size(product_complex_double_st_dim_7D,6)
          do i5=1,size(product_complex_double_st_dim_7D,5)
            do i4=1,size(product_complex_double_st_dim_7D,4)
              do i3=1,size(product_complex_double_st_dim_7D,3)
                do i2=1,size(product_complex_double_st_dim_7D,2)
                  do i1=1,size(product_complex_double_st_dim_7D,1)
                    if (present(mask)) then
                      product_complex_double_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          product(array(i1,i2,i3,i4,i5,:,i6), mask(i1,i2,i3,i4,i5,:,i6))
                    else
                      product_complex_double_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          product(array(i1,i2,i3,i4,i5,:,i6))
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      case (7)
        allocate( product_complex_double_st_dim_7D(size(array,1), size(array,2), size(array,3), &
                                               size(array,4), size(array,5), size(array,6)) ) 
        do i6=1,size(product_complex_double_st_dim_7D,6)
          do i5=1,size(product_complex_double_st_dim_7D,5)
            do i4=1,size(product_complex_double_st_dim_7D,4)
              do i3=1,size(product_complex_double_st_dim_7D,3)
                do i2=1,size(product_complex_double_st_dim_7D,2)
                  do i1=1,size(product_complex_double_st_dim_7D,1)
                    if (present(mask)) then
                      product_complex_double_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          product(array(i1,i2,i3,i4,i5,i6,:), mask(i1,i2,i3,i4,i5,i6,:))
                    else
                      product_complex_double_st_dim_7D(i1,i2,i3,i4,i5,i6) = &
                          product(array(i1,i2,i3,i4,i5,i6,:))
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      case default
        allocate( product_complex_double_st_dim_7D(0,0,0,0,0,0) ) 
        write(ERROR_UNIT, *) "Incorrect value of DIM argument :"
        write(ERROR_UNIT, *) "a zero-sized array has been returned."
    end select
  end function product_complex_double_st_dim_7D




end module cadna_cmplx_array

      program ex5_cad_opt
      use cadna
      implicit type (double_st) (a-h,o-z)
      parameter (nmax = 100)
!
      call cadna_init(-1)
      y = 0.5d0
      do i = 1,nmax
        x = y
          y = ((4.2d0*x + 3.5d0)*x + 1.5d0)/(6.3d0*x + 6.1d0)
          if (x.eq.y) goto 1
      enddo
!
 1    continue
!
      write(*,*)'x(',i-1,') = ',str(x)
      write(*,*)'x(',i,') = ',str(y)
      call cadna_end()
!
      end

!Copyright 2017 R. CARPENTIER, P. CORDE, F. JEZEQUEL, J.-L. LAMOTTE
!
!This file is part of CADNA.
!
!    CADNA is free software: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as
!    published by the Free Software Foundation, either version 3 of the
!    License, or (at your option) any later version.
!
!    CADNA is distributed in the hope that it will be useful, but WITHOUT
!    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
!    or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General
!    Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public
!    License along with CADNA. If not, see
!    <http://www.gnu.org/licenses/>.
!


! Module de surcharge de l'opérateur "/="




module cadna_ne
  use ISO_C_BINDING, only : C_BOOL, C_LONG_LONG, C_LONG, C_INT, C_SHORT, C_FLOAT, C_DOUBLE
  !`use ISO_C_BINDING, only : C_BOOL, C_LONG_LONG, C_LONG, C_INT, C_SHORT, C_FLOAT'
  use cadna_types
  implicit none

!INIT(ne, C_LONG_LONG, C_LONG, C_INT, C_SHORT, C_FLOAT, C_DOUBLE)



  interface operator(/=)
    module procedure ne_double_st_double_st
  end interface operator(/=)
  interface
    pure function cpp_ne_double_st_double_st(a, b) bind(C)
      import C_BOOL
      import double_st
      
      type(double_st), intent(in) :: a
      type(double_st), intent(in) :: b
      logical(C_BOOL) :: cpp_ne_double_st_double_st
      !logical :: cpp_ne_double_st_double_st
    end function cpp_ne_double_st_double_st
  end interface

  interface operator(/=)
    module procedure ne_double_st_single_st
  end interface operator(/=)
  interface
    pure function cpp_ne_double_st_single_st(a, b) bind(C)
      import C_BOOL
      import double_st
      import single_st
      type(double_st), intent(in) :: a
      type(single_st), intent(in) :: b
      logical(C_BOOL) :: cpp_ne_double_st_single_st
      !logical :: cpp_ne_double_st_single_st
    end function cpp_ne_double_st_single_st
  end interface

  interface operator(/=)
    module procedure ne_double_st_double
  end interface operator(/=)
  interface
    pure function cpp_ne_double_st_double(a, b) bind(C)
      import C_BOOL
      import double_st
      import C_DOUBLE
      type(double_st), intent(in) :: a
      real(C_DOUBLE), intent(in) :: b
      logical(C_BOOL) :: cpp_ne_double_st_double
      !logical :: cpp_ne_double_st_double
    end function cpp_ne_double_st_double
  end interface

  interface operator(/=)
    module procedure ne_double_st_float
  end interface operator(/=)
  interface
    pure function cpp_ne_double_st_float(a, b) bind(C)
      import C_BOOL
      import double_st
      import C_FLOAT
      type(double_st), intent(in) :: a
      real(C_FLOAT), intent(in) :: b
      logical(C_BOOL) :: cpp_ne_double_st_float
      !logical :: cpp_ne_double_st_float
    end function cpp_ne_double_st_float
  end interface

  interface operator(/=)
    module procedure ne_double_st_long_long
  end interface operator(/=)
  interface
    pure function cpp_ne_double_st_long_long(a, b) bind(C)
      import C_BOOL
      import double_st
      import C_LONG_LONG
      type(double_st), intent(in) :: a
      integer(C_LONG_LONG), intent(in) :: b
      logical(C_BOOL) :: cpp_ne_double_st_long_long
      !logical :: cpp_ne_double_st_long_long
    end function cpp_ne_double_st_long_long
  end interface

!INTERFACE_OP(/=, ne, double_st, long)
  interface operator(/=)
    module procedure ne_double_st_int
  end interface operator(/=)
  interface
    pure function cpp_ne_double_st_int(a, b) bind(C)
      import C_BOOL
      import double_st
      import C_INT
      type(double_st), intent(in) :: a
      integer(C_INT), intent(in) :: b
      logical(C_BOOL) :: cpp_ne_double_st_int
      !logical :: cpp_ne_double_st_int
    end function cpp_ne_double_st_int
  end interface

  interface operator(/=)
    module procedure ne_double_st_short
  end interface operator(/=)
  interface
    pure function cpp_ne_double_st_short(a, b) bind(C)
      import C_BOOL
      import double_st
      import C_SHORT
      type(double_st), intent(in) :: a
      integer(C_SHORT), intent(in) :: b
      logical(C_BOOL) :: cpp_ne_double_st_short
      !logical :: cpp_ne_double_st_short
    end function cpp_ne_double_st_short
  end interface


  interface operator(/=)
    module procedure ne_single_st_double_st
  end interface operator(/=)
  interface
    pure function cpp_ne_single_st_double_st(a, b) bind(C)
      import C_BOOL
      import single_st
      import double_st
      type(single_st), intent(in) :: a
      type(double_st), intent(in) :: b
      logical(C_BOOL) :: cpp_ne_single_st_double_st
      !logical :: cpp_ne_single_st_double_st
    end function cpp_ne_single_st_double_st
  end interface

  interface operator(/=)
    module procedure ne_single_st_single_st
  end interface operator(/=)
  interface
    pure function cpp_ne_single_st_single_st(a, b) bind(C)
      import C_BOOL
      import single_st
      
      type(single_st), intent(in) :: a
      type(single_st), intent(in) :: b
      logical(C_BOOL) :: cpp_ne_single_st_single_st
      !logical :: cpp_ne_single_st_single_st
    end function cpp_ne_single_st_single_st
  end interface

  interface operator(/=)
    module procedure ne_single_st_double
  end interface operator(/=)
  interface
    pure function cpp_ne_single_st_double(a, b) bind(C)
      import C_BOOL
      import single_st
      import C_DOUBLE
      type(single_st), intent(in) :: a
      real(C_DOUBLE), intent(in) :: b
      logical(C_BOOL) :: cpp_ne_single_st_double
      !logical :: cpp_ne_single_st_double
    end function cpp_ne_single_st_double
  end interface

  interface operator(/=)
    module procedure ne_single_st_float
  end interface operator(/=)
  interface
    pure function cpp_ne_single_st_float(a, b) bind(C)
      import C_BOOL
      import single_st
      import C_FLOAT
      type(single_st), intent(in) :: a
      real(C_FLOAT), intent(in) :: b
      logical(C_BOOL) :: cpp_ne_single_st_float
      !logical :: cpp_ne_single_st_float
    end function cpp_ne_single_st_float
  end interface

  interface operator(/=)
    module procedure ne_single_st_long_long
  end interface operator(/=)
  interface
    pure function cpp_ne_single_st_long_long(a, b) bind(C)
      import C_BOOL
      import single_st
      import C_LONG_LONG
      type(single_st), intent(in) :: a
      integer(C_LONG_LONG), intent(in) :: b
      logical(C_BOOL) :: cpp_ne_single_st_long_long
      !logical :: cpp_ne_single_st_long_long
    end function cpp_ne_single_st_long_long
  end interface

!INTERFACE_OP(/=, ne, single_st, long)
  interface operator(/=)
    module procedure ne_single_st_int
  end interface operator(/=)
  interface
    pure function cpp_ne_single_st_int(a, b) bind(C)
      import C_BOOL
      import single_st
      import C_INT
      type(single_st), intent(in) :: a
      integer(C_INT), intent(in) :: b
      logical(C_BOOL) :: cpp_ne_single_st_int
      !logical :: cpp_ne_single_st_int
    end function cpp_ne_single_st_int
  end interface

  interface operator(/=)
    module procedure ne_single_st_short
  end interface operator(/=)
  interface
    pure function cpp_ne_single_st_short(a, b) bind(C)
      import C_BOOL
      import single_st
      import C_SHORT
      type(single_st), intent(in) :: a
      integer(C_SHORT), intent(in) :: b
      logical(C_BOOL) :: cpp_ne_single_st_short
      !logical :: cpp_ne_single_st_short
    end function cpp_ne_single_st_short
  end interface


  interface operator(/=)
    module procedure ne_double_double_st
  end interface operator(/=)
  interface
    pure function cpp_ne_double_double_st(a, b) bind(C)
      import C_BOOL
      import C_DOUBLE
      import double_st
      real(C_DOUBLE), intent(in) :: a
      type(double_st), intent(in) :: b
      logical(C_BOOL) :: cpp_ne_double_double_st
      !logical :: cpp_ne_double_double_st
    end function cpp_ne_double_double_st
  end interface

  interface operator(/=)
    module procedure ne_double_single_st
  end interface operator(/=)
  interface
    pure function cpp_ne_double_single_st(a, b) bind(C)
      import C_BOOL
      import C_DOUBLE
      import single_st
      real(C_DOUBLE), intent(in) :: a
      type(single_st), intent(in) :: b
      logical(C_BOOL) :: cpp_ne_double_single_st
      !logical :: cpp_ne_double_single_st
    end function cpp_ne_double_single_st
  end interface


  interface operator(/=)
    module procedure ne_float_double_st
  end interface operator(/=)
  interface
    pure function cpp_ne_float_double_st(a, b) bind(C)
      import C_BOOL
      import C_FLOAT
      import double_st
      real(C_FLOAT), intent(in) :: a
      type(double_st), intent(in) :: b
      logical(C_BOOL) :: cpp_ne_float_double_st
      !logical :: cpp_ne_float_double_st
    end function cpp_ne_float_double_st
  end interface

  interface operator(/=)
    module procedure ne_float_single_st
  end interface operator(/=)
  interface
    pure function cpp_ne_float_single_st(a, b) bind(C)
      import C_BOOL
      import C_FLOAT
      import single_st
      real(C_FLOAT), intent(in) :: a
      type(single_st), intent(in) :: b
      logical(C_BOOL) :: cpp_ne_float_single_st
      !logical :: cpp_ne_float_single_st
    end function cpp_ne_float_single_st
  end interface


  interface operator(/=)
    module procedure ne_long_long_double_st
  end interface operator(/=)
  interface
    pure function cpp_ne_long_long_double_st(a, b) bind(C)
      import C_BOOL
      import C_LONG_LONG
      import double_st
      integer(C_LONG_LONG), intent(in) :: a
      type(double_st), intent(in) :: b
      logical(C_BOOL) :: cpp_ne_long_long_double_st
      !logical :: cpp_ne_long_long_double_st
    end function cpp_ne_long_long_double_st
  end interface

  interface operator(/=)
    module procedure ne_long_long_single_st
  end interface operator(/=)
  interface
    pure function cpp_ne_long_long_single_st(a, b) bind(C)
      import C_BOOL
      import C_LONG_LONG
      import single_st
      integer(C_LONG_LONG), intent(in) :: a
      type(single_st), intent(in) :: b
      logical(C_BOOL) :: cpp_ne_long_long_single_st
      !logical :: cpp_ne_long_long_single_st
    end function cpp_ne_long_long_single_st
  end interface


!INTERFACE_OP(/=, ne, long,     double_st)
!INTERFACE_OP(/=, ne, long,     single_st)

  interface operator(/=)
    module procedure ne_int_double_st
  end interface operator(/=)
  interface
    pure function cpp_ne_int_double_st(a, b) bind(C)
      import C_BOOL
      import C_INT
      import double_st
      integer(C_INT), intent(in) :: a
      type(double_st), intent(in) :: b
      logical(C_BOOL) :: cpp_ne_int_double_st
      !logical :: cpp_ne_int_double_st
    end function cpp_ne_int_double_st
  end interface

  interface operator(/=)
    module procedure ne_int_single_st
  end interface operator(/=)
  interface
    pure function cpp_ne_int_single_st(a, b) bind(C)
      import C_BOOL
      import C_INT
      import single_st
      integer(C_INT), intent(in) :: a
      type(single_st), intent(in) :: b
      logical(C_BOOL) :: cpp_ne_int_single_st
      !logical :: cpp_ne_int_single_st
    end function cpp_ne_int_single_st
  end interface


  interface operator(/=)
    module procedure ne_short_double_st
  end interface operator(/=)
  interface
    pure function cpp_ne_short_double_st(a, b) bind(C)
      import C_BOOL
      import C_SHORT
      import double_st
      integer(C_SHORT), intent(in) :: a
      type(double_st), intent(in) :: b
      logical(C_BOOL) :: cpp_ne_short_double_st
      !logical :: cpp_ne_short_double_st
    end function cpp_ne_short_double_st
  end interface

  interface operator(/=)
    module procedure ne_short_single_st
  end interface operator(/=)
  interface
    pure function cpp_ne_short_single_st(a, b) bind(C)
      import C_BOOL
      import C_SHORT
      import single_st
      integer(C_SHORT), intent(in) :: a
      type(single_st), intent(in) :: b
      logical(C_BOOL) :: cpp_ne_short_single_st
      !logical :: cpp_ne_short_single_st
    end function cpp_ne_short_single_st
  end interface


contains



  elemental function ne_double_st_double_st(a, b)
    type(double_st), intent(in) :: a
    type(double_st), intent(in) :: b
    !logical(C_BOOL) ne_double_st_double_st
    logical ne_double_st_double_st

    ne_double_st_double_st = cpp_ne_double_st_double_st(a, b)
  end function ne_double_st_double_st

  elemental function ne_double_st_single_st(a, b)
    type(double_st), intent(in) :: a
    type(single_st), intent(in) :: b
    !logical(C_BOOL) ne_double_st_single_st
    logical ne_double_st_single_st

    ne_double_st_single_st = cpp_ne_double_st_single_st(a, b)
  end function ne_double_st_single_st

  elemental function ne_double_st_double(a, b)
    type(double_st), intent(in) :: a
    real(C_DOUBLE), intent(in) :: b
    !logical(C_BOOL) ne_double_st_double
    logical ne_double_st_double

    ne_double_st_double = cpp_ne_double_st_double(a, b)
  end function ne_double_st_double

  elemental function ne_double_st_float(a, b)
    type(double_st), intent(in) :: a
    real(C_FLOAT), intent(in) :: b
    !logical(C_BOOL) ne_double_st_float
    logical ne_double_st_float

    ne_double_st_float = cpp_ne_double_st_float(a, b)
  end function ne_double_st_float

  elemental function ne_double_st_long_long(a, b)
    type(double_st), intent(in) :: a
    integer(C_LONG_LONG), intent(in) :: b
    !logical(C_BOOL) ne_double_st_long_long
    logical ne_double_st_long_long

    ne_double_st_long_long = cpp_ne_double_st_long_long(a, b)
  end function ne_double_st_long_long

!CONTAINS_OP(ne, double_st, long)
  elemental function ne_double_st_int(a, b)
    type(double_st), intent(in) :: a
    integer(C_INT), intent(in) :: b
    !logical(C_BOOL) ne_double_st_int
    logical ne_double_st_int

    ne_double_st_int = cpp_ne_double_st_int(a, b)
  end function ne_double_st_int

  elemental function ne_double_st_short(a, b)
    type(double_st), intent(in) :: a
    integer(C_SHORT), intent(in) :: b
    !logical(C_BOOL) ne_double_st_short
    logical ne_double_st_short

    ne_double_st_short = cpp_ne_double_st_short(a, b)
  end function ne_double_st_short


  elemental function ne_single_st_double_st(a, b)
    type(single_st), intent(in) :: a
    type(double_st), intent(in) :: b
    !logical(C_BOOL) ne_single_st_double_st
    logical ne_single_st_double_st

    ne_single_st_double_st = cpp_ne_single_st_double_st(a, b)
  end function ne_single_st_double_st

  elemental function ne_single_st_single_st(a, b)
    type(single_st), intent(in) :: a
    type(single_st), intent(in) :: b
    !logical(C_BOOL) ne_single_st_single_st
    logical ne_single_st_single_st

    ne_single_st_single_st = cpp_ne_single_st_single_st(a, b)
  end function ne_single_st_single_st

  elemental function ne_single_st_double(a, b)
    type(single_st), intent(in) :: a
    real(C_DOUBLE), intent(in) :: b
    !logical(C_BOOL) ne_single_st_double
    logical ne_single_st_double

    ne_single_st_double = cpp_ne_single_st_double(a, b)
  end function ne_single_st_double

  elemental function ne_single_st_float(a, b)
    type(single_st), intent(in) :: a
    real(C_FLOAT), intent(in) :: b
    !logical(C_BOOL) ne_single_st_float
    logical ne_single_st_float

    ne_single_st_float = cpp_ne_single_st_float(a, b)
  end function ne_single_st_float

  elemental function ne_single_st_long_long(a, b)
    type(single_st), intent(in) :: a
    integer(C_LONG_LONG), intent(in) :: b
    !logical(C_BOOL) ne_single_st_long_long
    logical ne_single_st_long_long

    ne_single_st_long_long = cpp_ne_single_st_long_long(a, b)
  end function ne_single_st_long_long

!CONTAINS_OP(ne, single_st, long)
  elemental function ne_single_st_int(a, b)
    type(single_st), intent(in) :: a
    integer(C_INT), intent(in) :: b
    !logical(C_BOOL) ne_single_st_int
    logical ne_single_st_int

    ne_single_st_int = cpp_ne_single_st_int(a, b)
  end function ne_single_st_int

  elemental function ne_single_st_short(a, b)
    type(single_st), intent(in) :: a
    integer(C_SHORT), intent(in) :: b
    !logical(C_BOOL) ne_single_st_short
    logical ne_single_st_short

    ne_single_st_short = cpp_ne_single_st_short(a, b)
  end function ne_single_st_short


  elemental function ne_double_double_st(a, b)
    real(C_DOUBLE), intent(in) :: a
    type(double_st), intent(in) :: b
    !logical(C_BOOL) ne_double_double_st
    logical ne_double_double_st

    ne_double_double_st = cpp_ne_double_double_st(a, b)
  end function ne_double_double_st

  elemental function ne_double_single_st(a, b)
    real(C_DOUBLE), intent(in) :: a
    type(single_st), intent(in) :: b
    !logical(C_BOOL) ne_double_single_st
    logical ne_double_single_st

    ne_double_single_st = cpp_ne_double_single_st(a, b)
  end function ne_double_single_st


  elemental function ne_float_double_st(a, b)
    real(C_FLOAT), intent(in) :: a
    type(double_st), intent(in) :: b
    !logical(C_BOOL) ne_float_double_st
    logical ne_float_double_st

    ne_float_double_st = cpp_ne_float_double_st(a, b)
  end function ne_float_double_st

  elemental function ne_float_single_st(a, b)
    real(C_FLOAT), intent(in) :: a
    type(single_st), intent(in) :: b
    !logical(C_BOOL) ne_float_single_st
    logical ne_float_single_st

    ne_float_single_st = cpp_ne_float_single_st(a, b)
  end function ne_float_single_st


  elemental function ne_long_long_double_st(a, b)
    integer(C_LONG_LONG), intent(in) :: a
    type(double_st), intent(in) :: b
    !logical(C_BOOL) ne_long_long_double_st
    logical ne_long_long_double_st

    ne_long_long_double_st = cpp_ne_long_long_double_st(a, b)
  end function ne_long_long_double_st

  elemental function ne_long_long_single_st(a, b)
    integer(C_LONG_LONG), intent(in) :: a
    type(single_st), intent(in) :: b
    !logical(C_BOOL) ne_long_long_single_st
    logical ne_long_long_single_st

    ne_long_long_single_st = cpp_ne_long_long_single_st(a, b)
  end function ne_long_long_single_st


!CONTAINS_OP(ne, long,     double_st)
!CONTAINS_OP(ne, long,     single_st)

  elemental function ne_int_double_st(a, b)
    integer(C_INT), intent(in) :: a
    type(double_st), intent(in) :: b
    !logical(C_BOOL) ne_int_double_st
    logical ne_int_double_st

    ne_int_double_st = cpp_ne_int_double_st(a, b)
  end function ne_int_double_st

  elemental function ne_int_single_st(a, b)
    integer(C_INT), intent(in) :: a
    type(single_st), intent(in) :: b
    !logical(C_BOOL) ne_int_single_st
    logical ne_int_single_st

    ne_int_single_st = cpp_ne_int_single_st(a, b)
  end function ne_int_single_st


  elemental function ne_short_double_st(a, b)
    integer(C_SHORT), intent(in) :: a
    type(double_st), intent(in) :: b
    !logical(C_BOOL) ne_short_double_st
    logical ne_short_double_st

    ne_short_double_st = cpp_ne_short_double_st(a, b)
  end function ne_short_double_st

  elemental function ne_short_single_st(a, b)
    integer(C_SHORT), intent(in) :: a
    type(single_st), intent(in) :: b
    !logical(C_BOOL) ne_short_single_st
    logical ne_short_single_st

    ne_short_single_st = cpp_ne_short_single_st(a, b)
  end function ne_short_single_st




end module cadna_ne

!Copyright 2017 R. CARPENTIER, P. CORDE, F. JEZEQUEL, J.-L. LAMOTTE
!
!This file is part of CADNA.
!
!    CADNA is free software: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as
!    published by the Free Software Foundation, either version 3 of the
!    License, or (at your option) any later version.
!
!    CADNA is distributed in the hope that it will be useful, but WITHOUT
!    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
!    or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General
!    Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public
!    License along with CADNA. If not, see
!    <http://www.gnu.org/licenses/>.
!



! Module de surcharge des fonctions mathématiques




module cadna_math
  use ISO_C_BINDING, only : C_SHORT, C_INT, C_LONG_LONG
  use cadna_types
  use cadna_affect
  use cadna_add
  use cadna_sub
  use cadna_mult
  use cadna_pow

  implicit none




  interface dabs
    module procedure dabs_double_st
  end interface

  interface dsqrt
    module procedure dsqrt_double_st
  end interface

  interface dsin
    module procedure dsin_double_st
  end interface

  interface dcos
    module procedure dcos_double_st
  end interface

  interface dtan
    module procedure dtan_double_st
  end interface

  interface dexp
    module procedure dexp_double_st
  end interface

  interface dlog
    module procedure dlog_double_st
  end interface




  interface abs
    module procedure abs_single_st
  end interface
  interface
    pure function cpp_abs_single_st(a) bind(C)
      import single_st
      
      type(single_st), intent(in) :: a
      type(single_st)  cpp_abs_single_st
    end function cpp_abs_single_st
  end interface

  interface abs
    module procedure abs_double_st
  end interface
  interface
    pure function cpp_abs_double_st(a) bind(C)
      import double_st
      
      type(double_st), intent(in) :: a
      type(double_st)  cpp_abs_double_st
    end function cpp_abs_double_st
  end interface

  interface acos
    module procedure acos_single_st
  end interface
  interface
    pure function cpp_acos_single_st(a) bind(C)
      import single_st
      
      type(single_st), intent(in) :: a
      type(single_st)  cpp_acos_single_st
    end function cpp_acos_single_st
  end interface

  interface acos
    module procedure acos_double_st
  end interface
  interface
    pure function cpp_acos_double_st(a) bind(C)
      import double_st
      
      type(double_st), intent(in) :: a
      type(double_st)  cpp_acos_double_st
    end function cpp_acos_double_st
  end interface

  interface acosh
    module procedure acosh_single_st
  end interface
  interface
    pure function cpp_acosh_single_st(a) bind(C)
      import single_st
      
      type(single_st), intent(in) :: a
      type(single_st)  cpp_acosh_single_st
    end function cpp_acosh_single_st
  end interface

  interface acosh
    module procedure acosh_double_st
  end interface
  interface
    pure function cpp_acosh_double_st(a) bind(C)
      import double_st
      
      type(double_st), intent(in) :: a
      type(double_st)  cpp_acosh_double_st
    end function cpp_acosh_double_st
  end interface

  interface aint
    module procedure aint_single_st
  end interface
  interface
    pure function cpp_aint_single_st(a) bind(C)
      import single_st
      
      type(single_st), intent(in) :: a
      type(single_st)  cpp_aint_single_st
    end function cpp_aint_single_st
  end interface

  interface aint
    module procedure aint_double_st
  end interface
  interface
    pure function cpp_aint_double_st(a) bind(C)
      import double_st
      
      type(double_st), intent(in) :: a
      type(double_st)  cpp_aint_double_st
    end function cpp_aint_double_st
  end interface

!INTERFACE_MATH_UNAIRE(anint,   single_st, int)
!INTERFACE_MATH_UNAIRE(anint,   double_st, int)
  interface asin
    module procedure asin_single_st
  end interface
  interface
    pure function cpp_asin_single_st(a) bind(C)
      import single_st
      
      type(single_st), intent(in) :: a
      type(single_st)  cpp_asin_single_st
    end function cpp_asin_single_st
  end interface

  interface asin
    module procedure asin_double_st
  end interface
  interface
    pure function cpp_asin_double_st(a) bind(C)
      import double_st
      
      type(double_st), intent(in) :: a
      type(double_st)  cpp_asin_double_st
    end function cpp_asin_double_st
  end interface

  interface asinh
    module procedure asinh_single_st
  end interface
  interface
    pure function cpp_asinh_single_st(a) bind(C)
      import single_st
      
      type(single_st), intent(in) :: a
      type(single_st)  cpp_asinh_single_st
    end function cpp_asinh_single_st
  end interface

  interface asinh
    module procedure asinh_double_st
  end interface
  interface
    pure function cpp_asinh_double_st(a) bind(C)
      import double_st
      
      type(double_st), intent(in) :: a
      type(double_st)  cpp_asinh_double_st
    end function cpp_asinh_double_st
  end interface

  interface atan
    module procedure atan_single_st
  end interface
  interface
    pure function cpp_atan_single_st(a) bind(C)
      import single_st
      
      type(single_st), intent(in) :: a
      type(single_st)  cpp_atan_single_st
    end function cpp_atan_single_st
  end interface

  interface atan
    module procedure atan_double_st
  end interface
  interface
    pure function cpp_atan_double_st(a) bind(C)
      import double_st
      
      type(double_st), intent(in) :: a
      type(double_st)  cpp_atan_double_st
    end function cpp_atan_double_st
  end interface

  interface atanh
    module procedure atanh_single_st
  end interface
  interface
    pure function cpp_atanh_single_st(a) bind(C)
      import single_st
      
      type(single_st), intent(in) :: a
      type(single_st)  cpp_atanh_single_st
    end function cpp_atanh_single_st
  end interface

  interface atanh
    module procedure atanh_double_st
  end interface
  interface
    pure function cpp_atanh_double_st(a) bind(C)
      import double_st
      
      type(double_st), intent(in) :: a
      type(double_st)  cpp_atanh_double_st
    end function cpp_atanh_double_st
  end interface

  interface ceiling
    module procedure ceiling_single_st
  end interface
  interface
    pure function cpp_ceiling_single_st(a) bind(C)
      import single_st
      import C_INT
      type(single_st), intent(in) :: a
      integer(C_INT) cpp_ceiling_single_st
    end function cpp_ceiling_single_st
  end interface

  interface ceiling
    module procedure ceiling_double_st
  end interface
  interface
    pure function cpp_ceiling_double_st(a) bind(C)
      import double_st
      import C_INT
      type(double_st), intent(in) :: a
      integer(C_INT) cpp_ceiling_double_st
    end function cpp_ceiling_double_st
  end interface

  interface cos
    module procedure cos_single_st
  end interface
  interface
    pure function cpp_cos_single_st(a) bind(C)
      import single_st
      
      type(single_st), intent(in) :: a
      type(single_st)  cpp_cos_single_st
    end function cpp_cos_single_st
  end interface

  interface cos
    module procedure cos_double_st
  end interface
  interface
    pure function cpp_cos_double_st(a) bind(C)
      import double_st
      
      type(double_st), intent(in) :: a
      type(double_st)  cpp_cos_double_st
    end function cpp_cos_double_st
  end interface

  interface cosh
    module procedure cosh_single_st
  end interface
  interface
    pure function cpp_cosh_single_st(a) bind(C)
      import single_st
      
      type(single_st), intent(in) :: a
      type(single_st)  cpp_cosh_single_st
    end function cpp_cosh_single_st
  end interface

  interface cosh
    module procedure cosh_double_st
  end interface
  interface
    pure function cpp_cosh_double_st(a) bind(C)
      import double_st
      
      type(double_st), intent(in) :: a
      type(double_st)  cpp_cosh_double_st
    end function cpp_cosh_double_st
  end interface

  interface erf
    module procedure erf_single_st
  end interface
  interface
    pure function cpp_erf_single_st(a) bind(C)
      import single_st
      
      type(single_st), intent(in) :: a
      type(single_st)  cpp_erf_single_st
    end function cpp_erf_single_st
  end interface

  interface erf
    module procedure erf_double_st
  end interface
  interface
    pure function cpp_erf_double_st(a) bind(C)
      import double_st
      
      type(double_st), intent(in) :: a
      type(double_st)  cpp_erf_double_st
    end function cpp_erf_double_st
  end interface

  interface erfc
    module procedure erfc_single_st
  end interface
  interface
    pure function cpp_erfc_single_st(a) bind(C)
      import single_st
      
      type(single_st), intent(in) :: a
      type(single_st)  cpp_erfc_single_st
    end function cpp_erfc_single_st
  end interface

  interface erfc
    module procedure erfc_double_st
  end interface
  interface
    pure function cpp_erfc_double_st(a) bind(C)
      import double_st
      
      type(double_st), intent(in) :: a
      type(double_st)  cpp_erfc_double_st
    end function cpp_erfc_double_st
  end interface

  interface exp
    module procedure exp_single_st
  end interface
  interface
    pure function cpp_exp_single_st(a) bind(C)
      import single_st
      
      type(single_st), intent(in) :: a
      type(single_st)  cpp_exp_single_st
    end function cpp_exp_single_st
  end interface

  interface exp
    module procedure exp_double_st
  end interface
  interface
    pure function cpp_exp_double_st(a) bind(C)
      import double_st
      
      type(double_st), intent(in) :: a
      type(double_st)  cpp_exp_double_st
    end function cpp_exp_double_st
  end interface

  interface floor
    module procedure floor_single_st
  end interface
  interface
    pure function cpp_floor_single_st(a) bind(C)
      import single_st
      import C_INT
      type(single_st), intent(in) :: a
      integer(C_INT) cpp_floor_single_st
    end function cpp_floor_single_st
  end interface

  interface floor
    module procedure floor_double_st
  end interface
  interface
    pure function cpp_floor_double_st(a) bind(C)
      import double_st
      import C_INT
      type(double_st), intent(in) :: a
      integer(C_INT) cpp_floor_double_st
    end function cpp_floor_double_st
  end interface

  interface log
    module procedure log_single_st
  end interface
  interface
    pure function cpp_log_single_st(a) bind(C)
      import single_st
      
      type(single_st), intent(in) :: a
      type(single_st)  cpp_log_single_st
    end function cpp_log_single_st
  end interface

  interface log
    module procedure log_double_st
  end interface
  interface
    pure function cpp_log_double_st(a) bind(C)
      import double_st
      
      type(double_st), intent(in) :: a
      type(double_st)  cpp_log_double_st
    end function cpp_log_double_st
  end interface

  interface log10
    module procedure log10_single_st
  end interface
  interface
    pure function cpp_log10_single_st(a) bind(C)
      import single_st
      
      type(single_st), intent(in) :: a
      type(single_st)  cpp_log10_single_st
    end function cpp_log10_single_st
  end interface

  interface log10
    module procedure log10_double_st
  end interface
  interface
    pure function cpp_log10_double_st(a) bind(C)
      import double_st
      
      type(double_st), intent(in) :: a
      type(double_st)  cpp_log10_double_st
    end function cpp_log10_double_st
  end interface

  interface nint
    module procedure nint_single_st
  end interface
  interface
    pure function cpp_nint_single_st(a) bind(C)
      import single_st
      import C_INT
      type(single_st), intent(in) :: a
      integer(C_INT) cpp_nint_single_st
    end function cpp_nint_single_st
  end interface

  interface nint
    module procedure nint_double_st
  end interface
  interface
    pure function cpp_nint_double_st(a) bind(C)
      import double_st
      import C_INT
      type(double_st), intent(in) :: a
      integer(C_INT) cpp_nint_double_st
    end function cpp_nint_double_st
  end interface

  interface sin
    module procedure sin_single_st
  end interface
  interface
    pure function cpp_sin_single_st(a) bind(C)
      import single_st
      
      type(single_st), intent(in) :: a
      type(single_st)  cpp_sin_single_st
    end function cpp_sin_single_st
  end interface

  interface sin
    module procedure sin_double_st
  end interface
  interface
    pure function cpp_sin_double_st(a) bind(C)
      import double_st
      
      type(double_st), intent(in) :: a
      type(double_st)  cpp_sin_double_st
    end function cpp_sin_double_st
  end interface

  interface sinh
    module procedure sinh_single_st
  end interface
  interface
    pure function cpp_sinh_single_st(a) bind(C)
      import single_st
      
      type(single_st), intent(in) :: a
      type(single_st)  cpp_sinh_single_st
    end function cpp_sinh_single_st
  end interface

  interface sinh
    module procedure sinh_double_st
  end interface
  interface
    pure function cpp_sinh_double_st(a) bind(C)
      import double_st
      
      type(double_st), intent(in) :: a
      type(double_st)  cpp_sinh_double_st
    end function cpp_sinh_double_st
  end interface

  interface sqrt
    module procedure sqrt_single_st
  end interface
  interface
    pure function cpp_sqrt_single_st(a) bind(C)
      import single_st
      
      type(single_st), intent(in) :: a
      type(single_st)  cpp_sqrt_single_st
    end function cpp_sqrt_single_st
  end interface

  interface sqrt
    module procedure sqrt_double_st
  end interface
  interface
    pure function cpp_sqrt_double_st(a) bind(C)
      import double_st
      
      type(double_st), intent(in) :: a
      type(double_st)  cpp_sqrt_double_st
    end function cpp_sqrt_double_st
  end interface

  interface tan
    module procedure tan_single_st
  end interface
  interface
    pure function cpp_tan_single_st(a) bind(C)
      import single_st
      
      type(single_st), intent(in) :: a
      type(single_st)  cpp_tan_single_st
    end function cpp_tan_single_st
  end interface

  interface tan
    module procedure tan_double_st
  end interface
  interface
    pure function cpp_tan_double_st(a) bind(C)
      import double_st
      
      type(double_st), intent(in) :: a
      type(double_st)  cpp_tan_double_st
    end function cpp_tan_double_st
  end interface

  interface tanh
    module procedure tanh_single_st
  end interface
  interface
    pure function cpp_tanh_single_st(a) bind(C)
      import single_st
      
      type(single_st), intent(in) :: a
      type(single_st)  cpp_tanh_single_st
    end function cpp_tanh_single_st
  end interface

  interface tanh
    module procedure tanh_double_st
  end interface
  interface
    pure function cpp_tanh_double_st(a) bind(C)
      import double_st
      
      type(double_st), intent(in) :: a
      type(double_st)  cpp_tanh_double_st
    end function cpp_tanh_double_st
  end interface




  interface atan2
    module procedure atan2_single_st_single_st
  end interface
  interface
    pure function cpp_atan2_single_st_single_st(a, b) bind(C)
      import single_st
      
      type(single_st), intent(in) :: a
      type(single_st), intent(in) :: b
      type(single_st) cpp_atan2_single_st_single_st
    end function cpp_atan2_single_st_single_st
  end interface

  interface atan2
    module procedure atan2_double_st_double_st
  end interface
  interface
    pure function cpp_atan2_double_st_double_st(a, b) bind(C)
      import double_st
      
      type(double_st), intent(in) :: a
      type(double_st), intent(in) :: b
      type(double_st) cpp_atan2_double_st_double_st
    end function cpp_atan2_double_st_double_st
  end interface

  interface max
    module procedure max_single_st_single_st
  end interface
  interface
    pure function cpp_max_single_st_single_st(a, b) bind(C)
      import single_st
      
      type(single_st), intent(in) :: a
      type(single_st), intent(in) :: b
      type(single_st) cpp_max_single_st_single_st
    end function cpp_max_single_st_single_st
  end interface

  interface max
    module procedure max_double_st_double_st
  end interface
  interface
    pure function cpp_max_double_st_double_st(a, b) bind(C)
      import double_st
      
      type(double_st), intent(in) :: a
      type(double_st), intent(in) :: b
      type(double_st) cpp_max_double_st_double_st
    end function cpp_max_double_st_double_st
  end interface

  interface max
    module procedure max_float_single_st
  end interface
  interface
    pure function cpp_max_float_single_st(a, b) bind(C)
      import C_FLOAT
      import single_st
      real(C_FLOAT), intent(in) :: a
      type(single_st), intent(in) :: b
      type(single_st) cpp_max_float_single_st
    end function cpp_max_float_single_st
  end interface

  interface max
    module procedure max_double_double_st
  end interface
  interface
    pure function cpp_max_double_double_st(a, b) bind(C)
      import C_DOUBLE
      import double_st
      real(C_DOUBLE), intent(in) :: a
      type(double_st), intent(in) :: b
      type(double_st) cpp_max_double_double_st
    end function cpp_max_double_double_st
  end interface

  interface max
    module procedure max_single_st_float
  end interface
  interface
    pure function cpp_max_single_st_float(a, b) bind(C)
      import single_st
      import C_FLOAT
      type(single_st), intent(in) :: a
      real(C_FLOAT), intent(in) :: b
      type(single_st) cpp_max_single_st_float
    end function cpp_max_single_st_float
  end interface

  interface max
    module procedure max_double_st_double
  end interface
  interface
    pure function cpp_max_double_st_double(a, b) bind(C)
      import double_st
      import C_DOUBLE
      type(double_st), intent(in) :: a
      real(C_DOUBLE), intent(in) :: b
      type(double_st) cpp_max_double_st_double
    end function cpp_max_double_st_double
  end interface

  interface min
    module procedure min_single_st_single_st
  end interface
  interface
    pure function cpp_min_single_st_single_st(a, b) bind(C)
      import single_st
      
      type(single_st), intent(in) :: a
      type(single_st), intent(in) :: b
      type(single_st) cpp_min_single_st_single_st
    end function cpp_min_single_st_single_st
  end interface

  interface min
    module procedure min_double_st_double_st
  end interface
  interface
    pure function cpp_min_double_st_double_st(a, b) bind(C)
      import double_st
      
      type(double_st), intent(in) :: a
      type(double_st), intent(in) :: b
      type(double_st) cpp_min_double_st_double_st
    end function cpp_min_double_st_double_st
  end interface

  interface min
    module procedure min_float_single_st
  end interface
  interface
    pure function cpp_min_float_single_st(a, b) bind(C)
      import C_FLOAT
      import single_st
      real(C_FLOAT), intent(in) :: a
      type(single_st), intent(in) :: b
      type(single_st) cpp_min_float_single_st
    end function cpp_min_float_single_st
  end interface

  interface min
    module procedure min_double_double_st
  end interface
  interface
    pure function cpp_min_double_double_st(a, b) bind(C)
      import C_DOUBLE
      import double_st
      real(C_DOUBLE), intent(in) :: a
      type(double_st), intent(in) :: b
      type(double_st) cpp_min_double_double_st
    end function cpp_min_double_double_st
  end interface

  interface min
    module procedure min_single_st_float
  end interface
  interface
    pure function cpp_min_single_st_float(a, b) bind(C)
      import single_st
      import C_FLOAT
      type(single_st), intent(in) :: a
      real(C_FLOAT), intent(in) :: b
      type(single_st) cpp_min_single_st_float
    end function cpp_min_single_st_float
  end interface

  interface min
    module procedure min_double_st_double
  end interface
  interface
    pure function cpp_min_double_st_double(a, b) bind(C)
      import double_st
      import C_DOUBLE
      type(double_st), intent(in) :: a
      real(C_DOUBLE), intent(in) :: b
      type(double_st) cpp_min_double_st_double
    end function cpp_min_double_st_double
  end interface

  interface mod
    module procedure mod_single_st_single_st
  end interface
  interface
    pure function cpp_mod_single_st_single_st(a, b) bind(C)
      import single_st
      
      type(single_st), intent(in) :: a
      type(single_st), intent(in) :: b
      type(single_st) cpp_mod_single_st_single_st
    end function cpp_mod_single_st_single_st
  end interface

  interface mod
    module procedure mod_double_st_double_st
  end interface
  interface
    pure function cpp_mod_double_st_double_st(a, b) bind(C)
      import double_st
      
      type(double_st), intent(in) :: a
      type(double_st), intent(in) :: b
      type(double_st) cpp_mod_double_st_double_st
    end function cpp_mod_double_st_double_st
  end interface




  interface dim
    module procedure dim_single_st_single_st
  end interface dim

  interface dim
    module procedure dim_double_st_double_st
  end interface dim

  interface dim
    module procedure dim_float_single_st
  end interface dim

  interface dim
    module procedure dim_double_double_st
  end interface dim

  interface dim
    module procedure dim_single_st_float
  end interface dim

  interface dim
    module procedure dim_double_st_double
  end interface dim

  interface hypot
    module procedure hypot_single_st_single_st
  end interface hypot

  interface hypot
    module procedure hypot_double_st_double_st
  end interface hypot

  interface hypot
    module procedure hypot_float_single_st
  end interface hypot

  interface hypot
    module procedure hypot_double_double_st
  end interface hypot

  interface hypot
    module procedure hypot_single_st_float
  end interface hypot

  interface hypot
    module procedure hypot_double_st_double
  end interface hypot

  interface sign
    module procedure sign_single_st_single_st
  end interface sign

  interface sign
    module procedure sign_double_st_double_st
  end interface sign

  interface sign
    module procedure sign_float_single_st
  end interface sign

  interface sign
    module procedure sign_double_double_st
  end interface sign

  interface sign
    module procedure sign_single_st_float
  end interface sign

  interface sign
    module procedure sign_double_st_double
  end interface sign


contains



  elemental function dabs_double_st(a)
    type(double_st), intent(in) :: a
    type(double_st) dabs_double_st

    dabs_double_st = abs(a)
  end function dabs_double_st

  elemental function dsqrt_double_st(a)
    type(double_st), intent(in) :: a
    type(double_st) dsqrt_double_st

    dsqrt_double_st = sqrt(a)
  end function dsqrt_double_st

  elemental function dsin_double_st(a)
    type(double_st), intent(in) :: a
    type(double_st) dsin_double_st

    dsin_double_st = sin(a)
  end function dsin_double_st

  elemental function dcos_double_st(a)
    type(double_st), intent(in) :: a
    type(double_st) dcos_double_st

    dcos_double_st = cos(a)
  end function dcos_double_st

  elemental function dtan_double_st(a)
    type(double_st), intent(in) :: a
    type(double_st) dtan_double_st

    dtan_double_st = tan(a)
  end function dtan_double_st

  elemental function dexp_double_st(a)
    type(double_st), intent(in) :: a
    type(double_st) dexp_double_st

    dexp_double_st = exp(a)
  end function dexp_double_st

  elemental function dlog_double_st(a)
    type(double_st), intent(in) :: a
    type(double_st) dlog_double_st

    dlog_double_st = log(a)
  end function dlog_double_st




  elemental function abs_single_st(a)
    type(single_st), intent(in) :: a
    type(single_st) abs_single_st

    abs_single_st = cpp_abs_single_st(a)
  end function abs_single_st

  elemental function abs_double_st(a)
    type(double_st), intent(in) :: a
    type(double_st) abs_double_st

    abs_double_st = cpp_abs_double_st(a)
  end function abs_double_st

  elemental function acos_single_st(a)
    type(single_st), intent(in) :: a
    type(single_st) acos_single_st

    acos_single_st = cpp_acos_single_st(a)
  end function acos_single_st

  elemental function acos_double_st(a)
    type(double_st), intent(in) :: a
    type(double_st) acos_double_st

    acos_double_st = cpp_acos_double_st(a)
  end function acos_double_st

  elemental function acosh_single_st(a)
    type(single_st), intent(in) :: a
    type(single_st) acosh_single_st

    acosh_single_st = cpp_acosh_single_st(a)
  end function acosh_single_st

  elemental function acosh_double_st(a)
    type(double_st), intent(in) :: a
    type(double_st) acosh_double_st

    acosh_double_st = cpp_acosh_double_st(a)
  end function acosh_double_st

  elemental function aint_single_st(a)
    type(single_st), intent(in) :: a
    type(single_st) aint_single_st

    aint_single_st = cpp_aint_single_st(a)
  end function aint_single_st

  elemental function aint_double_st(a)
    type(double_st), intent(in) :: a
    type(double_st) aint_double_st

    aint_double_st = cpp_aint_double_st(a)
  end function aint_double_st

!CONTAINS_MATH_UNAIRE(anint,   single_st, single_st)
!CONTAINS_MATH_UNAIRE(anint,   double_st, double_st)
  elemental function asin_single_st(a)
    type(single_st), intent(in) :: a
    type(single_st) asin_single_st

    asin_single_st = cpp_asin_single_st(a)
  end function asin_single_st

  elemental function asin_double_st(a)
    type(double_st), intent(in) :: a
    type(double_st) asin_double_st

    asin_double_st = cpp_asin_double_st(a)
  end function asin_double_st

  elemental function asinh_single_st(a)
    type(single_st), intent(in) :: a
    type(single_st) asinh_single_st

    asinh_single_st = cpp_asinh_single_st(a)
  end function asinh_single_st

  elemental function asinh_double_st(a)
    type(double_st), intent(in) :: a
    type(double_st) asinh_double_st

    asinh_double_st = cpp_asinh_double_st(a)
  end function asinh_double_st

  elemental function atan_single_st(a)
    type(single_st), intent(in) :: a
    type(single_st) atan_single_st

    atan_single_st = cpp_atan_single_st(a)
  end function atan_single_st

  elemental function atan_double_st(a)
    type(double_st), intent(in) :: a
    type(double_st) atan_double_st

    atan_double_st = cpp_atan_double_st(a)
  end function atan_double_st

  elemental function atanh_single_st(a)
    type(single_st), intent(in) :: a
    type(single_st) atanh_single_st

    atanh_single_st = cpp_atanh_single_st(a)
  end function atanh_single_st

  elemental function atanh_double_st(a)
    type(double_st), intent(in) :: a
    type(double_st) atanh_double_st

    atanh_double_st = cpp_atanh_double_st(a)
  end function atanh_double_st

  elemental function ceiling_single_st(a)
    type(single_st), intent(in) :: a
    integer(C_INT) ceiling_single_st

    ceiling_single_st = int(cpp_ceiling_single_st(a), C_INT)
  end function ceiling_single_st

  elemental function ceiling_double_st(a)
    type(double_st), intent(in) :: a
    integer(C_INT) ceiling_double_st

    ceiling_double_st = int(cpp_ceiling_double_st(a), C_INT)
  end function ceiling_double_st

  elemental function cos_single_st(a)
    type(single_st), intent(in) :: a
    type(single_st) cos_single_st

    cos_single_st = cpp_cos_single_st(a)
  end function cos_single_st

  elemental function cos_double_st(a)
    type(double_st), intent(in) :: a
    type(double_st) cos_double_st

    cos_double_st = cpp_cos_double_st(a)
  end function cos_double_st

  elemental function cosh_single_st(a)
    type(single_st), intent(in) :: a
    type(single_st) cosh_single_st

    cosh_single_st = cpp_cosh_single_st(a)
  end function cosh_single_st

  elemental function cosh_double_st(a)
    type(double_st), intent(in) :: a
    type(double_st) cosh_double_st

    cosh_double_st = cpp_cosh_double_st(a)
  end function cosh_double_st

  elemental function erf_single_st(a)
    type(single_st), intent(in) :: a
    type(single_st) erf_single_st

    erf_single_st = cpp_erf_single_st(a)
  end function erf_single_st

  elemental function erf_double_st(a)
    type(double_st), intent(in) :: a
    type(double_st) erf_double_st

    erf_double_st = cpp_erf_double_st(a)
  end function erf_double_st

  elemental function erfc_single_st(a)
    type(single_st), intent(in) :: a
    type(single_st) erfc_single_st

    erfc_single_st = cpp_erfc_single_st(a)
  end function erfc_single_st

  elemental function erfc_double_st(a)
    type(double_st), intent(in) :: a
    type(double_st) erfc_double_st

    erfc_double_st = cpp_erfc_double_st(a)
  end function erfc_double_st

  elemental function exp_single_st(a)
    type(single_st), intent(in) :: a
    type(single_st) exp_single_st

    exp_single_st = cpp_exp_single_st(a)
  end function exp_single_st

  elemental function exp_double_st(a)
    type(double_st), intent(in) :: a
    type(double_st) exp_double_st

    exp_double_st = cpp_exp_double_st(a)
  end function exp_double_st

  elemental function floor_single_st(a)
    type(single_st), intent(in) :: a
    integer(C_INT) floor_single_st

    floor_single_st = int(cpp_floor_single_st(a), C_INT)
  end function floor_single_st

  elemental function floor_double_st(a)
    type(double_st), intent(in) :: a
    integer(C_INT) floor_double_st

    floor_double_st = int(cpp_floor_double_st(a), C_INT)
  end function floor_double_st

  elemental function log_single_st(a)
    type(single_st), intent(in) :: a
    type(single_st) log_single_st

    log_single_st = cpp_log_single_st(a)
  end function log_single_st

  elemental function log_double_st(a)
    type(double_st), intent(in) :: a
    type(double_st) log_double_st

    log_double_st = cpp_log_double_st(a)
  end function log_double_st

  elemental function log10_single_st(a)
    type(single_st), intent(in) :: a
    type(single_st) log10_single_st

    log10_single_st = cpp_log10_single_st(a)
  end function log10_single_st

  elemental function log10_double_st(a)
    type(double_st), intent(in) :: a
    type(double_st) log10_double_st

    log10_double_st = cpp_log10_double_st(a)
  end function log10_double_st

  elemental function nint_single_st(a)
    type(single_st), intent(in) :: a
    integer(C_INT) nint_single_st

    nint_single_st = int(cpp_nint_single_st(a), C_INT)
  end function nint_single_st

  elemental function nint_double_st(a)
    type(double_st), intent(in) :: a
    integer(C_INT) nint_double_st

    nint_double_st = int(cpp_nint_double_st(a), C_INT)
  end function nint_double_st

  elemental function sin_single_st(a)
    type(single_st), intent(in) :: a
    type(single_st) sin_single_st

    sin_single_st = cpp_sin_single_st(a)
  end function sin_single_st

  elemental function sin_double_st(a)
    type(double_st), intent(in) :: a
    type(double_st) sin_double_st

    sin_double_st = cpp_sin_double_st(a)
  end function sin_double_st

  elemental function sinh_single_st(a)
    type(single_st), intent(in) :: a
    type(single_st) sinh_single_st

    sinh_single_st = cpp_sinh_single_st(a)
  end function sinh_single_st

  elemental function sinh_double_st(a)
    type(double_st), intent(in) :: a
    type(double_st) sinh_double_st

    sinh_double_st = cpp_sinh_double_st(a)
  end function sinh_double_st

  elemental function sqrt_single_st(a)
    type(single_st), intent(in) :: a
    type(single_st) sqrt_single_st

    sqrt_single_st = cpp_sqrt_single_st(a)
  end function sqrt_single_st

  elemental function sqrt_double_st(a)
    type(double_st), intent(in) :: a
    type(double_st) sqrt_double_st

    sqrt_double_st = cpp_sqrt_double_st(a)
  end function sqrt_double_st

  elemental function tan_single_st(a)
    type(single_st), intent(in) :: a
    type(single_st) tan_single_st

    tan_single_st = cpp_tan_single_st(a)
  end function tan_single_st

  elemental function tan_double_st(a)
    type(double_st), intent(in) :: a
    type(double_st) tan_double_st

    tan_double_st = cpp_tan_double_st(a)
  end function tan_double_st

  elemental function tanh_single_st(a)
    type(single_st), intent(in) :: a
    type(single_st) tanh_single_st

    tanh_single_st = cpp_tanh_single_st(a)
  end function tanh_single_st

  elemental function tanh_double_st(a)
    type(double_st), intent(in) :: a
    type(double_st) tanh_double_st

    tanh_double_st = cpp_tanh_double_st(a)
  end function tanh_double_st




  elemental function atan2_single_st_single_st(a, b)
    type(single_st), intent(in) :: a
    type(single_st), intent(in) :: b
    type(single_st) atan2_single_st_single_st

    atan2_single_st_single_st = cpp_atan2_single_st_single_st(a, b)
  end function atan2_single_st_single_st

  elemental function atan2_double_st_double_st(a, b)
    type(double_st), intent(in) :: a
    type(double_st), intent(in) :: b
    type(double_st) atan2_double_st_double_st

    atan2_double_st_double_st = cpp_atan2_double_st_double_st(a, b)
  end function atan2_double_st_double_st

  elemental function max_single_st_single_st(a, b)
    type(single_st), intent(in) :: a
    type(single_st), intent(in) :: b
    type(single_st) max_single_st_single_st

    max_single_st_single_st = cpp_max_single_st_single_st(a, b)
  end function max_single_st_single_st

  elemental function max_double_st_double_st(a, b)
    type(double_st), intent(in) :: a
    type(double_st), intent(in) :: b
    type(double_st) max_double_st_double_st

    max_double_st_double_st = cpp_max_double_st_double_st(a, b)
  end function max_double_st_double_st

  elemental function max_float_single_st(a, b)
    real(C_FLOAT), intent(in) :: a
    type(single_st), intent(in) :: b
    type(single_st) max_float_single_st

    max_float_single_st = cpp_max_float_single_st(a, b)
  end function max_float_single_st

  elemental function max_double_double_st(a, b)
    real(C_DOUBLE), intent(in) :: a
    type(double_st), intent(in) :: b
    type(double_st) max_double_double_st

    max_double_double_st = cpp_max_double_double_st(a, b)
  end function max_double_double_st

  elemental function max_single_st_float(a, b)
    type(single_st), intent(in) :: a
    real(C_FLOAT), intent(in) :: b
    type(single_st) max_single_st_float

    max_single_st_float = cpp_max_single_st_float(a, b)
  end function max_single_st_float

  elemental function max_double_st_double(a, b)
    type(double_st), intent(in) :: a
    real(C_DOUBLE), intent(in) :: b
    type(double_st) max_double_st_double

    max_double_st_double = cpp_max_double_st_double(a, b)
  end function max_double_st_double

  elemental function min_single_st_single_st(a, b)
    type(single_st), intent(in) :: a
    type(single_st), intent(in) :: b
    type(single_st) min_single_st_single_st

    min_single_st_single_st = cpp_min_single_st_single_st(a, b)
  end function min_single_st_single_st

  elemental function min_double_st_double_st(a, b)
    type(double_st), intent(in) :: a
    type(double_st), intent(in) :: b
    type(double_st) min_double_st_double_st

    min_double_st_double_st = cpp_min_double_st_double_st(a, b)
  end function min_double_st_double_st

  elemental function min_float_single_st(a, b)
    real(C_FLOAT), intent(in) :: a
    type(single_st), intent(in) :: b
    type(single_st) min_float_single_st

    min_float_single_st = cpp_min_float_single_st(a, b)
  end function min_float_single_st

  elemental function min_double_double_st(a, b)
    real(C_DOUBLE), intent(in) :: a
    type(double_st), intent(in) :: b
    type(double_st) min_double_double_st

    min_double_double_st = cpp_min_double_double_st(a, b)
  end function min_double_double_st

  elemental function min_single_st_float(a, b)
    type(single_st), intent(in) :: a
    real(C_FLOAT), intent(in) :: b
    type(single_st) min_single_st_float

    min_single_st_float = cpp_min_single_st_float(a, b)
  end function min_single_st_float

  elemental function min_double_st_double(a, b)
    type(double_st), intent(in) :: a
    real(C_DOUBLE), intent(in) :: b
    type(double_st) min_double_st_double

    min_double_st_double = cpp_min_double_st_double(a, b)
  end function min_double_st_double

  elemental function mod_single_st_single_st(a, b)
    type(single_st), intent(in) :: a
    type(single_st), intent(in) :: b
    type(single_st) mod_single_st_single_st

    mod_single_st_single_st = cpp_mod_single_st_single_st(a, b)
  end function mod_single_st_single_st

  elemental function mod_double_st_double_st(a, b)
    type(double_st), intent(in) :: a
    type(double_st), intent(in) :: b
    type(double_st) mod_double_st_double_st

    mod_double_st_double_st = cpp_mod_double_st_double_st(a, b)
  end function mod_double_st_double_st




  elemental function dim_single_st_single_st(a, b)
    type(single_st), intent(in) :: a
    type(single_st), intent(in) :: b
    type(single_st) dim_single_st_single_st

    dim_single_st_single_st = MAX(a-b, 0.)
  end function dim_single_st_single_st

  elemental function dim_double_st_double_st(a, b)
    type(double_st), intent(in) :: a
    type(double_st), intent(in) :: b
    type(double_st) dim_double_st_double_st

    dim_double_st_double_st = MAX(a-b, 0.d0)
  end function dim_double_st_double_st

  elemental function dim_float_single_st(a, b)
    real(C_FLOAT), intent(in) :: a
    type(single_st), intent(in) :: b
    type(single_st) dim_float_single_st

    dim_float_single_st = MAX(a-b, 0.)
  end function dim_float_single_st

  elemental function dim_double_double_st(a, b)
    real(C_DOUBLE), intent(in) :: a
    type(double_st), intent(in) :: b
    type(double_st) dim_double_double_st

    dim_double_double_st = MAX(a-b, 0.d0)
  end function dim_double_double_st

  elemental function dim_single_st_float(a, b)
    type(single_st), intent(in) :: a
    real(C_FLOAT), intent(in) :: b
    type(single_st) dim_single_st_float

    dim_single_st_float = MAX(a-b, 0.)
  end function dim_single_st_float

  elemental function dim_double_st_double(a, b)
    type(double_st), intent(in) :: a
    real(C_DOUBLE), intent(in) :: b
    type(double_st) dim_double_st_double

    dim_double_st_double = MAX(a-b, 0.d0)
  end function dim_double_st_double

  elemental function hypot_single_st_single_st(a, b)
    type(single_st), intent(in) :: a
    type(single_st), intent(in) :: b
    type(single_st) hypot_single_st_single_st

    hypot_single_st_single_st = SQRT( a**2 + b**2 )
  end function hypot_single_st_single_st

  elemental function hypot_double_st_double_st(a, b)
    type(double_st), intent(in) :: a
    type(double_st), intent(in) :: b
    type(double_st) hypot_double_st_double_st

    hypot_double_st_double_st = SQRT( a**2 + b**2 )
  end function hypot_double_st_double_st

  elemental function hypot_float_single_st(a, b)
    real(C_FLOAT), intent(in) :: a
    type(single_st), intent(in) :: b
    type(single_st) hypot_float_single_st

    hypot_float_single_st = SQRT( a**2 + b**2 )
  end function hypot_float_single_st

  elemental function hypot_double_double_st(a, b)
    real(C_DOUBLE), intent(in) :: a
    type(double_st), intent(in) :: b
    type(double_st) hypot_double_double_st

    hypot_double_double_st = SQRT( a**2 + b**2 )
  end function hypot_double_double_st

  elemental function hypot_single_st_float(a, b)
    type(single_st), intent(in) :: a
    real(C_FLOAT), intent(in) :: b
    type(single_st) hypot_single_st_float

    hypot_single_st_float = SQRT( a**2 + b**2 )
  end function hypot_single_st_float

  elemental function hypot_double_st_double(a, b)
    type(double_st), intent(in) :: a
    real(C_DOUBLE), intent(in) :: b
    type(double_st) hypot_double_st_double

    hypot_double_st_double = SQRT( a**2 + b**2 )
  end function hypot_double_st_double

  elemental function sign_single_st_single_st(a, b)
    type(single_st), intent(in) :: a
    type(single_st), intent(in) :: b
    type(single_st) sign_single_st_single_st

    sign_single_st_single_st%x = sign(a%x, b%x) 
    sign_single_st_single_st%y = sign(a%y, b%y) 
    sign_single_st_single_st%z = sign(a%z, b%z) 
    sign_single_st_single_st%accuracy = DIGIT_NOT_COMPUTED
  end function sign_single_st_single_st

  elemental function sign_double_st_double_st(a, b)
    type(double_st), intent(in) :: a
    type(double_st), intent(in) :: b
    type(double_st) sign_double_st_double_st

    sign_double_st_double_st%x = sign(a%x, b%x) 
    sign_double_st_double_st%y = sign(a%y, b%y) 
    sign_double_st_double_st%z = sign(a%z, b%z) 
    sign_double_st_double_st%accuracy = DIGIT_NOT_COMPUTED
  end function sign_double_st_double_st

  elemental function sign_float_single_st(a, b)
    real(C_FLOAT), intent(in) :: a
    type(single_st), intent(in) :: b
    type(single_st) sign_float_single_st

    sign_float_single_st%x = sign(a, b%x)
    sign_float_single_st%y = sign(a, b%y)
    sign_float_single_st%z = sign(a, b%z)
    sign_float_single_st%accuracy = DIGIT_NOT_COMPUTED
  end function sign_float_single_st

  elemental function sign_double_double_st(a, b)
    real(C_DOUBLE), intent(in) :: a
    type(double_st), intent(in) :: b
    type(double_st) sign_double_double_st

    sign_double_double_st%x = sign(a, b%x)
    sign_double_double_st%y = sign(a, b%y)
    sign_double_double_st%z = sign(a, b%z)
    sign_double_double_st%accuracy = DIGIT_NOT_COMPUTED
  end function sign_double_double_st

  elemental function sign_single_st_float(a, b)
    type(single_st), intent(in) :: a
    real(C_FLOAT), intent(in) :: b
    type(single_st) sign_single_st_float

    sign_single_st_float%x = sign(a%x, b)
    sign_single_st_float%y = sign(a%y, b)
    sign_single_st_float%z = sign(a%z, b)
    sign_single_st_float%accuracy = DIGIT_NOT_COMPUTED
  end function sign_single_st_float

  elemental function sign_double_st_double(a, b)
    type(double_st), intent(in) :: a
    real(C_DOUBLE), intent(in) :: b
    type(double_st) sign_double_st_double

    sign_double_st_double%x = sign(a%x, b)
    sign_double_st_double%y = sign(a%y, b)
    sign_double_st_double%z = sign(a%z, b)
    sign_double_st_double%accuracy = DIGIT_NOT_COMPUTED
  end function sign_double_st_double




end module cadna_math

!Copyright 2017 R. CARPENTIER, P. CORDE, F. JEZEQUEL, J.-L. LAMOTTE
!
!This file is part of CADNA.
!
!    CADNA is free software: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as
!    published by the Free Software Foundation, either version 3 of the
!    License, or (at your option) any later version.
!
!    CADNA is distributed in the hope that it will be useful, but WITHOUT
!    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
!    or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General
!    Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public
!    License along with CADNA. If not, see
!    <http://www.gnu.org/licenses/>.
!


! Module de surcharge de l'opérateur "-"




module cadna_cmplx_sub
  use ISO_C_BINDING,   only : C_LONG_LONG, C_LONG, C_INT, C_SHORT, C_FLOAT, C_DOUBLE
  use ISO_FORTRAN_ENV, only : REAL32, REAL64
  use cadna_types
  use cadna_sub
  use cadna_affect
  implicit none




  interface operator(-)
    module procedure sub_complex_double_st_complex_double_st
  end interface operator(-)

  interface operator(-)
    module procedure sub_complex_double_st_complex_single_st
  end interface operator(-)

  interface operator(-)
    module procedure sub_complex_double_st_double_st
  end interface operator(-)

  interface operator(-)
    module procedure sub_complex_double_st_single_st
  end interface operator(-)

  interface operator(-)
    module procedure sub_complex_double_st_complex_float
  end interface operator(-)

  interface operator(-)
    module procedure sub_complex_double_st_complex_double
  end interface operator(-)

  interface operator(-)
    module procedure sub_complex_double_st_double
  end interface operator(-)

  interface operator(-)
    module procedure sub_complex_double_st_float
  end interface operator(-)

  interface operator(-)
    module procedure sub_complex_double_st_long_long
  end interface operator(-)

!INTERFACE_OP(-, sub, complex_double_st, long)
  interface operator(-)
    module procedure sub_complex_double_st_int
  end interface operator(-)

  interface operator(-)
    module procedure sub_complex_double_st_short
  end interface operator(-)

!
  interface operator(-)
    module procedure sub_complex_single_st_complex_double_st
  end interface operator(-)

  interface operator(-)
    module procedure sub_complex_single_st_complex_single_st
  end interface operator(-)

  interface operator(-)
    module procedure sub_complex_single_st_double_st
  end interface operator(-)

  interface operator(-)
    module procedure sub_complex_single_st_single_st
  end interface operator(-)

  interface operator(-)
    module procedure sub_complex_single_st_complex_float
  end interface operator(-)

  interface operator(-)
    module procedure sub_complex_single_st_complex_double
  end interface operator(-)

  interface operator(-)
    module procedure sub_complex_single_st_double
  end interface operator(-)

  interface operator(-)
    module procedure sub_complex_single_st_float
  end interface operator(-)

  interface operator(-)
    module procedure sub_complex_single_st_long_long
  end interface operator(-)

!INTERFACE_OP(-, sub, complex_single_st, long)
  interface operator(-)
    module procedure sub_complex_single_st_int
  end interface operator(-)

  interface operator(-)
    module procedure sub_complex_single_st_short
  end interface operator(-)

!
  interface operator(-)
    module procedure sub_single_st_complex_double_st
  end interface operator(-)

  interface operator(-)
    module procedure sub_single_st_complex_single_st
  end interface operator(-)


  interface operator(-)
    module procedure sub_double_st_complex_double_st
  end interface operator(-)

  interface operator(-)
    module procedure sub_double_st_complex_single_st
  end interface operator(-)


  interface operator(-)
    module procedure sub_complex_float_complex_single_st
  end interface operator(-)

  interface operator(-)
    module procedure sub_complex_float_complex_double_st
  end interface operator(-)


  interface operator(-)
    module procedure sub_complex_double_complex_single_st
  end interface operator(-)

  interface operator(-)
    module procedure sub_complex_double_complex_double_st
  end interface operator(-)


  interface operator(-)
    module procedure sub_double_complex_double_st
  end interface operator(-)

  interface operator(-)
    module procedure sub_double_complex_single_st
  end interface operator(-)

!
  interface operator(-)
    module procedure sub_float_complex_double_st
  end interface operator(-)

  interface operator(-)
    module procedure sub_float_complex_single_st
  end interface operator(-)

!
  interface operator(-)
    module procedure sub_long_long_complex_double_st
  end interface operator(-)

  interface operator(-)
    module procedure sub_long_long_complex_single_st
  end interface operator(-)

!
!INTERFACE_OP(-, sub, long,              complex_double_st)
!INTERFACE_OP(-, sub, long,              complex_single_st)
!
  interface operator(-)
    module procedure sub_int_complex_double_st
  end interface operator(-)

  interface operator(-)
    module procedure sub_int_complex_single_st
  end interface operator(-)

!
  interface operator(-)
    module procedure sub_short_complex_double_st
  end interface operator(-)

  interface operator(-)
    module procedure sub_short_complex_single_st
  end interface operator(-)



contains



  elemental function sub_complex_double_st_complex_double_st(a, b)
    type(complex_double_st), intent(in) :: a
    type(complex_double_st), intent(in) :: b
    type(complex_double_st) sub_complex_double_st_complex_double_st
     
     

    sub_complex_double_st_complex_double_st%x = a%x-b%x
    sub_complex_double_st_complex_double_st%y = a%y-b%y 
  end function sub_complex_double_st_complex_double_st

  elemental function sub_complex_double_st_complex_single_st(a, b)
    type(complex_double_st), intent(in) :: a
    type(complex_single_st), intent(in) :: b
    type(complex_double_st) sub_complex_double_st_complex_single_st
     
     

    sub_complex_double_st_complex_single_st%x = a%x-b%x
    sub_complex_double_st_complex_single_st%y = a%y-b%y 
  end function sub_complex_double_st_complex_single_st

  elemental function sub_complex_double_st_double_st(a, b)
    type(complex_double_st), intent(in) :: a
    type(double_st), intent(in) :: b
    type(complex_double_st) sub_complex_double_st_double_st
     
     

    sub_complex_double_st_double_st%x = a%x-b
    sub_complex_double_st_double_st%y = a%y
  end function sub_complex_double_st_double_st

  elemental function sub_complex_double_st_single_st(a, b)
    type(complex_double_st), intent(in) :: a
    type(single_st), intent(in) :: b
    type(complex_double_st) sub_complex_double_st_single_st
     
     

    sub_complex_double_st_single_st%x = a%x-b
    sub_complex_double_st_single_st%y = a%y
  end function sub_complex_double_st_single_st

  elemental function sub_complex_double_st_complex_float(a, b)
    type(complex_double_st), intent(in) :: a
    complex(REAL32), intent(in) :: b
    type(complex_double_st) sub_complex_double_st_complex_float
     
    real(REAL32) re, im

    re = real(b) ; im = aimag(b)
    sub_complex_double_st_complex_float%x = a%x-re
    sub_complex_double_st_complex_float%y = a%y-im
  end function sub_complex_double_st_complex_float

  elemental function sub_complex_double_st_complex_double(a, b)
    type(complex_double_st), intent(in) :: a
    complex(REAL64), intent(in) :: b
    type(complex_double_st) sub_complex_double_st_complex_double
     
    real(REAL64) re, im

    re = real(b) ; im = aimag(b)
    sub_complex_double_st_complex_double%x = a%x-re
    sub_complex_double_st_complex_double%y = a%y-im
  end function sub_complex_double_st_complex_double

  elemental function sub_complex_double_st_double(a, b)
    type(complex_double_st), intent(in) :: a
    real(C_DOUBLE), intent(in) :: b
    type(complex_double_st) sub_complex_double_st_double
     
     

    sub_complex_double_st_double%x = a%x-b
    sub_complex_double_st_double%y = a%y
  end function sub_complex_double_st_double

  elemental function sub_complex_double_st_float(a, b)
    type(complex_double_st), intent(in) :: a
    real(C_FLOAT), intent(in) :: b
    type(complex_double_st) sub_complex_double_st_float
     
     

    sub_complex_double_st_float%x = a%x-b
    sub_complex_double_st_float%y = a%y
  end function sub_complex_double_st_float

  elemental function sub_complex_double_st_long_long(a, b)
    type(complex_double_st), intent(in) :: a
    integer(C_LONG_LONG), intent(in) :: b
    type(complex_double_st) sub_complex_double_st_long_long
     
     

    sub_complex_double_st_long_long%x = a%x-b
    sub_complex_double_st_long_long%y = a%y
  end function sub_complex_double_st_long_long

!CONTAINS_OP(sub, complex_double_st, long,              complex_double_st)
  elemental function sub_complex_double_st_int(a, b)
    type(complex_double_st), intent(in) :: a
    integer(C_INT), intent(in) :: b
    type(complex_double_st) sub_complex_double_st_int
     
     

    sub_complex_double_st_int%x = a%x-b
    sub_complex_double_st_int%y = a%y
  end function sub_complex_double_st_int

  elemental function sub_complex_double_st_short(a, b)
    type(complex_double_st), intent(in) :: a
    integer(C_SHORT), intent(in) :: b
    type(complex_double_st) sub_complex_double_st_short
     
     

    sub_complex_double_st_short%x = a%x-b
    sub_complex_double_st_short%y = a%y
  end function sub_complex_double_st_short

!
  elemental function sub_complex_single_st_complex_double_st(a, b)
    type(complex_single_st), intent(in) :: a
    type(complex_double_st), intent(in) :: b
    type(complex_double_st) sub_complex_single_st_complex_double_st
     
     

    sub_complex_single_st_complex_double_st%x = a%x-b%x
    sub_complex_single_st_complex_double_st%y = a%y-b%y 
  end function sub_complex_single_st_complex_double_st

  elemental function sub_complex_single_st_complex_single_st(a, b)
    type(complex_single_st), intent(in) :: a
    type(complex_single_st), intent(in) :: b
    type(complex_single_st) sub_complex_single_st_complex_single_st
     
     

    sub_complex_single_st_complex_single_st%x = a%x-b%x
    sub_complex_single_st_complex_single_st%y = a%y-b%y 
  end function sub_complex_single_st_complex_single_st

  elemental function sub_complex_single_st_double_st(a, b)
    type(complex_single_st), intent(in) :: a
    type(double_st), intent(in) :: b
    type(complex_double_st) sub_complex_single_st_double_st
     
     

    sub_complex_single_st_double_st%x = a%x-b
    sub_complex_single_st_double_st%y = a%y
  end function sub_complex_single_st_double_st

  elemental function sub_complex_single_st_single_st(a, b)
    type(complex_single_st), intent(in) :: a
    type(single_st), intent(in) :: b
    type(complex_single_st) sub_complex_single_st_single_st
     
     

    sub_complex_single_st_single_st%x = a%x-b
    sub_complex_single_st_single_st%y = a%y
  end function sub_complex_single_st_single_st

  elemental function sub_complex_single_st_complex_float(a, b)
    type(complex_single_st), intent(in) :: a
    complex(REAL32), intent(in) :: b
    type(complex_single_st) sub_complex_single_st_complex_float
     
    real(REAL32) re, im

    re = real(b) ; im = aimag(b)
    sub_complex_single_st_complex_float%x = a%x-re
    sub_complex_single_st_complex_float%y = a%y-im
  end function sub_complex_single_st_complex_float

  elemental function sub_complex_single_st_complex_double(a, b)
    type(complex_single_st), intent(in) :: a
    complex(REAL64), intent(in) :: b
    type(complex_single_st) sub_complex_single_st_complex_double
     
    real(REAL64) re, im

    re = real(b) ; im = aimag(b)
    sub_complex_single_st_complex_double%x = a%x-re
    sub_complex_single_st_complex_double%y = a%y-im
  end function sub_complex_single_st_complex_double

  elemental function sub_complex_single_st_double(a, b)
    type(complex_single_st), intent(in) :: a
    real(C_DOUBLE), intent(in) :: b
    type(complex_single_st) sub_complex_single_st_double
     
     

    sub_complex_single_st_double%x = a%x-b
    sub_complex_single_st_double%y = a%y
  end function sub_complex_single_st_double

  elemental function sub_complex_single_st_float(a, b)
    type(complex_single_st), intent(in) :: a
    real(C_FLOAT), intent(in) :: b
    type(complex_single_st) sub_complex_single_st_float
     
     

    sub_complex_single_st_float%x = a%x-b
    sub_complex_single_st_float%y = a%y
  end function sub_complex_single_st_float

  elemental function sub_complex_single_st_long_long(a, b)
    type(complex_single_st), intent(in) :: a
    integer(C_LONG_LONG), intent(in) :: b
    type(complex_single_st) sub_complex_single_st_long_long
     
     

    sub_complex_single_st_long_long%x = a%x-b
    sub_complex_single_st_long_long%y = a%y
  end function sub_complex_single_st_long_long

!CONTAINS_OP(sub, complex_single_st, long,              complex_single_st)
  elemental function sub_complex_single_st_int(a, b)
    type(complex_single_st), intent(in) :: a
    integer(C_INT), intent(in) :: b
    type(complex_single_st) sub_complex_single_st_int
     
     

    sub_complex_single_st_int%x = a%x-b
    sub_complex_single_st_int%y = a%y
  end function sub_complex_single_st_int

  elemental function sub_complex_single_st_short(a, b)
    type(complex_single_st), intent(in) :: a
    integer(C_SHORT), intent(in) :: b
    type(complex_single_st) sub_complex_single_st_short
     
     

    sub_complex_single_st_short%x = a%x-b
    sub_complex_single_st_short%y = a%y
  end function sub_complex_single_st_short

!
  elemental function sub_single_st_complex_double_st(a, b)
    type(single_st), intent(in) :: a
    type(complex_double_st), intent(in) :: b
    type(complex_double_st) sub_single_st_complex_double_st
     
     

    sub_single_st_complex_double_st%x = a-b%x
    sub_single_st_complex_double_st%y = b%y
  end function sub_single_st_complex_double_st

  elemental function sub_single_st_complex_single_st(a, b)
    type(single_st), intent(in) :: a
    type(complex_single_st), intent(in) :: b
    type(complex_single_st) sub_single_st_complex_single_st
     
     

    sub_single_st_complex_single_st%x = a-b%x
    sub_single_st_complex_single_st%y = b%y
  end function sub_single_st_complex_single_st


  elemental function sub_double_st_complex_double_st(a, b)
    type(double_st), intent(in) :: a
    type(complex_double_st), intent(in) :: b
    type(complex_double_st) sub_double_st_complex_double_st
     
     

    sub_double_st_complex_double_st%x = a-b%x
    sub_double_st_complex_double_st%y = b%y
  end function sub_double_st_complex_double_st

  elemental function sub_double_st_complex_single_st(a, b)
    type(double_st), intent(in) :: a
    type(complex_single_st), intent(in) :: b
    type(complex_double_st) sub_double_st_complex_single_st
     
     

    sub_double_st_complex_single_st%x = a-b%x
    sub_double_st_complex_single_st%y = b%y
  end function sub_double_st_complex_single_st


  elemental function sub_complex_float_complex_single_st(a, b)
    complex(REAL32), intent(in) :: a
    type(complex_single_st), intent(in) :: b
    type(complex_single_st) sub_complex_float_complex_single_st
    real(REAL32) re, im
     

    re = real(a) ; im = aimag(a)
    sub_complex_float_complex_single_st%x = re-b%x
    sub_complex_float_complex_single_st%y = im-b%y
  end function sub_complex_float_complex_single_st

  elemental function sub_complex_float_complex_double_st(a, b)
    complex(REAL32), intent(in) :: a
    type(complex_double_st), intent(in) :: b
    type(complex_double_st) sub_complex_float_complex_double_st
    real(REAL32) re, im
     

    re = real(a) ; im = aimag(a)
    sub_complex_float_complex_double_st%x = re-b%x
    sub_complex_float_complex_double_st%y = im-b%y
  end function sub_complex_float_complex_double_st


  elemental function sub_complex_double_complex_double_st(a, b)
    complex(REAL64), intent(in) :: a
    type(complex_double_st), intent(in) :: b
    type(complex_double_st) sub_complex_double_complex_double_st
    real(REAL64) re, im
     

    re = real(a) ; im = aimag(a)
    sub_complex_double_complex_double_st%x = re-b%x
    sub_complex_double_complex_double_st%y = im-b%y
  end function sub_complex_double_complex_double_st

  elemental function sub_complex_double_complex_single_st(a, b)
    complex(REAL64), intent(in) :: a
    type(complex_single_st), intent(in) :: b
    type(complex_single_st) sub_complex_double_complex_single_st
    real(REAL64) re, im
     

    re = real(a) ; im = aimag(a)
    sub_complex_double_complex_single_st%x = re-b%x
    sub_complex_double_complex_single_st%y = im-b%y
  end function sub_complex_double_complex_single_st

!
  elemental function sub_double_complex_double_st(a, b)
    real(C_DOUBLE), intent(in) :: a
    type(complex_double_st), intent(in) :: b
    type(complex_double_st) sub_double_complex_double_st
     
     

    sub_double_complex_double_st%x = a-b%x
    sub_double_complex_double_st%y = b%y
  end function sub_double_complex_double_st

  elemental function sub_double_complex_single_st(a, b)
    real(C_DOUBLE), intent(in) :: a
    type(complex_single_st), intent(in) :: b
    type(complex_single_st) sub_double_complex_single_st
     
     

    sub_double_complex_single_st%x = a-b%x
    sub_double_complex_single_st%y = b%y
  end function sub_double_complex_single_st

!
  elemental function sub_float_complex_double_st(a, b)
    real(C_FLOAT), intent(in) :: a
    type(complex_double_st), intent(in) :: b
    type(complex_double_st) sub_float_complex_double_st
     
     

    sub_float_complex_double_st%x = a-b%x
    sub_float_complex_double_st%y = b%y
  end function sub_float_complex_double_st

  elemental function sub_float_complex_single_st(a, b)
    real(C_FLOAT), intent(in) :: a
    type(complex_single_st), intent(in) :: b
    type(complex_single_st) sub_float_complex_single_st
     
     

    sub_float_complex_single_st%x = a-b%x
    sub_float_complex_single_st%y = b%y
  end function sub_float_complex_single_st

!
  elemental function sub_long_long_complex_double_st(a, b)
    integer(C_LONG_LONG), intent(in) :: a
    type(complex_double_st), intent(in) :: b
    type(complex_double_st) sub_long_long_complex_double_st
     
     

    sub_long_long_complex_double_st%x = a-b%x
    sub_long_long_complex_double_st%y = b%y
  end function sub_long_long_complex_double_st

  elemental function sub_long_long_complex_single_st(a, b)
    integer(C_LONG_LONG), intent(in) :: a
    type(complex_single_st), intent(in) :: b
    type(complex_single_st) sub_long_long_complex_single_st
     
     

    sub_long_long_complex_single_st%x = a-b%x
    sub_long_long_complex_single_st%y = b%y
  end function sub_long_long_complex_single_st

!
!CONTAINS_OP(sub, long,              complex_double_st, complex_double_st)
!CONTAINS_OP(sub, long,              complex_single_st, complex_single_st)
!
  elemental function sub_int_complex_double_st(a, b)
    integer(C_INT), intent(in) :: a
    type(complex_double_st), intent(in) :: b
    type(complex_double_st) sub_int_complex_double_st
     
     

    sub_int_complex_double_st%x = a-b%x
    sub_int_complex_double_st%y = b%y
  end function sub_int_complex_double_st

  elemental function sub_int_complex_single_st(a, b)
    integer(C_INT), intent(in) :: a
    type(complex_single_st), intent(in) :: b
    type(complex_single_st) sub_int_complex_single_st
     
     

    sub_int_complex_single_st%x = a-b%x
    sub_int_complex_single_st%y = b%y
  end function sub_int_complex_single_st

!
  elemental function sub_short_complex_double_st(a, b)
    integer(C_SHORT), intent(in) :: a
    type(complex_double_st), intent(in) :: b
    type(complex_double_st) sub_short_complex_double_st
     
     

    sub_short_complex_double_st%x = a-b%x
    sub_short_complex_double_st%y = b%y
  end function sub_short_complex_double_st

  elemental function sub_short_complex_single_st(a, b)
    integer(C_SHORT), intent(in) :: a
    type(complex_single_st), intent(in) :: b
    type(complex_single_st) sub_short_complex_single_st
     
     

    sub_short_complex_single_st%x = a-b%x
    sub_short_complex_single_st%y = b%y
  end function sub_short_complex_single_st




end module cadna_cmplx_sub

!Copyright 2017 R. CARPENTIER, P. CORDE, F. JEZEQUEL, J.-L. LAMOTTE
!
!This file is part of CADNA.
!
!    CADNA is free software: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as
!    published by the Free Software Foundation, either version 3 of the
!    License, or (at your option) any later version.
!
!    CADNA is distributed in the hope that it will be useful, but WITHOUT
!    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
!    or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General
!    Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public
!    License along with CADNA. If not, see
!    <http://www.gnu.org/licenses/>.
!



! Module de surcharge de l'opérateur "**"




module cadna_cmplx_pow
  use ISO_C_BINDING, only : C_LONG_LONG, C_LONG, C_INT, C_SHORT, C_FLOAT, C_DOUBLE
  use cadna_types
  use cadna_math
  use cadna_cmplx_affect
  use cadna_cmplx_mult
  use cadna_cmplx_math
  implicit none




  interface operator(**)
    module procedure pow_complex_double_st_complex_double_st
  end interface operator(**)

  interface operator(**)
    module procedure pow_complex_double_st_complex_single_st
  end interface operator(**)

  interface operator(**)
    module procedure pow_complex_double_st_double_st
  end interface operator(**)

  interface operator(**)
    module procedure pow_complex_double_st_single_st
  end interface operator(**)

  interface operator(**)
    module procedure pow_complex_double_st_double
  end interface operator(**)

  interface operator(**)
    module procedure pow_complex_double_st_float
  end interface operator(**)

  interface operator(**)
    module procedure pow_complex_double_st_long_long
  end interface operator(**)

!INTERFACE_OP(**, pow, complex_double_st, long)
  interface operator(**)
    module procedure pow_complex_double_st_int
  end interface operator(**)

  interface operator(**)
    module procedure pow_complex_double_st_short
  end interface operator(**)

!
  interface operator(**)
    module procedure pow_complex_single_st_complex_double_st
  end interface operator(**)

  interface operator(**)
    module procedure pow_complex_single_st_complex_single_st
  end interface operator(**)

  interface operator(**)
    module procedure pow_complex_single_st_double_st
  end interface operator(**)

  interface operator(**)
    module procedure pow_complex_single_st_single_st
  end interface operator(**)

  interface operator(**)
    module procedure pow_complex_single_st_double
  end interface operator(**)

  interface operator(**)
    module procedure pow_complex_single_st_float
  end interface operator(**)

  interface operator(**)
    module procedure pow_complex_single_st_long_long
  end interface operator(**)

!INTERFACE_OP(**, pow, complex_single_st, long)
  interface operator(**)
    module procedure pow_complex_single_st_int
  end interface operator(**)

  interface operator(**)
    module procedure pow_complex_single_st_short
  end interface operator(**)

!
  interface operator(**)
    module procedure pow_single_st_complex_double_st
  end interface operator(**)

  interface operator(**)
    module procedure pow_single_st_complex_single_st
  end interface operator(**)


  interface operator(**)
    module procedure pow_double_st_complex_double_st
  end interface operator(**)

  interface operator(**)
    module procedure pow_double_st_complex_single_st
  end interface operator(**)


  interface operator(**)
    module procedure pow_double_complex_double_st
  end interface operator(**)

  interface operator(**)
    module procedure pow_double_complex_single_st
  end interface operator(**)

!
  interface operator(**)
    module procedure pow_float_complex_double_st
  end interface operator(**)

  interface operator(**)
    module procedure pow_float_complex_single_st
  end interface operator(**)

!
  interface operator(**)
    module procedure pow_long_long_complex_double_st
  end interface operator(**)

  interface operator(**)
    module procedure pow_long_long_complex_single_st
  end interface operator(**)

!
!INTERFACE_OP(**, pow, long,              complex_double_st)
!INTERFACE_OP(**, pow, long,              complex_single_st)
!
  interface operator(**)
    module procedure pow_int_complex_double_st
  end interface operator(**)

  interface operator(**)
    module procedure pow_int_complex_single_st
  end interface operator(**)

!
  interface operator(**)
    module procedure pow_short_complex_double_st
  end interface operator(**)

  interface operator(**)
    module procedure pow_short_complex_single_st
  end interface operator(**)



contains



  elemental function pow_complex_double_st_complex_double_st(a, b)
    type(complex_double_st), intent(in) :: a
    type(complex_double_st), intent(in) :: b
    type(complex_double_st) pow_complex_double_st_complex_double_st

    pow_complex_double_st_complex_double_st = exp(b*log(a))
  end function pow_complex_double_st_complex_double_st

  elemental function pow_complex_double_st_complex_single_st(a, b)
    type(complex_double_st), intent(in) :: a
    type(complex_single_st), intent(in) :: b
    type(complex_double_st) pow_complex_double_st_complex_single_st

    pow_complex_double_st_complex_single_st = exp(b*log(a))
  end function pow_complex_double_st_complex_single_st

  elemental function pow_complex_double_st_double_st(a, b)
    type(complex_double_st), intent(in) :: a
    type(double_st), intent(in) :: b
    type(complex_double_st) pow_complex_double_st_double_st

    pow_complex_double_st_double_st = exp(b*log(a))
  end function pow_complex_double_st_double_st

  elemental function pow_complex_double_st_single_st(a, b)
    type(complex_double_st), intent(in) :: a
    type(single_st), intent(in) :: b
    type(complex_double_st) pow_complex_double_st_single_st

    pow_complex_double_st_single_st = exp(b*log(a))
  end function pow_complex_double_st_single_st

  elemental function pow_complex_double_st_double(a, b)
    type(complex_double_st), intent(in) :: a
    real(C_DOUBLE), intent(in) :: b
    type(complex_double_st) pow_complex_double_st_double

    pow_complex_double_st_double = exp(b*log(a))
  end function pow_complex_double_st_double

  elemental function pow_complex_double_st_float(a, b)
    type(complex_double_st), intent(in) :: a
    real(C_FLOAT), intent(in) :: b
    type(complex_double_st) pow_complex_double_st_float

    pow_complex_double_st_float = exp(b*log(a))
  end function pow_complex_double_st_float

  elemental function pow_complex_double_st_long_long(a, b)
    type(complex_double_st), intent(in) :: a
    integer(C_LONG_LONG), intent(in) :: b
    type(complex_double_st) pow_complex_double_st_long_long

    pow_complex_double_st_long_long = exp(b*log(a))
  end function pow_complex_double_st_long_long

!CONTAINS_OP(pow, complex_double_st, long,              complex_double_st)
  elemental function pow_complex_double_st_int(a, b)
    type(complex_double_st), intent(in) :: a
    integer(C_INT), intent(in) :: b
    type(complex_double_st) pow_complex_double_st_int

    pow_complex_double_st_int = exp(b*log(a))
  end function pow_complex_double_st_int

  elemental function pow_complex_double_st_short(a, b)
    type(complex_double_st), intent(in) :: a
    integer(C_SHORT), intent(in) :: b
    type(complex_double_st) pow_complex_double_st_short

    pow_complex_double_st_short = exp(b*log(a))
  end function pow_complex_double_st_short

!
  elemental function pow_complex_single_st_complex_double_st(a, b)
    type(complex_single_st), intent(in) :: a
    type(complex_double_st), intent(in) :: b
    type(complex_double_st) pow_complex_single_st_complex_double_st

    pow_complex_single_st_complex_double_st = exp(b*log(a))
  end function pow_complex_single_st_complex_double_st

  elemental function pow_complex_single_st_complex_single_st(a, b)
    type(complex_single_st), intent(in) :: a
    type(complex_single_st), intent(in) :: b
    type(complex_single_st) pow_complex_single_st_complex_single_st

    pow_complex_single_st_complex_single_st = exp(b*log(a))
  end function pow_complex_single_st_complex_single_st

  elemental function pow_complex_single_st_double_st(a, b)
    type(complex_single_st), intent(in) :: a
    type(double_st), intent(in) :: b
    type(complex_double_st) pow_complex_single_st_double_st

    pow_complex_single_st_double_st = exp(b*log(a))
  end function pow_complex_single_st_double_st

  elemental function pow_complex_single_st_single_st(a, b)
    type(complex_single_st), intent(in) :: a
    type(single_st), intent(in) :: b
    type(complex_single_st) pow_complex_single_st_single_st

    pow_complex_single_st_single_st = exp(b*log(a))
  end function pow_complex_single_st_single_st

  elemental function pow_complex_single_st_double(a, b)
    type(complex_single_st), intent(in) :: a
    real(C_DOUBLE), intent(in) :: b
    type(complex_single_st) pow_complex_single_st_double

    pow_complex_single_st_double = exp(b*log(a))
  end function pow_complex_single_st_double

  elemental function pow_complex_single_st_float(a, b)
    type(complex_single_st), intent(in) :: a
    real(C_FLOAT), intent(in) :: b
    type(complex_single_st) pow_complex_single_st_float

    pow_complex_single_st_float = exp(b*log(a))
  end function pow_complex_single_st_float

  elemental function pow_complex_single_st_long_long(a, b)
    type(complex_single_st), intent(in) :: a
    integer(C_LONG_LONG), intent(in) :: b
    type(complex_single_st) pow_complex_single_st_long_long

    pow_complex_single_st_long_long = exp(b*log(a))
  end function pow_complex_single_st_long_long

!CONTAINS_OP(pow, complex_single_st, long,              complex_single_st)
  elemental function pow_complex_single_st_int(a, b)
    type(complex_single_st), intent(in) :: a
    integer(C_INT), intent(in) :: b
    type(complex_single_st) pow_complex_single_st_int

    pow_complex_single_st_int = exp(b*log(a))
  end function pow_complex_single_st_int

  elemental function pow_complex_single_st_short(a, b)
    type(complex_single_st), intent(in) :: a
    integer(C_SHORT), intent(in) :: b
    type(complex_single_st) pow_complex_single_st_short

    pow_complex_single_st_short = exp(b*log(a))
  end function pow_complex_single_st_short

!
  elemental function pow_single_st_complex_double_st(a, b)
    type(single_st), intent(in) :: a
    type(complex_double_st), intent(in) :: b
    type(complex_double_st) pow_single_st_complex_double_st

    pow_single_st_complex_double_st = exp(b*log(a))
  end function pow_single_st_complex_double_st

  elemental function pow_single_st_complex_single_st(a, b)
    type(single_st), intent(in) :: a
    type(complex_single_st), intent(in) :: b
    type(complex_single_st) pow_single_st_complex_single_st

    pow_single_st_complex_single_st = exp(b*log(a))
  end function pow_single_st_complex_single_st


  elemental function pow_double_st_complex_double_st(a, b)
    type(double_st), intent(in) :: a
    type(complex_double_st), intent(in) :: b
    type(complex_double_st) pow_double_st_complex_double_st

    pow_double_st_complex_double_st = exp(b*log(a))
  end function pow_double_st_complex_double_st

  elemental function pow_double_st_complex_single_st(a, b)
    type(double_st), intent(in) :: a
    type(complex_single_st), intent(in) :: b
    type(complex_double_st) pow_double_st_complex_single_st

    pow_double_st_complex_single_st = exp(b*log(a))
  end function pow_double_st_complex_single_st


  elemental function pow_double_complex_double_st(a, b)
    real(C_DOUBLE), intent(in) :: a
    type(complex_double_st), intent(in) :: b
    type(complex_double_st) pow_double_complex_double_st

    pow_double_complex_double_st = exp(b*log(a))
  end function pow_double_complex_double_st

  elemental function pow_double_complex_single_st(a, b)
    real(C_DOUBLE), intent(in) :: a
    type(complex_single_st), intent(in) :: b
    type(complex_single_st) pow_double_complex_single_st

    pow_double_complex_single_st = exp(b*log(a))
  end function pow_double_complex_single_st

!
  elemental function pow_float_complex_double_st(a, b)
    real(C_FLOAT), intent(in) :: a
    type(complex_double_st), intent(in) :: b
    type(complex_double_st) pow_float_complex_double_st

    pow_float_complex_double_st = exp(b*log(a))
  end function pow_float_complex_double_st

  elemental function pow_float_complex_single_st(a, b)
    real(C_FLOAT), intent(in) :: a
    type(complex_single_st), intent(in) :: b
    type(complex_single_st) pow_float_complex_single_st

    pow_float_complex_single_st = exp(b*log(a))
  end function pow_float_complex_single_st

!
  elemental function pow_long_long_complex_double_st(a, b)
    integer(C_LONG_LONG), intent(in) :: a
    type(complex_double_st), intent(in) :: b
    type(complex_double_st) pow_long_long_complex_double_st

    pow_long_long_complex_double_st = exp(b*log(real(a)))
  end function pow_long_long_complex_double_st

  elemental function pow_long_long_complex_single_st(a, b)
    integer(C_LONG_LONG), intent(in) :: a
    type(complex_single_st), intent(in) :: b
    type(complex_single_st) pow_long_long_complex_single_st

    pow_long_long_complex_single_st = exp(b*log(real(a)))
  end function pow_long_long_complex_single_st

!
!CONTAINS_OP(pow, long, complex_double_st,             complex_double_st)
!CONTAINS_OP(pow, long, complex_single_st,             complex_single_st)
!
  elemental function pow_int_complex_double_st(a, b)
    integer(C_INT), intent(in) :: a
    type(complex_double_st), intent(in) :: b
    type(complex_double_st) pow_int_complex_double_st

    pow_int_complex_double_st = exp(b*log(real(a)))
  end function pow_int_complex_double_st

  elemental function pow_int_complex_single_st(a, b)
    integer(C_INT), intent(in) :: a
    type(complex_single_st), intent(in) :: b
    type(complex_single_st) pow_int_complex_single_st

    pow_int_complex_single_st = exp(b*log(real(a)))
  end function pow_int_complex_single_st

!
  elemental function pow_short_complex_double_st(a, b)
    integer(C_SHORT), intent(in) :: a
    type(complex_double_st), intent(in) :: b
    type(complex_double_st) pow_short_complex_double_st

    pow_short_complex_double_st = exp(b*log(real(a)))
  end function pow_short_complex_double_st

  elemental function pow_short_complex_single_st(a, b)
    integer(C_SHORT), intent(in) :: a
    type(complex_single_st), intent(in) :: b
    type(complex_single_st) pow_short_complex_single_st

    pow_short_complex_single_st = exp(b*log(real(a)))
  end function pow_short_complex_single_st




end module cadna_cmplx_pow

      program ex2
      print *,'Second order equation without CADNA:' 
      a = 0.3
      b = -2.1
      c = 3.675
!
      if (a.eq.0.) then
        if (b.eq.0.) then
          if (c.eq.0.) then
            write(*,*)'Every complex value is solution.'
          else
            write(*,*)'There is no solution.'
          endif
        else
          x1 = - c/b
          write(*,1000) x1
        endif
!
      else
!
        b = b/a
        c = c/a
        d = b*b - 4.0*c
        write(*,*)'d = ',d
!
        if (d.eq.0.) then
          x1 = -b*0.5
          write(*,1001) x1
!
        elseif (d.gt.0.) then
          x1 = ( - b - sqrt(d))*0.5
          x2 = ( - b + sqrt(d))*0.5
          write(*,1002) x1, x2
!
        else
          x1 = - b*0.5
          x2 = sqrt(-d)*0.5
          write(*,1003) x1, x2, x1, -x2
        endif
!
      endif
!
 1000 format('The equation is degenerated.'/, &
     &       'There is one real solution ',e14.7)
!
 1001 format('Discriminant is zero.'/, &
     &       'The double solution is ',e14.7)
!
 1002 format('There are two real solutions.'/, &
     &       'x1 = ',e14.7/,'x2 = ',e14.7)
!
 1003 format('There are two complex solutions.'/, & 
     &       'z1 = ',e14.7,'  +  i * ',e14.7/, &
     &       'z2 = ',e14.7,'  +  i * ',e14.7)
!
      end    

! Module de conversion




module cadna_convert
  use ISO_C_BINDING, only : C_INT
  use cadna_types
  use cadna_affect

  implicit none




  interface single_st
    module procedure single_st_double_st
  end interface

  interface single_st
    module procedure single_st_single_st
  end interface

  interface double_st
    module procedure double_st_single_st
  end interface

  interface double_st
    module procedure double_st_double_st
  end interface




  interface int
    module procedure int_single_st
  end interface
  interface
    pure function cpp_int_single_st(a) bind(C)
      import single_st
      import C_INT
      type(single_st), intent(in) :: a
      integer(C_INT) cpp_int_single_st
    end function cpp_int_single_st
  end interface

  interface int
    module procedure int_double_st
  end interface
  interface
    pure function cpp_int_double_st(a) bind(C)
      import double_st
      import C_INT
      type(double_st), intent(in) :: a
      integer(C_INT) cpp_int_double_st
    end function cpp_int_double_st
  end interface




  interface real
    module procedure single_st_double_st
  end interface

  interface real
    module procedure single_st_single_st
  end interface

  interface dble
    module procedure double_st_single_st
  end interface

  interface dble
    module procedure double_st_double_st
  end interface


contains



  elemental function int_single_st(a)
    type(single_st), intent(in) :: a
    integer(C_INT) int_single_st

    int_single_st = cpp_int_single_st(a)
  end function int_single_st

  elemental function int_double_st(a)
    type(double_st), intent(in) :: a
    integer(C_INT) int_double_st

    int_double_st = cpp_int_double_st(a)
  end function int_double_st




  elemental function single_st_double_st(a)
    type(double_st), intent(in) :: a
    type(single_st) single_st_double_st

    single_st_double_st = a
  end function single_st_double_st

  elemental function single_st_single_st(a)
    type(single_st), intent(in) :: a
    type(single_st) single_st_single_st

    single_st_single_st = a
  end function single_st_single_st

  elemental function double_st_single_st(a)
    type(single_st), intent(in) :: a
    type(double_st) double_st_single_st

    double_st_single_st = a
  end function double_st_single_st

  elemental function double_st_double_st(a)
    type(double_st), intent(in) :: a
    type(double_st) double_st_double_st

    double_st_double_st = a
  end function double_st_double_st




end module cadna_convert

!Copyright 2017 R. CARPENTIER, P. CORDE, F. JEZEQUEL, J.-L. LAMOTTE
!
!This file is part of CADNA.
!
!    CADNA is free software: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as
!    published by the Free Software Foundation, either version 3 of the
!    License, or (at your option) any later version.
!
!    CADNA is distributed in the hope that it will be useful, but WITHOUT
!    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
!    or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General
!    Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public
!    License along with CADNA. If not, see
!    <http://www.gnu.org/licenses/>.
!


module cadna_utils
  use ISO_C_BINDING, only : C_INT, C_DOUBLE, C_CHAR, C_NULL_CHAR
  use cadna_types

  implicit none

  interface nb_significant_digit
    function nb_significant_digit_single_st(a) bind(C, name="cpp_nb_significant_digit_single_st")
      import single_st, C_INT
      type(single_st), intent(in) :: a
      integer(kind=C_INT) :: nb_significant_digit_single_st
    end function nb_significant_digit_single_st
    function nb_significant_digit_double_st(a) bind(C, name="cpp_nb_significant_digit_double_st")
      import double_st, C_INT
      type(double_st), intent(in) :: a
      integer(kind=C_INT) :: nb_significant_digit_double_st
    end function nb_significant_digit_double_st
  end interface nb_significant_digit
  !
  !=== DATA_ST ===
  interface data_st
    module procedure f_data_st_single_st, f_data_st_single_st_double_int, &
                     f_data_st_double_st, f_data_st_double_st_double_int
  end interface data_st
  !
  interface
    pure subroutine data_st_single_st(a) bind(C,name="cpp_data_st_single_st")
      import single_st
      type(single_st), intent(inout) :: a
    end subroutine data_st_single_st
    pure subroutine data_st_single_st_double_int(a, e, error_type) bind(C,name="cpp_data_st_single_st_double_int")
      import single_st, C_INT, C_DOUBLE
      type(single_st), intent(inout) :: a
      real(C_DOUBLE),  intent(in)    :: e
      integer(C_INT),  intent(in)    :: error_type
    end subroutine data_st_single_st_double_int
    pure subroutine data_st_double_st(a) bind(C,name="cpp_data_st_double_st")
      import double_st
      type(double_st), intent(inout) :: a
    end subroutine data_st_double_st
    pure subroutine data_st_double_st_double_int(a, e, error_type) bind(C,name="cpp_data_st_double_st_double_int")
      import double_st, C_INT, C_DOUBLE
      type(double_st), intent(inout) :: a
      real(C_DOUBLE),  intent(in)    :: e
      integer(C_INT),  intent(in)    :: error_type
    end subroutine data_st_double_st_double_int
  end interface
  !=== END DATA_ST ===

  !=== DISPLAY ===
  interface display
    module procedure f_display_single_st, f_display_char_single_st, &
                     f_display_double_st, f_display_char_double_st
  end interface display
  !
  interface
    pure subroutine display_single_st(a) bind(C, name="cpp_display_single_st")
      import single_st
      type(single_st), intent(in) :: a
    end subroutine display_single_st
    pure subroutine display_char_single_st(s, a) bind(C, name="cpp_display_char_single_st")
      import single_st, C_CHAR
      character(kind=C_CHAR), dimension(*), intent(in) :: s
      type(single_st), intent(in) :: a
    end subroutine display_char_single_st
    !
    pure subroutine display_double_st(a) bind(C, name="cpp_display_double_st")
      import double_st
      type(double_st), intent(in) :: a
    end subroutine display_double_st
    pure subroutine display_char_double_st(s, a) bind(C, name="cpp_display_char_double_st")
      import double_st, C_CHAR
      character(kind=C_CHAR), dimension(*), intent(in) :: s
      type(double_st), intent(in) :: a
    end subroutine display_char_double_st
  end interface
  !=== END DISPLAY ===
  !
  !=== STR ===
  interface str
    module procedure f_str_single_st, f_str_double_st
  end interface str
  !
  interface
    pure subroutine str_single_st(a,str) bind(C, name="cpp_str_single_st")
      import single_st, C_CHAR
      type(single_st), intent(in) :: a
      character(kind=C_CHAR), dimension(*), intent(out) :: str
    end subroutine str_single_st
    pure subroutine str_double_st(a,str) bind(C, name="cpp_str_double_st")
      import double_st, C_CHAR
      type(double_st), intent(in) :: a
      character(kind=C_CHAR), dimension(*), intent(out) :: str
    end subroutine str_double_st
  end interface
  !=== END STR ===

contains

  !=== DISPLAY ===
  elemental subroutine f_display_single_st(a)
    type(single_st), intent(in) :: a

    call display_single_st(a)
  end subroutine f_display_single_st

  elemental subroutine f_display_char_single_st(s, a)
    character(kind=C_CHAR, len=*), intent(in) :: s
    type(single_st), intent(in) :: a

    call display_char_single_st(s, a)
  end subroutine f_display_char_single_st
  !
  elemental subroutine f_display_double_st(a)
    type(double_st), intent(in) :: a

    call display_double_st(a)
  end subroutine f_display_double_st

  elemental subroutine f_display_char_double_st(s, a)
    character(kind=C_CHAR, len=*), intent(in) :: s
    type(double_st), intent(in) :: a

    call display_char_double_st(s, a)
  end subroutine f_display_char_double_st
  !=== END DISPLAY ===

  !=== STR ===
  elemental function f_str_single_st(a)
    type(single_st), intent(in) :: a
    !character(len=:), allocatable :: f_str_single_st
    character(kind=C_CHAR,len=64) :: f_str_single_st
    integer i

    call str_single_st(a, f_str_single_st)
    i = index(f_str_single_st, C_NULL_CHAR )
    f_str_single_st(i:) = ' '
  end function f_str_single_st
  elemental function f_str_double_st(a)
    type(double_st), intent(in) :: a
    !character(len=:), allocatable :: f_str_double_st
    character(kind=C_CHAR,len=64) :: f_str_double_st
    integer i

    call str_double_st(a, f_str_double_st)
    i = index(f_str_double_st, C_NULL_CHAR )
    f_str_double_st(i:) = ' '
  end function f_str_double_st
  !=== END STR ===
  
  !=== DATA_ST ===
  elemental subroutine f_data_st_single_st(a)
    type(single_st), intent(inout) :: a

    call data_st_single_st(a)
  end  subroutine f_data_st_single_st

  elemental subroutine f_data_st_single_st_double_int(a, e, error_type)
    type(single_st), intent(inout) :: a
    real(C_DOUBLE),  intent(in)    :: e
    integer(C_INT),  intent(in)    :: error_type

    call data_st_single_st_double_int(a, e, error_type)
  end  subroutine f_data_st_single_st_double_int
  elemental subroutine f_data_st_double_st(a)
    type(double_st), intent(inout) :: a

    call data_st_double_st(a)
  end  subroutine f_data_st_double_st

  elemental subroutine f_data_st_double_st_double_int(a, e, error_type)
    type(double_st), intent(inout) :: a
    real(C_DOUBLE),  intent(in)    :: e
    integer(C_INT),  intent(in)    :: error_type

    call data_st_double_st_double_int(a, e, error_type)
  end  subroutine f_data_st_double_st_double_int
  !=== END DATA_ST ===

end module cadna_utils

!Copyright 2017 R. CARPENTIER, P. CORDE, F. JEZEQUEL, J.-L. LAMOTTE
!
!This file is part of CADNA.
!
!    CADNA is free software: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as
!    published by the Free Software Foundation, either version 3 of the
!    License, or (at your option) any later version.
!
!    CADNA is distributed in the hope that it will be useful, but WITHOUT
!    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
!    or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General
!    Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public
!    License along with CADNA. If not, see
!    <http://www.gnu.org/licenses/>.
!


! Module de surcharge de l'opérateur "/"




module cadna_div
  use ISO_C_BINDING, only : C_LONG_LONG, C_LONG, C_INT, C_SHORT, C_FLOAT, C_DOUBLE
  use cadna_types
  implicit none




  interface operator(/)
    module procedure div_double_st_double_st
  end interface operator(/)
  interface
    pure function cpp_div_double_st_double_st(a, b) bind(C)
      import double_st
      
      type(double_st), intent(in) :: a
      type(double_st), intent(in) :: b
      type(double_st) cpp_div_double_st_double_st
    end function cpp_div_double_st_double_st
  end interface

  interface operator(/)
    module procedure div_double_st_single_st
  end interface operator(/)
  interface
    pure function cpp_div_double_st_single_st(a, b) bind(C)
      import double_st
      import single_st
      type(double_st), intent(in) :: a
      type(single_st), intent(in) :: b
      type(double_st) cpp_div_double_st_single_st
    end function cpp_div_double_st_single_st
  end interface

  interface operator(/)
    module procedure div_double_st_double
  end interface operator(/)
  interface
    pure function cpp_div_double_st_double(a, b) bind(C)
      import double_st
      import C_DOUBLE
      type(double_st), intent(in) :: a
      real(C_DOUBLE), intent(in) :: b
      type(double_st) cpp_div_double_st_double
    end function cpp_div_double_st_double
  end interface

  interface operator(/)
    module procedure div_double_st_float
  end interface operator(/)
  interface
    pure function cpp_div_double_st_float(a, b) bind(C)
      import double_st
      import C_FLOAT
      type(double_st), intent(in) :: a
      real(C_FLOAT), intent(in) :: b
      type(double_st) cpp_div_double_st_float
    end function cpp_div_double_st_float
  end interface

  interface operator(/)
    module procedure div_double_st_long_long
  end interface operator(/)
  interface
    pure function cpp_div_double_st_long_long(a, b) bind(C)
      import double_st
      import C_LONG_LONG
      type(double_st), intent(in) :: a
      integer(C_LONG_LONG), intent(in) :: b
      type(double_st) cpp_div_double_st_long_long
    end function cpp_div_double_st_long_long
  end interface

!INTERFACE_OP(/, div, double_st, long,      double_st)
  interface operator(/)
    module procedure div_double_st_int
  end interface operator(/)
  interface
    pure function cpp_div_double_st_int(a, b) bind(C)
      import double_st
      import C_INT
      type(double_st), intent(in) :: a
      integer(C_INT), intent(in) :: b
      type(double_st) cpp_div_double_st_int
    end function cpp_div_double_st_int
  end interface

  interface operator(/)
    module procedure div_double_st_short
  end interface operator(/)
  interface
    pure function cpp_div_double_st_short(a, b) bind(C)
      import double_st
      import C_SHORT
      type(double_st), intent(in) :: a
      integer(C_SHORT), intent(in) :: b
      type(double_st) cpp_div_double_st_short
    end function cpp_div_double_st_short
  end interface


  interface operator(/)
    module procedure div_single_st_double_st
  end interface operator(/)
  interface
    pure function cpp_div_single_st_double_st(a, b) bind(C)
      import single_st
      import double_st
      type(single_st), intent(in) :: a
      type(double_st), intent(in) :: b
      type(double_st) cpp_div_single_st_double_st
    end function cpp_div_single_st_double_st
  end interface

  interface operator(/)
    module procedure div_single_st_single_st
  end interface operator(/)
  interface
    pure function cpp_div_single_st_single_st(a, b) bind(C)
      import single_st
      
      type(single_st), intent(in) :: a
      type(single_st), intent(in) :: b
      type(single_st) cpp_div_single_st_single_st
    end function cpp_div_single_st_single_st
  end interface

  interface operator(/)
    module procedure div_single_st_double
  end interface operator(/)
  interface
    pure function cpp_div_single_st_double(a, b) bind(C)
      import single_st
      import C_DOUBLE
      type(single_st), intent(in) :: a
      real(C_DOUBLE), intent(in) :: b
      type(single_st) cpp_div_single_st_double
    end function cpp_div_single_st_double
  end interface

  interface operator(/)
    module procedure div_single_st_float
  end interface operator(/)
  interface
    pure function cpp_div_single_st_float(a, b) bind(C)
      import single_st
      import C_FLOAT
      type(single_st), intent(in) :: a
      real(C_FLOAT), intent(in) :: b
      type(single_st) cpp_div_single_st_float
    end function cpp_div_single_st_float
  end interface

  interface operator(/)
    module procedure div_single_st_long_long
  end interface operator(/)
  interface
    pure function cpp_div_single_st_long_long(a, b) bind(C)
      import single_st
      import C_LONG_LONG
      type(single_st), intent(in) :: a
      integer(C_LONG_LONG), intent(in) :: b
      type(single_st) cpp_div_single_st_long_long
    end function cpp_div_single_st_long_long
  end interface

!INTERFACE_OP(/, div, single_st, long,      single_st)
  interface operator(/)
    module procedure div_single_st_int
  end interface operator(/)
  interface
    pure function cpp_div_single_st_int(a, b) bind(C)
      import single_st
      import C_INT
      type(single_st), intent(in) :: a
      integer(C_INT), intent(in) :: b
      type(single_st) cpp_div_single_st_int
    end function cpp_div_single_st_int
  end interface

  interface operator(/)
    module procedure div_single_st_short
  end interface operator(/)
  interface
    pure function cpp_div_single_st_short(a, b) bind(C)
      import single_st
      import C_SHORT
      type(single_st), intent(in) :: a
      integer(C_SHORT), intent(in) :: b
      type(single_st) cpp_div_single_st_short
    end function cpp_div_single_st_short
  end interface


  interface operator(/)
    module procedure div_double_double_st
  end interface operator(/)
  interface
    pure function cpp_div_double_double_st(a, b) bind(C)
      import C_DOUBLE
      import double_st
      real(C_DOUBLE), intent(in) :: a
      type(double_st), intent(in) :: b
      type(double_st) cpp_div_double_double_st
    end function cpp_div_double_double_st
  end interface

  interface operator(/)
    module procedure div_double_single_st
  end interface operator(/)
  interface
    pure function cpp_div_double_single_st(a, b) bind(C)
      import C_DOUBLE
      import single_st
      real(C_DOUBLE), intent(in) :: a
      type(single_st), intent(in) :: b
      type(single_st) cpp_div_double_single_st
    end function cpp_div_double_single_st
  end interface


  interface operator(/)
    module procedure div_float_double_st
  end interface operator(/)
  interface
    pure function cpp_div_float_double_st(a, b) bind(C)
      import C_FLOAT
      import double_st
      real(C_FLOAT), intent(in) :: a
      type(double_st), intent(in) :: b
      type(double_st) cpp_div_float_double_st
    end function cpp_div_float_double_st
  end interface

  interface operator(/)
    module procedure div_float_single_st
  end interface operator(/)
  interface
    pure function cpp_div_float_single_st(a, b) bind(C)
      import C_FLOAT
      import single_st
      real(C_FLOAT), intent(in) :: a
      type(single_st), intent(in) :: b
      type(single_st) cpp_div_float_single_st
    end function cpp_div_float_single_st
  end interface


  interface operator(/)
    module procedure div_long_long_double_st
  end interface operator(/)
  interface
    pure function cpp_div_long_long_double_st(a, b) bind(C)
      import C_LONG_LONG
      import double_st
      integer(C_LONG_LONG), intent(in) :: a
      type(double_st), intent(in) :: b
      type(double_st) cpp_div_long_long_double_st
    end function cpp_div_long_long_double_st
  end interface

  interface operator(/)
    module procedure div_long_long_single_st
  end interface operator(/)
  interface
    pure function cpp_div_long_long_single_st(a, b) bind(C)
      import C_LONG_LONG
      import single_st
      integer(C_LONG_LONG), intent(in) :: a
      type(single_st), intent(in) :: b
      type(single_st) cpp_div_long_long_single_st
    end function cpp_div_long_long_single_st
  end interface


!INTERFACE_OP(/, div, long, double_st,      double_st)
!INTERFACE_OP(/, div, long, single_st,      single_st)

  interface operator(/)
    module procedure div_int_double_st
  end interface operator(/)
  interface
    pure function cpp_div_int_double_st(a, b) bind(C)
      import C_INT
      import double_st
      integer(C_INT), intent(in) :: a
      type(double_st), intent(in) :: b
      type(double_st) cpp_div_int_double_st
    end function cpp_div_int_double_st
  end interface

  interface operator(/)
    module procedure div_int_single_st
  end interface operator(/)
  interface
    pure function cpp_div_int_single_st(a, b) bind(C)
      import C_INT
      import single_st
      integer(C_INT), intent(in) :: a
      type(single_st), intent(in) :: b
      type(single_st) cpp_div_int_single_st
    end function cpp_div_int_single_st
  end interface


  interface operator(/)
    module procedure div_short_double_st
  end interface operator(/)
  interface
    pure function cpp_div_short_double_st(a, b) bind(C)
      import C_SHORT
      import double_st
      integer(C_SHORT), intent(in) :: a
      type(double_st), intent(in) :: b
      type(double_st) cpp_div_short_double_st
    end function cpp_div_short_double_st
  end interface

  interface operator(/)
    module procedure div_short_single_st
  end interface operator(/)
  interface
    pure function cpp_div_short_single_st(a, b) bind(C)
      import C_SHORT
      import single_st
      integer(C_SHORT), intent(in) :: a
      type(single_st), intent(in) :: b
      type(single_st) cpp_div_short_single_st
    end function cpp_div_short_single_st
  end interface


contains



  elemental function div_double_st_double_st(a, b)
    type(double_st), intent(in) :: a
    type(double_st), intent(in) :: b
    type(double_st) div_double_st_double_st

    div_double_st_double_st = cpp_div_double_st_double_st(a, b)
  end function div_double_st_double_st

  elemental function div_double_st_single_st(a, b)
    type(double_st), intent(in) :: a
    type(single_st), intent(in) :: b
    type(double_st) div_double_st_single_st

    div_double_st_single_st = cpp_div_double_st_single_st(a, b)
  end function div_double_st_single_st

  elemental function div_double_st_double(a, b)
    type(double_st), intent(in) :: a
    real(C_DOUBLE), intent(in) :: b
    type(double_st) div_double_st_double

    div_double_st_double = cpp_div_double_st_double(a, b)
  end function div_double_st_double

  elemental function div_double_st_float(a, b)
    type(double_st), intent(in) :: a
    real(C_FLOAT), intent(in) :: b
    type(double_st) div_double_st_float

    div_double_st_float = cpp_div_double_st_float(a, b)
  end function div_double_st_float

  elemental function div_double_st_long_long(a, b)
    type(double_st), intent(in) :: a
    integer(C_LONG_LONG), intent(in) :: b
    type(double_st) div_double_st_long_long

    div_double_st_long_long = cpp_div_double_st_long_long(a, b)
  end function div_double_st_long_long

!CONTAINS_OP(div, double_st, long,      double_st)
  elemental function div_double_st_int(a, b)
    type(double_st), intent(in) :: a
    integer(C_INT), intent(in) :: b
    type(double_st) div_double_st_int

    div_double_st_int = cpp_div_double_st_int(a, b)
  end function div_double_st_int

  elemental function div_double_st_short(a, b)
    type(double_st), intent(in) :: a
    integer(C_SHORT), intent(in) :: b
    type(double_st) div_double_st_short

    div_double_st_short = cpp_div_double_st_short(a, b)
  end function div_double_st_short


  elemental function div_single_st_double_st(a, b)
    type(single_st), intent(in) :: a
    type(double_st), intent(in) :: b
    type(double_st) div_single_st_double_st

    div_single_st_double_st = cpp_div_single_st_double_st(a, b)
  end function div_single_st_double_st

  elemental function div_single_st_single_st(a, b)
    type(single_st), intent(in) :: a
    type(single_st), intent(in) :: b
    type(single_st) div_single_st_single_st

    div_single_st_single_st = cpp_div_single_st_single_st(a, b)
  end function div_single_st_single_st

  elemental function div_single_st_double(a, b)
    type(single_st), intent(in) :: a
    real(C_DOUBLE), intent(in) :: b
    type(single_st) div_single_st_double

    div_single_st_double = cpp_div_single_st_double(a, b)
  end function div_single_st_double

  elemental function div_single_st_float(a, b)
    type(single_st), intent(in) :: a
    real(C_FLOAT), intent(in) :: b
    type(single_st) div_single_st_float

    div_single_st_float = cpp_div_single_st_float(a, b)
  end function div_single_st_float

  elemental function div_single_st_long_long(a, b)
    type(single_st), intent(in) :: a
    integer(C_LONG_LONG), intent(in) :: b
    type(single_st) div_single_st_long_long

    div_single_st_long_long = cpp_div_single_st_long_long(a, b)
  end function div_single_st_long_long

!CONTAINS_OP(div, single_st, long,      single_st)
  elemental function div_single_st_int(a, b)
    type(single_st), intent(in) :: a
    integer(C_INT), intent(in) :: b
    type(single_st) div_single_st_int

    div_single_st_int = cpp_div_single_st_int(a, b)
  end function div_single_st_int

  elemental function div_single_st_short(a, b)
    type(single_st), intent(in) :: a
    integer(C_SHORT), intent(in) :: b
    type(single_st) div_single_st_short

    div_single_st_short = cpp_div_single_st_short(a, b)
  end function div_single_st_short


  elemental function div_double_double_st(a, b)
    real(C_DOUBLE), intent(in) :: a
    type(double_st), intent(in) :: b
    type(double_st) div_double_double_st

    div_double_double_st = cpp_div_double_double_st(a, b)
  end function div_double_double_st

  elemental function div_double_single_st(a, b)
    real(C_DOUBLE), intent(in) :: a
    type(single_st), intent(in) :: b
    type(single_st) div_double_single_st

    div_double_single_st = cpp_div_double_single_st(a, b)
  end function div_double_single_st


  elemental function div_float_double_st(a, b)
    real(C_FLOAT), intent(in) :: a
    type(double_st), intent(in) :: b
    type(double_st) div_float_double_st

    div_float_double_st = cpp_div_float_double_st(a, b)
  end function div_float_double_st

  elemental function div_float_single_st(a, b)
    real(C_FLOAT), intent(in) :: a
    type(single_st), intent(in) :: b
    type(single_st) div_float_single_st

    div_float_single_st = cpp_div_float_single_st(a, b)
  end function div_float_single_st


  elemental function div_long_long_double_st(a, b)
    integer(C_LONG_LONG), intent(in) :: a
    type(double_st), intent(in) :: b
    type(double_st) div_long_long_double_st

    div_long_long_double_st = cpp_div_long_long_double_st(a, b)
  end function div_long_long_double_st

  elemental function div_long_long_single_st(a, b)
    integer(C_LONG_LONG), intent(in) :: a
    type(single_st), intent(in) :: b
    type(single_st) div_long_long_single_st

    div_long_long_single_st = cpp_div_long_long_single_st(a, b)
  end function div_long_long_single_st


!CONTAINS_OP(div, long, double_st,      double_st)
!CONTAINS_OP(div, long, single_st,      single_st)

  elemental function div_int_double_st(a, b)
    integer(C_INT), intent(in) :: a
    type(double_st), intent(in) :: b
    type(double_st) div_int_double_st

    div_int_double_st = cpp_div_int_double_st(a, b)
  end function div_int_double_st

  elemental function div_int_single_st(a, b)
    integer(C_INT), intent(in) :: a
    type(single_st), intent(in) :: b
    type(single_st) div_int_single_st

    div_int_single_st = cpp_div_int_single_st(a, b)
  end function div_int_single_st


  elemental function div_short_double_st(a, b)
    integer(C_SHORT), intent(in) :: a
    type(double_st), intent(in) :: b
    type(double_st) div_short_double_st

    div_short_double_st = cpp_div_short_double_st(a, b)
  end function div_short_double_st

  elemental function div_short_single_st(a, b)
    integer(C_SHORT), intent(in) :: a
    type(single_st), intent(in) :: b
    type(single_st) div_short_single_st

    div_short_single_st = cpp_div_short_single_st(a, b)
  end function div_short_single_st




end module cadna_div

program ex7
  implicit none
  double precision :: r,r1,x,y,z
  integer :: i, nloop, ierr
  print *,'Example created on purpose to make CADNA fail'
  print *,'The same result r is computed for a number of iterations chosen by the user'
  print *,'The exact result is 1.4E-10'
  print *,'Enter the number of iterations'
  read *,nloop
  ierr = 0
  do i=1,nloop
    x=6.83561d+05
    y=6.83560d+05
    z=1.00000000007d0
    r = z - x
    r1 = z - y
    r = r + y
    r1 = r1 + x
    r1 = r1 - 2
    r = r + r1
    !      r = ((z-x)+y) + ((z-y)+x-2)
    if(r.ne.1.4d-10) then 
        ierr = ierr + 1
     endif
  enddo
  print *, 'Last value of r: ', r
  print *, 'Number of iterations when r is different from the exact result:', ierr 
end program ex7

      program ex4
      implicit double precision (a-h,o-z)
      !
      print *,'A second order recurrent sequence without CADNA:'
      a = 5.5d0
      b = 61.d0/11.d0
      do i=3,30
        c = b
        b = 111.d0 - 1130.d0/b + 3000.d0/(a*b)
        a = c
        write(*,'(a2,i2,a3,d23.16)')'U(',i,') = ',b
      enddo
      write(*,*)'The exact limit is 6.'
!
      end

!Copyright 2017 R. CARPENTIER, P. CORDE, F. JEZEQUEL, J.-L. LAMOTTE
!
!This file is part of CADNA.
!
!    CADNA is free software: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as
!    published by the Free Software Foundation, either version 3 of the
!    License, or (at your option) any later version.
!
!    CADNA is distributed in the hope that it will be useful, but WITHOUT
!    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
!    or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General
!    Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public
!    License along with CADNA. If not, see
!    <http://www.gnu.org/licenses/>.
!

module cadna
  use ISO_C_BINDING, only : C_INT
  use cadna_types
  use cadna_add
  use cadna_cmplx_add
  use cadna_sub
  use cadna_cmplx_sub
  use cadna_opp
  use cadna_cmplx_opp
  use cadna_plus
  use cadna_cmplx_plus
  use cadna_mult
  use cadna_cmplx_mult
  use cadna_pow
  use cadna_cmplx_pow
  use cadna_div
  use cadna_cmplx_div
  use cadna_affect
  use cadna_cmplx_affect
  use cadna_lt
  use cadna_le
  use cadna_gt
  use cadna_ge
  use cadna_eq
  use cadna_cmplx_eq
  use cadna_ne
  use cadna_cmplx_ne
  use cadna_math
  use cadna_cmplx_math
  use cadna_array
  use cadna_cmplx_array
  use cadna_convert
  use cadna_cmplx_convert
  use cadna_utils
  use cadna_prec

  interface cadna_init
    subroutine cadna_init_int( max_nb_instability ) bind(C, name="cpp_cadna_init_int")
      import C_INT

      integer(C_INT), VALUE :: max_nb_instability
    end subroutine cadna_init_int
    subroutine cadna_init_int_int( max_nb_instability, &
                                   tag ) bind(C, name="cpp_cadna_init_int_int")
      import C_INT

      integer(C_INT), VALUE :: max_nb_instability
      integer(C_INT), VALUE :: tag
    end subroutine cadna_init_int_int
    subroutine cadna_init_int_int_int_int( max_nb_instability, &
                                           tag,                &
                                           seed,               &
                                           cancellation ) bind(C, name="cpp_cadna_init_int_int_int_int")
      import C_INT

      integer(C_INT), VALUE :: max_nb_instability, tag, seed, cancellation
    end subroutine cadna_init_int_int_int_int
  end interface cadna_init

  interface
    subroutine cadna_end() bind(C, name="cpp_cadna_end")
    end subroutine cadna_end
  end interface

  interface
    subroutine cadna_enable(tag) bind(C, name="cpp_cadna_enable")
      import C_INT
      integer(C_INT), VALUE :: tag
    end subroutine cadna_enable
    subroutine cadna_disable(tag) bind(C, name="cpp_cadna_disable")
      import C_INT
      integer(C_INT), VALUE :: tag
    end subroutine cadna_disable
  end interface

end module cadna

!Copyright 2019 R. CARPENTIER, P. CORDE, F. JEZEQUEL, J.-L. LAMOTTE
!
!This file is part of CADNA.
!
!    CADNA is free software: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as
!    published by the Free Software Foundation, either version 3 of the
!    License, or (at your option) any later version.
!
!    CADNA is distributed in the hope that it will be useful, but WITHOUT
!    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
!    or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General
!    Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public
!    License along with CADNA. If not, see
!    <http://www.gnu.org/licenses/>.
!


! Module d'interfaçage MPI


module cadna_mpi
  use ISO_C_BINDING, only : C_INT

  integer(C_INT), bind(C,name="MPIF_SINGLE_ST")     :: MPIF_SINGLE_ST
  integer(C_INT), bind(C,name="MPIF_DOUBLE_ST")     :: MPIF_DOUBLE_ST

  integer(C_INT), bind(C,name="MPIF_CADNA_SUM_SP")  :: MPIF_CADNA_SUM_SP
  integer(C_INT), bind(C,name="MPIF_CADNA_SUM_DP")  :: MPIF_CADNA_SUM_DP
  integer(C_INT), bind(C,name="MPIF_CADNA_PROD_SP") :: MPIF_CADNA_PROD_SP
  integer(C_INT), bind(C,name="MPIF_CADNA_PROD_DP") :: MPIF_CADNA_PROD_DP
  integer(C_INT), bind(C,name="MPIF_CADNA_MIN_SP")  :: MPIF_CADNA_MIN_SP
  integer(C_INT), bind(C,name="MPIF_CADNA_MIN_DP")  :: MPIF_CADNA_MIN_DP
  integer(C_INT), bind(C,name="MPIF_CADNA_MAX_SP")  :: MPIF_CADNA_MAX_SP
  integer(C_INT), bind(C,name="MPIF_CADNA_MAX_DP")  :: MPIF_CADNA_MAX_DP

  integer(C_INT), bind(C) :: f_cadna_comm

  interface
    subroutine cadna_mpi_init( rank, max_nb_instability ) bind(C, name="cpp_cadna_mpi_init")
      import C_INT
      integer(C_INT), intent(in) :: rank
      integer(C_INT), value      :: max_nb_instability
    end subroutine cadna_mpi_init
    subroutine cadna_mpi_end() bind (C, name="cpp_cadna_mpi_end")
    end subroutine cadna_mpi_end
  end interface
end module cadna_mpi

!Copyright 2017 R. CARPENTIER, P. CORDE, F. JEZEQUEL, J.-L. LAMOTTE
!
!This file is part of CADNA.
!
!    CADNA is free software: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as
!    published by the Free Software Foundation, either version 3 of the
!    License, or (at your option) any later version.
!
!    CADNA is distributed in the hope that it will be useful, but WITHOUT
!    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
!    or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General
!    Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public
!    License along with CADNA. If not, see
!    <http://www.gnu.org/licenses/>.
!



! Module de surcharge des fonctions mathématiques




module cadna_cmplx_math
  use cadna_types
  use cadna_affect
  use cadna_add
  use cadna_cmplx_add
  use cadna_sub
  use cadna_cmplx_sub
  use cadna_mult
  use cadna_cmplx_mult
! `use cadna_cmplx_pow'
  use cadna_div
  use cadna_cmplx_div
  use cadna_opp
  use cadna_math
  use cadna_lt
  use cadna_gt

  implicit none


!define(INTERFACE_MATH_UNAIRE_DOUBLE,
!`  interface $1'
!    `module procedure $1_double_st'
!  `end interface'
!)
!
!INTERFACE_MATH_UNAIRE_DOUBLE(dabs)
!INTERFACE_MATH_UNAIRE_DOUBLE(dsqrt)
!INTERFACE_MATH_UNAIRE_DOUBLE(dsin)
!INTERFACE_MATH_UNAIRE_DOUBLE(dcos)
!INTERFACE_MATH_UNAIRE_DOUBLE(dtan)
!INTERFACE_MATH_UNAIRE_DOUBLE(dexp)
!INTERFACE_MATH_UNAIRE_DOUBLE(dlog)



  interface abs
    module procedure abs_complex_single_st
  end interface abs

  interface abs
    module procedure abs_complex_double_st
  end interface abs

  interface acos
    module procedure acos_complex_single_st
  end interface acos

  interface acos
    module procedure acos_complex_double_st
  end interface acos

  interface acosh
    module procedure acosh_complex_single_st
  end interface acosh

  interface acosh
    module procedure acosh_complex_double_st
  end interface acosh

  interface asin
    module procedure asin_complex_single_st
  end interface asin

  interface asin
    module procedure asin_complex_double_st
  end interface asin

  interface asinh
    module procedure asinh_complex_single_st
  end interface asinh

  interface asinh
    module procedure asinh_complex_double_st
  end interface asinh

  interface atan
    module procedure atan_complex_single_st
  end interface atan

  interface atan
    module procedure atan_complex_double_st
  end interface atan

  interface atanh
    module procedure atanh_complex_single_st
  end interface atanh

  interface atanh
    module procedure atanh_complex_double_st
  end interface atanh

  interface cos
    module procedure cos_complex_single_st
  end interface cos

  interface cos
    module procedure cos_complex_double_st
  end interface cos

  interface cosh
    module procedure cosh_complex_single_st
  end interface cosh

  interface cosh
    module procedure cosh_complex_double_st
  end interface cosh

  interface exp
    module procedure exp_complex_single_st
  end interface exp

  interface exp
    module procedure exp_complex_double_st
  end interface exp

  interface log
    module procedure log_complex_single_st
  end interface log

  interface log
    module procedure log_complex_double_st
  end interface log

  interface sin
    module procedure sin_complex_single_st
  end interface sin

  interface sin
    module procedure sin_complex_double_st
  end interface sin

  interface sinh
    module procedure sinh_complex_single_st
  end interface sinh

  interface sinh
    module procedure sinh_complex_double_st
  end interface sinh

  interface sqrt
    module procedure sqrt_complex_single_st
  end interface sqrt

  interface sqrt
    module procedure sqrt_complex_double_st
  end interface sqrt

  interface tan
    module procedure tan_complex_single_st
  end interface tan

  interface tan
    module procedure tan_complex_double_st
  end interface tan

  interface tanh
    module procedure tanh_complex_single_st
  end interface tanh

  interface tanh
    module procedure tanh_complex_double_st
  end interface tanh


contains

!define(CONTAINS_MATH_UNAIRE_DOUBLE,
!`  elemental function $1_double_st(a)'
!`    type(double_st), intent(in) :: a'
!`    type(double_st) $1_double_st'
!
!`    $1_double_st = translit( $1, `^d' )(a)'
!`  end function $1_double_st'
!)
!
!CONTAINS_MATH_UNAIRE_DOUBLE(dabs)
!CONTAINS_MATH_UNAIRE_DOUBLE(dsqrt)
!CONTAINS_MATH_UNAIRE_DOUBLE(dsin)
!CONTAINS_MATH_UNAIRE_DOUBLE(dcos)
!CONTAINS_MATH_UNAIRE_DOUBLE(dtan)
!CONTAINS_MATH_UNAIRE_DOUBLE(dexp)
!CONTAINS_MATH_UNAIRE_DOUBLE(dlog)



  elemental function abs_complex_single_st(z)
    type(complex_single_st), intent(in) :: z
    type(single_st) abs_complex_single_st
    

    abs_complex_single_st = (z%x**2 + z%y**2)**0.5
  end function abs_complex_single_st

  elemental function abs_complex_double_st(z)
    type(complex_double_st), intent(in) :: z
    type(double_st) abs_complex_double_st
    

    abs_complex_double_st = (z%x**2 + z%y**2)**0.5
  end function abs_complex_double_st

  elemental function acos_complex_single_st(z)
    type(complex_single_st), intent(in) :: z
    type(complex_single_st) acos_complex_single_st 
    

    acos_complex_single_st = (0.,-1.)*log(z + (0.,1.)*sqrt(1.-z*z))
  end function acos_complex_single_st

  elemental function acos_complex_double_st(z)
    type(complex_double_st), intent(in) :: z
    type(complex_double_st) acos_complex_double_st 
    

    acos_complex_double_st = (0.,-1.)*log(z + (0.,1.)*sqrt(1.-z*z))
  end function acos_complex_double_st

  elemental function acosh_complex_single_st(z)
    type(complex_single_st), intent(in) :: z
    type(complex_single_st) acosh_complex_single_st 
    

    acosh_complex_single_st = log(z + sqrt(z-1.)*sqrt(z+1.))
  end function acosh_complex_single_st

  elemental function acosh_complex_double_st(z)
    type(complex_double_st), intent(in) :: z
    type(complex_double_st) acosh_complex_double_st 
    

    acosh_complex_double_st = log(z + sqrt(z-1.)*sqrt(z+1.))
  end function acosh_complex_double_st

  elemental function asin_complex_single_st(z)
    type(complex_single_st), intent(in) :: z
    type(complex_single_st) asin_complex_single_st 
    

    asin_complex_single_st = (0.,-1.)*log((0.,1.)*z + sqrt(1.-z*z))
  end function asin_complex_single_st

  elemental function asin_complex_double_st(z)
    type(complex_double_st), intent(in) :: z
    type(complex_double_st) asin_complex_double_st 
    

    asin_complex_double_st = (0.,-1.)*log((0.,1.)*z + sqrt(1.-z*z))
  end function asin_complex_double_st

  elemental function asinh_complex_single_st(z)
    type(complex_single_st), intent(in) :: z
    type(complex_single_st) asinh_complex_single_st 
    

    asinh_complex_single_st = log(z + sqrt(z*z+1.))
  end function asinh_complex_single_st

  elemental function asinh_complex_double_st(z)
    type(complex_double_st), intent(in) :: z
    type(complex_double_st) asinh_complex_double_st 
    

    asinh_complex_double_st = log(z + sqrt(z*z+1.))
  end function asinh_complex_double_st

  elemental function atan_complex_single_st(z)
    type(complex_single_st), intent(in) :: z
    type(complex_single_st) atan_complex_single_st 
    

    atan_complex_single_st = asin(z)/acos(z)
  end function atan_complex_single_st

  elemental function atan_complex_double_st(z)
    type(complex_double_st), intent(in) :: z
    type(complex_double_st) atan_complex_double_st 
    

    atan_complex_double_st = asin(z)/acos(z)
  end function atan_complex_double_st

  elemental function atanh_complex_single_st(z)
    type(complex_single_st), intent(in) :: z
    type(complex_single_st) atanh_complex_single_st 
    

    atanh_complex_single_st = asinh(z)/acosh(z) 
  end function atanh_complex_single_st

  elemental function atanh_complex_double_st(z)
    type(complex_double_st), intent(in) :: z
    type(complex_double_st) atanh_complex_double_st 
    

    atanh_complex_double_st = asinh(z)/acosh(z) 
  end function atanh_complex_double_st

  elemental function cos_complex_single_st(z)
    type(complex_single_st), intent(in) :: z
    type(complex_single_st) cos_complex_single_st 
    

    cos_complex_single_st%x =  cos(z%x)*cosh(z%y)
    cos_complex_single_st%y = -sin(z%x)*sinh(z%y)
  end function cos_complex_single_st

  elemental function cos_complex_double_st(z)
    type(complex_double_st), intent(in) :: z
    type(complex_double_st) cos_complex_double_st 
    

    cos_complex_double_st%x =  cos(z%x)*cosh(z%y)
    cos_complex_double_st%y = -sin(z%x)*sinh(z%y)
  end function cos_complex_double_st

  elemental function cosh_complex_single_st(z)
    type(complex_single_st), intent(in) :: z
    type(complex_single_st) cosh_complex_single_st 
    

    cosh_complex_single_st%x = cosh(z%x)*cos(z%y)
    cosh_complex_single_st%y = sinh(z%x)*sin(z%y)
  end function cosh_complex_single_st

  elemental function cosh_complex_double_st(z)
    type(complex_double_st), intent(in) :: z
    type(complex_double_st) cosh_complex_double_st 
    

    cosh_complex_double_st%x = cosh(z%x)*cos(z%y)
    cosh_complex_double_st%y = sinh(z%x)*sin(z%y)
  end function cosh_complex_double_st

  elemental function exp_complex_single_st(z)
    type(complex_single_st), intent(in) :: z
    type(complex_single_st) exp_complex_single_st 
    

    exp_complex_single_st%x = exp(z%x)*cos(z%y)
    exp_complex_single_st%y = exp(z%x)*sin(z%y)
  end function exp_complex_single_st

  elemental function exp_complex_double_st(z)
    type(complex_double_st), intent(in) :: z
    type(complex_double_st) exp_complex_double_st 
    

    exp_complex_double_st%x = exp(z%x)*cos(z%y)
    exp_complex_double_st%y = exp(z%x)*sin(z%y)
  end function exp_complex_double_st

  elemental function log_complex_single_st(z)
    type(complex_single_st), intent(in) :: z
    type(complex_single_st) log_complex_single_st 
    

    log_complex_single_st%x = log(abs(z))
    log_complex_single_st%y = atan(z%y/z%x)
    if (z%x<0. .AND. z%y<0.) log_complex_single_st%y = log_complex_single_st%y - acos(-z%x/z%x)
    if (z%x<0. .AND. z%y>0.) log_complex_single_st%y = log_complex_single_st%y + acos(-z%x/z%x)
  end function log_complex_single_st

  elemental function log_complex_double_st(z)
    type(complex_double_st), intent(in) :: z
    type(complex_double_st) log_complex_double_st 
    

    log_complex_double_st%x = log(abs(z))
    log_complex_double_st%y = atan(z%y/z%x)
    if (z%x<0. .AND. z%y<0.) log_complex_double_st%y = log_complex_double_st%y - acos(-z%x/z%x)
    if (z%x<0. .AND. z%y>0.) log_complex_double_st%y = log_complex_double_st%y + acos(-z%x/z%x)
  end function log_complex_double_st

  elemental function sin_complex_single_st(z)
    type(complex_single_st), intent(in) :: z
    type(complex_single_st) sin_complex_single_st 
    

    sin_complex_single_st%x = sin(z%x)*cosh(z%y)
    sin_complex_single_st%y = cos(z%x)*sinh(z%y)
  end function sin_complex_single_st

  elemental function sin_complex_double_st(z)
    type(complex_double_st), intent(in) :: z
    type(complex_double_st) sin_complex_double_st 
    

    sin_complex_double_st%x = sin(z%x)*cosh(z%y)
    sin_complex_double_st%y = cos(z%x)*sinh(z%y)
  end function sin_complex_double_st

  elemental function sinh_complex_single_st(z)
    type(complex_single_st), intent(in) :: z
    type(complex_single_st) sinh_complex_single_st 
    

    sinh_complex_single_st%x = sinh(z%x)*cos(z%y)
    sinh_complex_single_st%y = cosh(z%x)*sin(z%y)
  end function sinh_complex_single_st

  elemental function sinh_complex_double_st(z)
    type(complex_double_st), intent(in) :: z
    type(complex_double_st) sinh_complex_double_st 
    

    sinh_complex_double_st%x = sinh(z%x)*cos(z%y)
    sinh_complex_double_st%y = cosh(z%x)*sin(z%y)
  end function sinh_complex_double_st

  elemental function sqrt_complex_single_st(z)
    type(complex_single_st), intent(in) :: z
    type(complex_single_st) sqrt_complex_single_st 
    type(single_st) rho, theta

    rho = abs(z)
    theta = atan(z%y/z%x)
    if (z%x<0. .AND. z%y<0.) theta = theta - acos(-z%x/z%x)
    if (z%x<0. .AND. z%y>0.) theta = theta + acos(-z%x/z%x)
    rho = sqrt(rho)
    theta = theta/2
    sqrt_complex_single_st%x = rho*cos(theta)
    sqrt_complex_single_st%y = rho*sin(theta)
  end function sqrt_complex_single_st

  elemental function sqrt_complex_double_st(z)
    type(complex_double_st), intent(in) :: z
    type(complex_double_st) sqrt_complex_double_st 
    type(double_st) rho, theta

    rho = abs(z)
    theta = atan(z%y/z%x)
    if (z%x<0. .AND. z%y<0.) theta = theta - acos(-z%x/z%x)
    if (z%x<0. .AND. z%y>0.) theta = theta + acos(-z%x/z%x)
    rho = sqrt(rho)
    theta = theta/2
    sqrt_complex_double_st%x = rho*cos(theta)
    sqrt_complex_double_st%y = rho*sin(theta)
  end function sqrt_complex_double_st

  elemental function tan_complex_single_st(z)
    type(complex_single_st), intent(in) :: z
    type(complex_single_st) tan_complex_single_st 
    

    tan_complex_single_st =  sin(z)/cos(z)
  end function tan_complex_single_st

  elemental function tan_complex_double_st(z)
    type(complex_double_st), intent(in) :: z
    type(complex_double_st) tan_complex_double_st 
    

    tan_complex_double_st =  sin(z)/cos(z)
  end function tan_complex_double_st

  elemental function tanh_complex_single_st(z)
    type(complex_single_st), intent(in) :: z
    type(complex_single_st) tanh_complex_single_st 
    

    tanh_complex_single_st =  sinh(z)/cosh(z)
  end function tanh_complex_single_st

  elemental function tanh_complex_double_st(z)
    type(complex_double_st), intent(in) :: z
    type(complex_double_st) tanh_complex_double_st 
    

    tanh_complex_double_st =  sinh(z)/cosh(z)
  end function tanh_complex_double_st




end module cadna_cmplx_math

! Module de surcharge de l'opérateur "="




module cadna_affect
  use ISO_C_BINDING, only : C_LONG_LONG, C_LONG, C_INT, C_SHORT, C_FLOAT, C_DOUBLE
  use cadna_types
  implicit none




!INTERFACE_OP(affect, double_st, double_st, double_st)
  interface assignment(=)
    module procedure affect_double_st_single_st
  end interface assignment(=)
  interface
    pure subroutine cpp_affect_double_st_single_st(a, b) bind(C)
      import double_st
      import single_st
      type(double_st), intent(out) :: a
      type(single_st), intent(in) :: b
    end subroutine cpp_affect_double_st_single_st
  end interface

  interface assignment(=)
    module procedure affect_double_st_double
  end interface assignment(=)
  interface
    pure subroutine cpp_affect_double_st_double(a, b) bind(C)
      import double_st
      import C_DOUBLE
      type(double_st), intent(out) :: a
      real(C_DOUBLE), intent(in) :: b
    end subroutine cpp_affect_double_st_double
  end interface

  interface assignment(=)
    module procedure affect_double_st_float
  end interface assignment(=)
  interface
    pure subroutine cpp_affect_double_st_float(a, b) bind(C)
      import double_st
      import C_FLOAT
      type(double_st), intent(out) :: a
      real(C_FLOAT), intent(in) :: b
    end subroutine cpp_affect_double_st_float
  end interface

  interface assignment(=)
    module procedure affect_double_st_long_long
  end interface assignment(=)
  interface
    pure subroutine cpp_affect_double_st_long_long(a, b) bind(C)
      import double_st
      import C_LONG_LONG
      type(double_st), intent(out) :: a
      integer(C_LONG_LONG), intent(in) :: b
    end subroutine cpp_affect_double_st_long_long
  end interface

!INTERFACE_OP(affect, double_st, long,      double_st)
  interface assignment(=)
    module procedure affect_double_st_int
  end interface assignment(=)
  interface
    pure subroutine cpp_affect_double_st_int(a, b) bind(C)
      import double_st
      import C_INT
      type(double_st), intent(out) :: a
      integer(C_INT), intent(in) :: b
    end subroutine cpp_affect_double_st_int
  end interface

  interface assignment(=)
    module procedure affect_double_st_short
  end interface assignment(=)
  interface
    pure subroutine cpp_affect_double_st_short(a, b) bind(C)
      import double_st
      import C_SHORT
      type(double_st), intent(out) :: a
      integer(C_SHORT), intent(in) :: b
    end subroutine cpp_affect_double_st_short
  end interface


  interface assignment(=)
    module procedure affect_single_st_double_st
  end interface assignment(=)
  interface
    pure subroutine cpp_affect_single_st_double_st(a, b) bind(C)
      import single_st
      import double_st
      type(single_st), intent(out) :: a
      type(double_st), intent(in) :: b
    end subroutine cpp_affect_single_st_double_st
  end interface

!INTERFACE_OP(affect, single_st, single_st, single_st)
  interface assignment(=)
    module procedure affect_single_st_double
  end interface assignment(=)
  interface
    pure subroutine cpp_affect_single_st_double(a, b) bind(C)
      import single_st
      import C_DOUBLE
      type(single_st), intent(out) :: a
      real(C_DOUBLE), intent(in) :: b
    end subroutine cpp_affect_single_st_double
  end interface

  interface assignment(=)
    module procedure affect_single_st_float
  end interface assignment(=)
  interface
    pure subroutine cpp_affect_single_st_float(a, b) bind(C)
      import single_st
      import C_FLOAT
      type(single_st), intent(out) :: a
      real(C_FLOAT), intent(in) :: b
    end subroutine cpp_affect_single_st_float
  end interface

  interface assignment(=)
    module procedure affect_single_st_long_long
  end interface assignment(=)
  interface
    pure subroutine cpp_affect_single_st_long_long(a, b) bind(C)
      import single_st
      import C_LONG_LONG
      type(single_st), intent(out) :: a
      integer(C_LONG_LONG), intent(in) :: b
    end subroutine cpp_affect_single_st_long_long
  end interface

!INTERFACE_OP(affect, single_st, long,      single_st)
  interface assignment(=)
    module procedure affect_single_st_int
  end interface assignment(=)
  interface
    pure subroutine cpp_affect_single_st_int(a, b) bind(C)
      import single_st
      import C_INT
      type(single_st), intent(out) :: a
      integer(C_INT), intent(in) :: b
    end subroutine cpp_affect_single_st_int
  end interface

  interface assignment(=)
    module procedure affect_single_st_short
  end interface assignment(=)
  interface
    pure subroutine cpp_affect_single_st_short(a, b) bind(C)
      import single_st
      import C_SHORT
      type(single_st), intent(out) :: a
      integer(C_SHORT), intent(in) :: b
    end subroutine cpp_affect_single_st_short
  end interface


  interface assignment(=)
    module procedure affect_double_double_st
  end interface assignment(=)
  interface
    pure subroutine cpp_affect_double_double_st(a, b) bind(C)
      import C_DOUBLE
      import double_st
      real(C_DOUBLE), intent(out) :: a
      type(double_st), intent(in) :: b
    end subroutine cpp_affect_double_double_st
  end interface

  interface assignment(=)
    module procedure affect_double_single_st
  end interface assignment(=)
  interface
    pure subroutine cpp_affect_double_single_st(a, b) bind(C)
      import C_DOUBLE
      import single_st
      real(C_DOUBLE), intent(out) :: a
      type(single_st), intent(in) :: b
    end subroutine cpp_affect_double_single_st
  end interface


  interface assignment(=)
    module procedure affect_float_double_st
  end interface assignment(=)
  interface
    pure subroutine cpp_affect_float_double_st(a, b) bind(C)
      import C_FLOAT
      import double_st
      real(C_FLOAT), intent(out) :: a
      type(double_st), intent(in) :: b
    end subroutine cpp_affect_float_double_st
  end interface

  interface assignment(=)
    module procedure affect_float_single_st
  end interface assignment(=)
  interface
    pure subroutine cpp_affect_float_single_st(a, b) bind(C)
      import C_FLOAT
      import single_st
      real(C_FLOAT), intent(out) :: a
      type(single_st), intent(in) :: b
    end subroutine cpp_affect_float_single_st
  end interface


  interface assignment(=)
    module procedure affect_long_long_double_st
  end interface assignment(=)
  interface
    pure subroutine cpp_affect_long_long_double_st(a, b) bind(C)
      import C_LONG_LONG
      import double_st
      integer(C_LONG_LONG), intent(out) :: a
      type(double_st), intent(in) :: b
    end subroutine cpp_affect_long_long_double_st
  end interface

  interface assignment(=)
    module procedure affect_long_long_single_st
  end interface assignment(=)
  interface
    pure subroutine cpp_affect_long_long_single_st(a, b) bind(C)
      import C_LONG_LONG
      import single_st
      integer(C_LONG_LONG), intent(out) :: a
      type(single_st), intent(in) :: b
    end subroutine cpp_affect_long_long_single_st
  end interface


!INTERFACE_OP(affect, long, double_st,      double_st)
!INTERFACE_OP(affect, long, single_st,      single_st)

  interface assignment(=)
    module procedure affect_int_double_st
  end interface assignment(=)
  interface
    pure subroutine cpp_affect_int_double_st(a, b) bind(C)
      import C_INT
      import double_st
      integer(C_INT), intent(out) :: a
      type(double_st), intent(in) :: b
    end subroutine cpp_affect_int_double_st
  end interface

  interface assignment(=)
    module procedure affect_int_single_st
  end interface assignment(=)
  interface
    pure subroutine cpp_affect_int_single_st(a, b) bind(C)
      import C_INT
      import single_st
      integer(C_INT), intent(out) :: a
      type(single_st), intent(in) :: b
    end subroutine cpp_affect_int_single_st
  end interface


  interface assignment(=)
    module procedure affect_short_double_st
  end interface assignment(=)
  interface
    pure subroutine cpp_affect_short_double_st(a, b) bind(C)
      import C_SHORT
      import double_st
      integer(C_SHORT), intent(out) :: a
      type(double_st), intent(in) :: b
    end subroutine cpp_affect_short_double_st
  end interface

  interface assignment(=)
    module procedure affect_short_single_st
  end interface assignment(=)
  interface
    pure subroutine cpp_affect_short_single_st(a, b) bind(C)
      import C_SHORT
      import single_st
      integer(C_SHORT), intent(out) :: a
      type(single_st), intent(in) :: b
    end subroutine cpp_affect_short_single_st
  end interface


contains



!CONTAINS_OP(affect, double_st, double_st)
  elemental subroutine affect_double_st_single_st(a, b)
    type(double_st), intent(out) :: a
    type(single_st), intent(in) :: b

    call cpp_affect_double_st_single_st(a, b)
  end subroutine affect_double_st_single_st

  elemental subroutine affect_double_st_double(a, b)
    type(double_st), intent(out) :: a
    real(C_DOUBLE), intent(in) :: b

    call cpp_affect_double_st_double(a, b)
  end subroutine affect_double_st_double

  elemental subroutine affect_double_st_float(a, b)
    type(double_st), intent(out) :: a
    real(C_FLOAT), intent(in) :: b

    call cpp_affect_double_st_float(a, b)
  end subroutine affect_double_st_float

  elemental subroutine affect_double_st_long_long(a, b)
    type(double_st), intent(out) :: a
    integer(C_LONG_LONG), intent(in) :: b

    call cpp_affect_double_st_long_long(a, b)
  end subroutine affect_double_st_long_long

!CONTAINS_OP(affect, double_st, long)
  elemental subroutine affect_double_st_int(a, b)
    type(double_st), intent(out) :: a
    integer(C_INT), intent(in) :: b

    call cpp_affect_double_st_int(a, b)
  end subroutine affect_double_st_int

  elemental subroutine affect_double_st_short(a, b)
    type(double_st), intent(out) :: a
    integer(C_SHORT), intent(in) :: b

    call cpp_affect_double_st_short(a, b)
  end subroutine affect_double_st_short


  elemental subroutine affect_single_st_double_st(a, b)
    type(single_st), intent(out) :: a
    type(double_st), intent(in) :: b

    call cpp_affect_single_st_double_st(a, b)
  end subroutine affect_single_st_double_st

!CONTAINS_OP(affect, single_st, single_st)
  elemental subroutine affect_single_st_double(a, b)
    type(single_st), intent(out) :: a
    real(C_DOUBLE), intent(in) :: b

    call cpp_affect_single_st_double(a, b)
  end subroutine affect_single_st_double

  elemental subroutine affect_single_st_float(a, b)
    type(single_st), intent(out) :: a
    real(C_FLOAT), intent(in) :: b

    call cpp_affect_single_st_float(a, b)
  end subroutine affect_single_st_float

  elemental subroutine affect_single_st_long_long(a, b)
    type(single_st), intent(out) :: a
    integer(C_LONG_LONG), intent(in) :: b

    call cpp_affect_single_st_long_long(a, b)
  end subroutine affect_single_st_long_long

!CONTAINS_OP(affect, single_st, long)
  elemental subroutine affect_single_st_int(a, b)
    type(single_st), intent(out) :: a
    integer(C_INT), intent(in) :: b

    call cpp_affect_single_st_int(a, b)
  end subroutine affect_single_st_int

  elemental subroutine affect_single_st_short(a, b)
    type(single_st), intent(out) :: a
    integer(C_SHORT), intent(in) :: b

    call cpp_affect_single_st_short(a, b)
  end subroutine affect_single_st_short


  elemental subroutine affect_double_double_st(a, b)
    real(C_DOUBLE), intent(out) :: a
    type(double_st), intent(in) :: b

    call cpp_affect_double_double_st(a, b)
  end subroutine affect_double_double_st

  elemental subroutine affect_double_single_st(a, b)
    real(C_DOUBLE), intent(out) :: a
    type(single_st), intent(in) :: b

    call cpp_affect_double_single_st(a, b)
  end subroutine affect_double_single_st


  elemental subroutine affect_float_double_st(a, b)
    real(C_FLOAT), intent(out) :: a
    type(double_st), intent(in) :: b

    call cpp_affect_float_double_st(a, b)
  end subroutine affect_float_double_st

  elemental subroutine affect_float_single_st(a, b)
    real(C_FLOAT), intent(out) :: a
    type(single_st), intent(in) :: b

    call cpp_affect_float_single_st(a, b)
  end subroutine affect_float_single_st


  elemental subroutine affect_long_long_double_st(a, b)
    integer(C_LONG_LONG), intent(out) :: a
    type(double_st), intent(in) :: b

    call cpp_affect_long_long_double_st(a, b)
  end subroutine affect_long_long_double_st

  elemental subroutine affect_long_long_single_st(a, b)
    integer(C_LONG_LONG), intent(out) :: a
    type(single_st), intent(in) :: b

    call cpp_affect_long_long_single_st(a, b)
  end subroutine affect_long_long_single_st


!CONTAINS_OP(affect, long, double_st)
!CONTAINS_OP(affect, long, single_st)

  elemental subroutine affect_int_double_st(a, b)
    integer(C_INT), intent(out) :: a
    type(double_st), intent(in) :: b

    call cpp_affect_int_double_st(a, b)
  end subroutine affect_int_double_st

  elemental subroutine affect_int_single_st(a, b)
    integer(C_INT), intent(out) :: a
    type(single_st), intent(in) :: b

    call cpp_affect_int_single_st(a, b)
  end subroutine affect_int_single_st


  elemental subroutine affect_short_double_st(a, b)
    integer(C_SHORT), intent(out) :: a
    type(double_st), intent(in) :: b

    call cpp_affect_short_double_st(a, b)
  end subroutine affect_short_double_st

  elemental subroutine affect_short_single_st(a, b)
    integer(C_SHORT), intent(out) :: a
    type(single_st), intent(in) :: b

    call cpp_affect_short_single_st(a, b)
  end subroutine affect_short_single_st




end module cadna_affect

      program ex5
      implicit double precision (a-h,o-z)
      parameter (eps = 1.0d-12, nmax = 100)
      !
      print *,'Computation of a root of a polynomial by Newton method'
      print *,'without CADNA:'
      y = 0.5d0
      do i = 1,nmax
        x = y
        y = x - (1.47d0*x**3 + 1.19d0*x**2 - 1.83d0*x + 0.45d0)&
     &         /(4.41d0*x**2 + 2.38d0*x - 1.83d0)
        if (abs(x-y).le.eps) goto 1
      enddo
!
 1    continue
!
      write(*,*)'x(',i-1,') = ',x
      write(*,*)'x(',i,') = ',y
!
      end

#!/bin/bash
echo "configure.."
tar --strip-components=1 -xf  cadna_c_half-3.1.12.tar.gz
./configure CXX=g++ --prefix=`pwd` --enable-half-emulation --disable-dependency-tracking
echo "make install.."
make install

#!/bin/bash
echo "configure..."
tar --strip-components=1 -xf  cadna_c_half-3.1.12.tar.gz
flag1=--enable-half-emulation
flag2=--disable-dependency-tracking

if [ $# -eq 2 ]
then
  echo CC=$1 CXX=$2 --prefix=`pwd` $flag1 $flag2
  ./configure CC=$1 CXX=$2 --prefix=`pwd` $flag1 $flag2
else
  echo CXX=g++ --prefix=`pwd` $flag1 $flag2
  ./configure CXX=g++ --prefix=`pwd` $flag1 $flag2
fi

echo "make install..."
make install

#!/bin/bash

# colors
RED="\033[0;31m"
GREEN="\033[0;32m"
NOCOLOR="\033[0m"

#
echo "Running some tests"

# iterate over all _cad files
for file in $(ls *_cad)
do
    # if the .txt file is missing, we do not test
    if [ ! -f $file.txt ]; then
        continue
    fi
    
    printf -- "- Checking $file "

    # Compare $file.txt to the output of $file 
    # (remove the line with "CADNA... software")
    # (and used $file.input as input if the file exists)
    if [ -f $file.input ]; then
        diff -q $file.txt <(mpirun -np 4 ./$file < $file.input 2>/dev/null | grep "\-\->") &>/dev/null
    else
        diff -q $file.txt <(mpirun -np 4 ./$file 2>/dev/null | grep "\-\->") &>/dev/null
    fi
    # display ✓ or ✗
    if [ $? -eq 0 ]; then
        echo -e "${GREEN}✓${NOCOLOR}"
    else
        echo -e "${RED}✗${NOCOLOR}"
        echo "-- Comparison (expected result vs current result):"
        # also display the comparison between the two results
        if [ -f $file.input ]; then
            diff -y $file.txt <(mpirun -np 4 ./$file < $file.input)
        else
            echo "$file"
            diff -y $file.txt <(mpirun -np 4 ./$file)
        fi
        echo ""
    fi
done
